using System;
using System.Collections;
using System.Windows.Forms;
using Syncfusion.Windows.Forms.Diagram.Controls;
using Syncfusion.Windows.Forms.Diagram;
using Symcon.Utils.MessageLogger;
using Symcon.LightRidge.BusinessObjects;
using Symcon.Utils.MessageDispatcher;
using Symcon.BusinessObjects;
using Symcon.Lightridge.LRRUI.Controls;
using System.Collections.Generic;
using System.Drawing;
using Symcon.Lightridge.LRRUI;
using System.ComponentModel;
//Copyright (C) 2004-2005 Symcom Global Technologies.  All rights reserved.


namespace Symcon.LightRidge.PEAdvisor
{
	/// <summary>
	/// 
	/// </summary>
	public class GraphicsManagers
	{
		public GraphicsManagers()
		{
			_savedViews				=	new Hashtable();
			_openedViews			=	new Hashtable();
			_lrrModes				=	new LRRModes();
			_hashGraphicsManagerList=	new Hashtable();
			_modifiedEntries		=	new Hashtable();
			LRRModel.ProjectModes.ModesChanged+=new EventHandler(ProjectModes_ModesChanged);
			_app = AppDomain.CurrentDomain.GetData("AppObject")	as LRRApp;
            //_app.RunControllerObj.SuspendEvents();
			_app.ReconnectCompleted+=new EventHandler(_app_ReconnectCompleted);
		}

		#region Public Properties
		
		public GraphicsManager ActiveManager
		{
			get{return _activeGraphicsManager; }
			set{_activeGraphicsManager = value;}
		}

		public Hashtable SavedViews
		{
			get{return _savedViews;}
		}

		public Hashtable OpenedViews
		{
			get{return _openedViews;}
		}

		public LRRModes SelectedModes
		{
			get{return _lrrModes;}
		}

		public object GridView
		{
			get { return _gridView;}
			set
			{
				_gridView = value;
			}
		}

        private Hashtable _gmIDFileIDMap = new Hashtable();

        public Hashtable HashGmIDFileIDMap
        {
            get { return _gmIDFileIDMap; }
            set { _gmIDFileIDMap = value; }
        }

        public Hashtable HashGraphicsManagerList
        {
            get { return _hashGraphicsManagerList; }
        }


		#endregion

		#region Fields
        private Syncfusion.Windows.Forms.Diagram.Controls.Diagram diagram1;
		private			GraphicsManager					_activeGraphicsManager;
		private			Hashtable						_savedViews;
		private			Hashtable						_openedViews;
		private			LRRModes						_lrrModes;
		private			Hashtable						_hashGraphicsManagerList;
        //public event Syncfusion.Windows.Forms.Diagram.NodeCollection CanvasSelectionChanged;
        //public event NodeEventHandler CanvasSelectionChanged;
        public event CollectionExEventHandler CanvasSelectionChanged; 
        //public event NodeEventHandler ChildrenChangeComplete;
        public event CollectionExEventHandler ChildrenChangeComplete;
        //public event CollectionEEventHandler ChildrenChangeComplete;
        //public event NodeMouseEventHandler ChildrenChangeComplete;
        
        //public event Syncfusion.Windows.Forms.Diagram.NodeCollection ChildrenChangeComplete;
        //public event Syncfusion.Windows.Forms.Diagram.CollectionExEventHandler CanvasSelectionChanged;
        //public event Syncfusion.Windows.Forms.Diagram.NodeSelectedEventHandler ChildrenChangeComplete;
		public	event	EventHandler					MapProperties;
		public	event	EventHandler					ShowAttributeDetails;
        public  event   EventHandler                    SelectedAttributeDetails;
		public	event	EventHandler					SetLabelsVisibility;
		public	event	EventHandler					SelectDisplayUOM;
		public	event	EventHandler					ViewTrend;
		public	event	EventHandler			       NodeDoubleClick;
        //public event NodeMouseEventHandler NodeDoubleClick;
		public	event	EventHandler					OverrideValueClick;
		public	event	Symcon.LightRidge.BusinessObjects.PropertyChanged	LabelPropertyValueChanged;
		public	event	NodeMouseEventHandler			LabelDoubleClick;
		public	event	NodeMouseEventHandler			MouseEnter;
		public	event	EventHandler					ChangeGridDimensions;
        public  event   EventHandler                    RemoveRow;
        public  event   EventHandler                    RemoveColumn;
        public  event   EventHandler                    ResetGridCell;
		 public  event   EventHandler                    ResetNode;
		public	event	EventHandler					SetCustomFormat;
        public  event   EventHandler                    SetCustomFormatGridCell;
        public  event   MouseEventHandler               MouseUp;

		private LRRApp _app;
		private object _gridView;
		private Hashtable _modifiedEntries;
		private List<bool> _defaultVisibilityList = new List<bool>();

		#endregion

		#region Methods
		public void CreateGraphicsManager()
		{
			GraphicsManager gm = new GraphicsManager();
			gm.CanvasObj.Model.BackgroundStyle.Color=	_app.LRRUIManagerObj.ColorSchemeObj.Canvas.BackgroundColor;
			//gm.CanvasObj.Model.BackgroundStyle.Color		=	_app.LRRUIManagerObj.ColorSchemeObj.Canvas.BackgroundStyleColor;
			//gm.CanvasObj.Model.BackgroundStyle.GradientStartColor = _app.LRRUIManagerObj.ColorSchemeObj.Canvas.BackgroundStyleGradientStartColor;
			gm.CanvasObj.View.HandleAnchorColor		=	_app.LRRUIManagerObj.ColorSchemeObj.Canvas.HandleAnchorColor;
			gm.CanvasObj.Model.ShadowStyle.Color	=	_app.LRRUIManagerObj.ColorSchemeObj.Canvas.ShadowColor;
			gm.CanvasObj.View.HandleColor			=	_app.LRRUIManagerObj.ColorSchemeObj.Canvas.HandleColor;
			//gm.CanvasObj.View.RulerFillColor		=	_app.LRRUIManagerObj.ColorSchemeObj.Canvas.RulerFillColor;
			//gm.CanvasObj.View.RulerLineColor		=	_app.LRRUIManagerObj.ColorSchemeObj.Canvas.RulerLineColor;
			gm.CanvasObj.View.HandleDisabledColor	=	_app.LRRUIManagerObj.ColorSchemeObj.Canvas.DisableColor;
			gm.CanvasObj.View.Grid.Color			=	_app.LRRUIManagerObj.ColorSchemeObj.Canvas.GridColor;	
			gm.CanvasObj.Model.LineStyle.LineColor	=	_app.LRRUIManagerObj.ColorSchemeObj.Canvas.LineColor;	
			_hashGraphicsManagerList.Add(gm.ID,gm);

            
			SetActiveGraphicsManager(gm.ID);
			WireGMEvents(gm);
		}

        public void CreateGraphicsManager(string fileID)
        {
            GraphicsManager gm = new GraphicsManager(fileID);
            _hashGraphicsManagerList.Add(gm.ID, gm);
            SetActiveGraphicsManager(gm.ID);
            WireGMEvents(gm);
        }

		public void SetActiveGraphicsManager(string ID)
		{
			if(_hashGraphicsManagerList.Contains(ID))
				this.ActiveManager = _hashGraphicsManagerList[ID] as GraphicsManager;
			else
				this.ActiveManager = null;
		}


		private void WireGMEvents(GraphicsManager gm)
		{
			//gm.CanvasSelectionChanged+=new Syncfusion.Windows.Forms.Diagram.NodeCollectionEventHandler(gm_CanvasSelectionChanged);
            //gm.CanvasSelectionChanged += new Syncfusion.Windows.Forms.Diagram.NodeCollection(gm_CanvasSelectionChanged);
			//gm.ChildrenChangeComplete+=new NodeCollectionEventHandler(gm_ChildrenChangeComplete);
            //gm.ChildrenChangeComplete += new CollectionExEventHandler(gm_ChildrenChangeComplete);
            this.diagram1.Model.EventSink.NodeCollectionChanged += new CollectionExEventHandler(diagram1_ChildrenChangeComplete);
            //this.diagram1.Model.EventSink.NodeCollectionChanged += new CollectionExEventHandler(diagram1_ChildrenChangeComplete);
            //gm.ChildrenChangeComplete += new Syncfusion.Windows.Forms.Diagram.NodeMouseEventHandler(gm_ChildrenChangeComplete);
			gm.MapProperties+=new EventHandler(gm_MapProperties);
			gm.ShowAttributeDetails+=new EventHandler(gm_ShowAttributeDetails);
            gm.SelectedAttributeDetails += new EventHandler(gm_SelectedAttributeDetails);
			gm.SetLabelsVisibility+=new EventHandler(gm_SetLabelsVisibility);
			gm.SelectDisplayUOM+=new EventHandler(gm_SelectDisplayUOM);
			gm.ViewTrend+=new EventHandler(gm_ViewTrend);
			gm.NodeDoubleClick+=new EventHandler(gm_NodeDoubleClick);
			gm.OverRideValueClick+=new EventHandler(gm_OverRideValueClick);
			gm.LabelPropertyValueChanged+=new Symcon.LightRidge.BusinessObjects.PropertyChanged(gm_LabelPropertyValueChanged);
			//gm.LabelDoubleClick+=new NodeMouseEventHandler(gm_LabelDoubleClick);
			//gm.MouseEnter+=new NodeMouseEventHandler(gm_MouseEnter);
			gm.ChangeGridDimensions+=new EventHandler(gm_ChangeGridDimensions);
            gm.RemoveRow += new EventHandler(gm_RemoveRow);
            gm.RemoveColumn += new EventHandler(gm_RemoveColumn);
			gm.SetCustomFormat+=new EventHandler(gm_SetCustomFormat);
            gm.SetCustomFormatGridCell += new EventHandler(gm_SetCustomFormatGridCell);
            gm.MouseUp += new MouseEventHandler(gm_MouseUp);
          
            gm.ResetGridCell += new EventHandler(gm_ResetGridCell);
			gm.ResetNode += new EventHandler(gm_ResetNode);
		}

        void gm_RemoveColumn(object sender, EventArgs e)
        {
            if (RemoveColumn != null)
            {
                RemoveColumn(sender, e);
            }
        }

        void gm_RemoveRow(object sender, EventArgs e)
        {
            if (RemoveRow != null)
            {
                RemoveRow(sender, e);
            }
        }

        void gm_ResetGridCell(object sender, EventArgs e)
        {
            if (ResetGridCell != null)
            {
                ResetGridCell(sender, e);   
            }
        }

		void gm_ResetNode(object sender, EventArgs e)
        {
            if (ResetNode != null)
            {
                ResetNode(sender, e);   
            }
        }
        void gm_MouseUp(object sender, MouseEventArgs e)
        {
            if (MouseUp != null)
            {
                MouseUp(sender, e);
            }
        }

		private void UnWireGMEvents(GraphicsManager gm)
		{
			gm.TerminateCanvas();
			//gm.CanvasSelectionChanged-=new Syncfusion.Windows.Forms.Diagram.NodeCollection(gm_CanvasSelectionChanged);
           
			//gm.ChildrenChangeComplete-=new NodeCollectionEventHandler(gm_ChildrenChangeComplete);
            //gm.ChildrenChangeComplete-= new CollectionExEventHandler(gm_ChildrenChangeComplete);
            this.diagram1.Model.EventSink.NodeCollectionChanged-= new CollectionExEventHandler(diagram1_ChildrenChangeComplete);
			gm.MapProperties-=new EventHandler(gm_MapProperties);
			gm.ShowAttributeDetails-=new EventHandler(gm_ShowAttributeDetails);
            gm.SelectedAttributeDetails -= new EventHandler(gm_SelectedAttributeDetails);
			gm.SetLabelsVisibility-=new EventHandler(gm_SetLabelsVisibility);
			gm.SelectDisplayUOM-=new EventHandler(gm_SelectDisplayUOM);
			gm.NodeDoubleClick-=new EventHandler(gm_NodeDoubleClick);
			gm.OverRideValueClick-=new EventHandler(gm_OverRideValueClick);
			gm.LabelPropertyValueChanged-=new Symcon.LightRidge.BusinessObjects.PropertyChanged(gm_LabelPropertyValueChanged);
			//gm.LabelDoubleClick-=new NodeMouseEventHandler(gm_LabelDoubleClick);
			//gm.MouseEnter-=new NodeMouseEventHandler(gm_MouseEnter);
			gm.ChangeGridDimensions-=new EventHandler(gm_ChangeGridDimensions);
            gm.RemoveRow -= new EventHandler(gm_RemoveRow);
            gm.RemoveColumn -= new EventHandler(gm_RemoveColumn);
			gm.SetCustomFormat-=new EventHandler(gm_SetCustomFormat);
            gm.SetCustomFormatGridCell -= new EventHandler(gm_SetCustomFormatGridCell);
            gm.MouseUp -= new MouseEventHandler(gm_MouseUp);
            gm.ResetGridCell -= new EventHandler(gm_ResetGridCell);
			  gm.ResetNode -= new EventHandler(gm_ResetNode);
		}


		public void Dispose()
		{
            _savedViews = null;
            _openedViews = null;
            _lrrModes = null;
            _hashGraphicsManagerList = null;
            _modifiedEntries = null;
			
			LRRModel.ProjectModes.ModesChanged-=new EventHandler(ProjectModes_ModesChanged);
			_app.RunControllerObj.RunStarted-=new RunStartedDel(RunControllerObj_RunStarted);
			_app.RunControllerObj.RunCompleted-=new EventHandler(RunControllerObj_RunCompleted);
			_app.ReconnectCompleted-=new EventHandler(_app_ReconnectCompleted);
            _app.RunControllerObj.RunCycleCompleted -= new EventHandler(RunControllerObj_RunCycleCompleted);
			
		}

		public void RemoveGraphicsManager(string ID)
		{
			if(_hashGraphicsManagerList.Contains(ID))
			{
				UnWireGMEvents(_hashGraphicsManagerList[ID] as GraphicsManager);

				GraphicsManager gm =  _hashGraphicsManagerList[ID] as GraphicsManager;
				

				_hashGraphicsManagerList.Remove(ID);
                gm.Dispose();
                gm = null;
			}
			if(_hashGraphicsManagerList.Count == 0)
			{
				this.ActiveManager = null;
			}
		}


		public void HideColumns()
		{
			Symcon.LightRidge.PEAdvisor.IOScreen.IGridFactory igridFactory = this.GridView as Symcon.LightRidge.PEAdvisor.IOScreen.IGridFactory;
			if(igridFactory != null)
				igridFactory.HideModes();
			else
			{
				Symcon.LightRidge.PEAdvisor.GroupProperties.IGroupGridFactory igrpGridFactory = this.GridView as Symcon.LightRidge.PEAdvisor.GroupProperties.IGroupGridFactory;
				if(igrpGridFactory != null)
					igrpGridFactory.HideModes();
			}
		}

		public void ApplyModes()
		{
			this.SelectedModes.Clear();

			foreach(LRRMode lrmd in LRRModel.ProjectModes)
			{
				if(lrmd.ViewSelection && lrmd.ModeTypeID != null && lrmd.ModeTypeID.Trim() != "" )
				{
					if(!(this.SelectedModes.Contains(lrmd)))
						this.SelectedModes.Add(lrmd);

					else if(lrmd != null && lrmd.ModeTypeID.Trim() == "" && this.SelectedModes.Contains(lrmd))
					{
						this.SelectedModes.Remove(lrmd);
					}

				}
			}
			foreach(DictionaryEntry dEntry in _hashGraphicsManagerList)
			{
				if(dEntry.Value != null)
				{
					GraphicsManager gm = dEntry.Value as GraphicsManager;
					gm.BindSymbols(this.SelectedModes,GraphicsManagers.PropertiesMappingMode.NONE,GraphicsManagers.UserMode.NONE);
				}
			}
			if(this.ActiveManager != null)
			{
				//this.ActiveManager.CanvasObj.Model.UpdateViews();
                
			}
			HideColumns();
		}

        /// <summary>
        /// Maps the properties to the Grid Cell based on selection
        /// </summary>
        public void OnGridCellMapping()
        {
            Canvas activeCanvas = this.ActiveManager.CanvasObj;
            

            //Cannot TypeCast the SelectionList(NodeCollection) to Node
            //Node nd = diagram1.Controller.SelectionList[1] as Node;

            DynamicGridcontainer dg = activeCanvas.Controller.SelectionList as DynamicGridcontainer;
            
            //DynamicGridcontainer dg = ((PathNode)activeCanvas.Controller.SelectionList).Labels[0] as DynamicGridcontainer;
            GridCell gc = dg.SelectedCell;
            ISymbolPropertiesMapping isymbolMapping = null;
            if (gc.PlantItem.SiteItemType == Globals.Enums.PlantItemType.AGGREGATE)
            {
                isymbolMapping = new AggregatesMapping();
            }
            else //if(dg.SelectedCell.PlantItem.SiteItemType == Globals.Enums.PlantItemType.SIMPLE)
            {
                isymbolMapping = new SiteComponentMapping();
            }
            GridCellMappingDialog gcellMappingDialog = new GridCellMappingDialog(isymbolMapping, dg.PT, dg.SelectedCell, true);
            DialogResult dresult = gcellMappingDialog.ShowDialog(_app.MainFrame);
            if (dresult == DialogResult.OK)
            {
                LRRMode mode = gcellMappingDialog.SelectedMode;
                List<IPropertyValue> alstValues = gcellMappingDialog.SelectedValues;
                IProperty selectedItem = gcellMappingDialog.SelectedItem;
                foreach (IPropertyValue iPropvalue in alstValues)
                {
                    if (mode != null)
                    {
                        if (mode.ModeId == iPropvalue.GetModeID())
                        {
                            string sPropertyID = iPropvalue.GetPropertyID();
                            if (sPropertyID != gc.PropertyID || mode.ModeId != gc.ModeID)
                            {
                                //Remove previous binding.
                                this.ActiveManager.LRRBindingManagerObj.RemoveBinding(gc.Tag, "PropertyValue", gc, true);
                                this.ActiveManager.LRRBindingManagerObj.RemoveBinding(gc.Tag, "ErrCode", gc, true);
                                gc.IsBinded = false;
                                gc.Tag = null;
                                gc.ModeID = null;
                                gc.Type = null;
                                gc.PropertyID = null;
                                gc.BackgroundStyle.Color = Color.Transparent;
                                //gc.BorderStyle.BorderColor = dg.GridBorderColor;
                                //gc.BorderStyle.BorderWidth = dg.GridBorderWidth;
                                gc.Text = "";
                                gc.Description = "";
                                gc.FontStyle.Style = System.Drawing.FontStyle.Regular;
                                gc.GridCellDoubleClick -= new NodeMouseEventHandler(GraphicsUtilities.OnUOMChangeForGridCell);
                                //gc.GridCellDoubleClick -= new NodeMouseEventHandler(GraphicsUtilities.gCell_GridCellDoubleClick);
                                
                                for (int i = dg.PT.Properties.Count; i > 0; i--)
                                {
                                    PropertySpec ps = dg.PT.Properties[i - 1] as PropertySpec;
                                    if (ps.Category == "Bound Properties")
                                    {
                                        dg.PT.Properties.Remove(ps);
                                    }
                                }

                                //Add New Binding
                                gc.Tag = iPropvalue;
                                gc.ModeID = iPropvalue.GetModeID();
                                gc.Type = iPropvalue.GetObjectType();

                                this.ActiveManager.LRRBindingManagerObj.AddBinding(iPropvalue, "PropertyValue", gc, "Text");
                                if (gc.PlantItem.SiteItemType != Globals.Enums.PlantItemType.AGGREGATE)
                                {
                                    this.ActiveManager.LRRBindingManagerObj.AddBinding(iPropvalue, "ErrCode", gc, "LabelColorCode");
                                }

                                if (gcellMappingDialog.UIUOMID != null)
                                {
                                    gc.Text = iPropvalue.GetPropertyValueForUOM(iPropvalue.GetUOMID(), gcellMappingDialog.UIUOMID, iPropvalue.GetPropertyValue());
                                    gc.Description = selectedItem.GetName() + "(" + mode.ModeName + ")";
                                    gc.UIUOMID = gcellMappingDialog.UIUOMID;
                                    gc.UOMTypeID = gcellMappingDialog.UOMTypeID;

                                    gc.GridCellDoubleClick += new NodeMouseEventHandler(GraphicsUtilities.OnUOMChangeForGridCell);
                                    //gc.GridCellDoubleClick += new NodeMouseEventHandler(GraphicsUtilities.gCell_GridCellDoubleClick);
                                    
                                 
                                    
                                    
                                }

                                dg.SelectedCell.IsBinded = true;
                                if (gc.Type.Name == "LRRSiteGroupPropertyQualifierValue")
                                {
                                    LRRSiteGroupPropertyQualifierValue currentPropval = iPropvalue as LRRSiteGroupPropertyQualifierValue;
                                    gc.ID = currentPropval.LookUpQualifierID;
                                    gc.PropertyID = currentPropval.GroupPropertyID;
                                }
                                else
                                {
                                    gc.PropertyID = selectedItem.GetID();
                                    dg.SelectedCell.ID = iPropvalue.GetID();
                                }
                                int propIndex = dg.PT.Properties.Add(new PropertySpec(selectedItem.GetName() + "(" + mode.ModeName + ")", typeof(String), "Bound Properties", selectedItem.GetName(), iPropvalue.GetPropertyValue(), "", typeof(String), iPropvalue.GetID()));
                                Attribute[] attrib = new Attribute[1];

                                BrowsableAttribute browsableAttrib;
                                browsableAttrib = new BrowsableAttribute(false);
                                attrib[0] = browsableAttrib;
                                dg.PT.Properties[propIndex].AttributesNew = attrib;


                                //Add Colour Binding
                                GraphicsUtilities.SetColor(dg.SelectedCell, iPropvalue);
                                // propertyEditor2.PropertyGrid.Update();
                                // propertyEditor2.PropertyGrid.Refresh();

                            }
                        }
                    }
                }
            }
        }

		/// <summary>
		/// Maps the properties to the symbol based on selection
		/// </summary>
		/// <param name="userMode">The Mode eg. Operator,Implementer</param>
		public void OnMapProperties(GraphicsManagers.UserMode userMode)
		{
			try
			{
				//Check if Modes are selected
				if(!CheckForSelectedModes())
				{
					return;
				}
				//Set active canvas
				Canvas activeCanvas	 = this.ActiveManager.CanvasObj;
				
				//Set the Symbol
				 Group smbl=activeCanvas.Controller.SelectionList.First as Group;
                //PathNode smbl = activeCanvas.Controller.SelectionList.First as PathNode;
                //Node smbl = activeCanvas.Controller.SelectionList.First as Node;
				ISymbolPropertiesMapping isymbolMapping;
				
				if(smbl	== null)
					return;
				//Set the interface based on symbol type
				if(smbl.GetType().Name == "Aggregates")
					isymbolMapping = new AggregatesMapping();
				else
					isymbolMapping = new SiteComponentMapping();

				if(smbl.GetPropertyContainerByName("PlantItem") != null )//&&	smbl.GetPropertyContainerByName("SiteItem").ToString() != "Select" )
				{
					Symcon.Lightridge.LRRUI.PropertyTable pt =	smbl.GetPropertyContainerByName("PT")	as Symcon.Lightridge.LRRUI.PropertyTable;
			
					GraphicsManagers.PropertiesMappingMode propMappingMode = GraphicsManagers.PropertiesMappingMode.NORMAL;
					foreach(Symcon.Lightridge.LRRUI.PropertySpec ps in pt.Properties)
					{
						if(ps.Category == "Bound Properties")
						{	
							propMappingMode = GraphicsManagers.PropertiesMappingMode.REMAP;
                     if(propMappingMode == PropertiesMappingMode.REMAP)
							{
								SetLocalVisiblityOnRemap(smbl);
							}
							break;
						}
					}
					if (propMappingMode != PropertiesMappingMode.REMAP && _defaultVisibilityList.Count != 0)
					{
						for (int i = 0; i < _defaultVisibilityList.Count; i++)
						{
							_app.GetOptions().GraphicsLblsVisibility[i] =	_defaultVisibilityList[i];
						}
					}
					 PropertiesMap propMap = new PropertiesMap(isymbolMapping,pt,smbl);
					if(propMap.ShowDialog(_app.MainFrame) == DialogResult.OK)
					{
		                  if (propMap.ResetAlignment)
		                  {
		                      GraphicsUtilities.ResetLabels(smbl);
		                      smbl.Labels[0].BackgroundStyle.Color = Color.Transparent;
		                      propMappingMode = GraphicsManagers.PropertiesMappingMode.NORMAL;
		                  }
									
								for (int i = 0; i < _app.GetOptions().GraphicsLblsVisibility.Count; i++)
								{
									if (_defaultVisibilityList.Count > i)
									{
										_defaultVisibilityList[i] = _app.GetOptions().GraphicsLblsVisibility[i];

									}
									else
									{
										_defaultVisibilityList.Add(_app.GetOptions().GraphicsLblsVisibility[i]);

									}
								}
						//this.ActiveManager.UpdateLabels(smbl,this.SelectedModes,propMap.SelectedProperties,propMappingMode,userMode,propMap.SetEquipmentName);											
						this.ActiveManager.LabelControllerObj.BusinessObjectCollection[smbl.GetPropertyContainerByName("ID")] = smbl;

				
					}
				}
				else
				{
					LRRMessagBox.ShowMessage("SID_NODETAILS","SID_LABEL",MessageBoxButtons.OK,MessageBoxIcon.Information);     
				}
			}
			catch(Exception ex)
			{
				Logger.LogMessage(typeof(GraphicsManagers),"MapProperties :"+ex.Message  ,Logger.Level.Debug);
			}
		}


		public void SetLocalVisiblityOnRemap(Group targetSymbol)
		{
			LabelCollection localLabelCol = targetSymbol.Labels;
            
            
			List<bool> localVisiblity = new List<bool>();
			int index = 0;
			int visibleIndex = 0;

			for (int i = 0; i < _app.GetOptions().GraphicsLblsVisibility.Count; i++)
			{
				if (_defaultVisibilityList.Count > i)
				{
					_defaultVisibilityList[i] = _app.GetOptions().GraphicsLblsVisibility[i];

				}
				else
				{
					_defaultVisibilityList.Add(_app.GetOptions().GraphicsLblsVisibility[i]);

				}
			}
			for (int i = 0; i < localLabelCol.Count - 1; i++)
			{
				localVisiblity = _app.GetOptions().GraphicsLblsVisibility;
				LRRLabel lbl = localLabelCol[i] as LRRLabel;
				if (i == 0)
				{
					localVisiblity[0] = lbl.Visible;
					index = index + 3;
					visibleIndex++;
				}
				if (i == index && lbl != null)
				{
					if (lbl.ParentID == "" && lbl.Text == "" && lbl.IsParent)
					{
						index = index + 2;
					}
					else if (lbl.ParentID == "" && lbl.Text == "" && lbl.IsUOM)
					{
						index = index + 5;
					}

					else if (lbl.IsParent)
					{
						localVisiblity[visibleIndex] = lbl.Visible;
						visibleIndex++;
						index = index + 2;
					}
					else if (lbl.IsUOM)
					{
						localVisiblity[visibleIndex] = lbl.Visible;
						visibleIndex++;
						index = index + 5;
					}
				}
			}
		}	

		/// <summary>
		/// Checks if Modes are Selected
		/// </summary>
		/// <returns>true is ModeSelection count is > 0</returns>
		private bool CheckForSelectedModes()
		{
			if(this.SelectedModes.Count == 0)
			{
				LRRMessagBox.ShowMessage("SID_SELECT_MODE","SID_LABEL",MessageBoxButtons.OK,MessageBoxIcon.Error);  
				_app.LRRUIManagerObj.ShowModesDialog();
				return false;
			}
			else
				return true;

		}


		public void ChangeUOMSetDefinationForSelectedSymbols(string measSysID)
		{
			Canvas activeCanvas = this.ActiveManager.CanvasObj;
			if(activeCanvas != null)
			{
				if(activeCanvas.Controller.SelectionList.Count > 0)
				{
					foreach(PathNode smbl in  activeCanvas.Controller.SelectionList)
					{
						if(smbl.GetType() == typeof(DynamicGridcontainer))
						{
                            foreach (Syncfusion.Windows.Forms.Diagram.Label lbl in smbl.Labels)
							{
								if(smbl.Labels[0] == lbl)
									continue;
								GridCell gridCell = lbl as GridCell;
								if(gridCell.IsBinded)
								{
									string newUomID = LRRModel.ChildModel.MeasSysDef.GetLocaleUOM(measSysID,gridCell.UOMTypeID);
									IPropertyValue lrrscpv = gridCell.Tag as IPropertyValue;
                                    gridCell.Text = GraphicsUtilities.ChangeUOM(lrrscpv.GetUOMID(), newUomID, lrrscpv.GetPropertyValue(), lrrscpv.GetDataType());
									Symcon.Lightridge.LRRUI.PropertyTable myPT = gridCell.PT;
									for(int	i= myPT.Properties.Count; i>0;i--)
									{
										Symcon.Lightridge.LRRUI.PropertySpec ps	=  myPT.Properties[i-1]	as Symcon.Lightridge.LRRUI.PropertySpec;
										if(ps.Category == "Bound Properties")
										{
											ps.DefaultValue	= gridCell.Text;
										}
									}
									string newUOMName =	LRRModel.ChildModel.GetUOMNameFromID(newUomID);
									gridCell.UIUOMID= newUomID;
								}
							}
						}
						else
						{
							foreach(LRRLabel lbl in smbl.Labels)
							{
								if(lbl.IsUOM)
								{
									if(lbl.Tag != null)
									{
										LRRUOMType uomTypeObj = lbl.Tag as LRRUOMType;
										if(uomTypeObj != null)
										{
											string newUomID = LRRModel.ChildModel.MeasSysDef.GetLocaleUOM(measSysID,uomTypeObj.UOMTypeID);
											GraphicsUtilities.OnUOMChanged(lbl,newUomID);
										}
									}
								}
							}
						}
					}
				}
			}
		}
        
        public void HookUpEvents()
        {
            _app.RunControllerObj.SuspendEvents();
            //_app.RunControllerObj.RunStarted -= new RunStartedDel(RunControllerObj_RunStarted);
            _app.RunControllerObj.RunStarted += new RunStartedDel(this.RunControllerObj_RunStarted);
            _app.RunControllerObj.RunCompleted += new EventHandler(this.RunControllerObj_RunCompleted);
            _app.RunControllerObj.RunStopped += new EventHandler(this.RunControllerObj_RunStopped);
            _app.RunControllerObj.RunCycleCompleted += new EventHandler(this.RunControllerObj_RunCycleCompleted);
            _app.RunControllerObj.ResumeEvents();
			
        }
        
		#endregion

		#region Events

        /*private void gm_CanvasSelectionChanged(object sender, Syncfusion.Windows.Forms.Diagram.NodeCollection evtArgs)
		{
			if(this.CanvasSelectionChanged != null)
			{
				//this.CanvasSelectionChanged(sender,evtArgs);
                this.CanvasSelectionChanged(evtArgs);
			}
		}*/

        /*private void gm_ChildrenChangeComplete(object sender, Syncfusion.Windows.Forms.Diagram.CollectionExEventArgs evtArgs)
		{
			if(this.ChildrenChangeComplete != null)
			{
				//this.ChildrenChangeComplete(sender,evtArgs);
                this.ChildrenChangeComplete(evtArgs);
                //this.ChildrenChangeComplete(sender, evtArgs);
               
			}
		}*/
        private void diagram1_ChildrenChangeComplete(CollectionExEventArgs evtArgs)
        {
            if (this.ChildrenChangeComplete != null)
            {
                this.ChildrenChangeComplete(evtArgs);
            }
        }

//		private void gm_MagnificationChanged(object sender, ViewMagnificationEventArgs evtArgs)
//		{
//			if(MagnificationChanged != null)
//			{
//				MagnificationChanged(sender,evtArgs);
//			}
//		}

		private void gm_NodeDoubleClick(object sender, EventArgs e)
		{
			if(NodeDoubleClick != null)
			{
				NodeDoubleClick(sender,e);
                //NodeDoubleClick(evtArgs);
			}
		}

		private void ProjectModes_ModesChanged(object sender, EventArgs e)
		{

			ApplyModes();
			HideColumns();
		}


		private void gm_OverRideValueClick(object sender, EventArgs e)
		{
			if(OverrideValueClick != null)
			{
				OverrideValueClick(sender,e);
			}

		}

		private void RunControllerObj_RunStarted(RunStartedEventArgs e)
		{
			foreach(DictionaryEntry dEntry in _hashGraphicsManagerList)
			{
				GraphicsManager gm = dEntry.Value as GraphicsManager;
				Canvas canvas = gm.CanvasObj as Canvas;
                //gm.IsRunning = true;
				if(!_modifiedEntries.ContainsKey(gm.ID))
					_modifiedEntries.Add(gm.ID, canvas.Model.Modified );
			}
		}

        private void RunControllerObj_RunCycleCompleted(object sender, EventArgs e)
        {
            foreach (DictionaryEntry dEntry in _hashGraphicsManagerList)
            {
                GraphicsManager gm = dEntry.Value as GraphicsManager;
                Canvas canvas = gm.CanvasObj as Canvas;
                //canvas.Model.UpdateViews();
               
            }
        }

		private void RunControllerObj_RunCompleted(object sender, EventArgs e)
		{
			foreach(DictionaryEntry dEntry in _hashGraphicsManagerList)
			{
				GraphicsManager gm = dEntry.Value as GraphicsManager;

				if(_modifiedEntries.ContainsKey(gm.ID))
				{
                    //gm.IsRunning = false;
					gm.CanvasObj.Model.Modified = (bool)_modifiedEntries[gm.ID] ;
				}
//				else
//				{
//					gm.CanvasObj.Model.Modified = false;
//				}
			}

			if(!isStopped)
				_modifiedEntries.Clear();
			isStopped = false;
		}


		#endregion

		#region ENUMS
		public enum PropertiesMappingMode
		{
			NORMAL,
			OPEN,
			REMAP,
            NONE
		}


		public enum State {UNMAPPED, MAPPED, MODESCHANGE, OPEN};


		public enum UserMode
		{
			OPERATOR,
			IMPLEMENTOR,
			NONE
		}

		public enum	FileDialogMode
		{
			Open,
			SaveAs
		}

		#endregion

//		private void gm_LabelTextChanged(object sender, string propertyName)
//		{
//			if(LabelTextChanged != null)
//			{
//				LabelTextChanged(sender,propertyName);
//			}
//
//		}

		private void gm_LabelPropertyValueChanged(object sender, string propertyName)
		{
			if(LabelPropertyValueChanged != null)
			{
				LabelPropertyValueChanged(sender,propertyName);
			}
		}

		private void RunControllerObj_RunStopped(object sender, EventArgs e)
		{
			isStopped = true;

		}

		private bool isStopped = false;

		/*private void gm_MouseEnter(object sender, NodeMouseEventArgs evtArgs)
		{
			if(MouseEnter != null)
			{
				//MouseEnter(sender,evtArgs);
                MouseEnter(evtArgs);
			}
		}*/

//		private void gm_MouseLeave(object sender, NodeMouseEventArgs evtArgs)
//		{
//			if(MouseLeave != null)
//			{
//				MouseLeave(sender,evtArgs);
//			}
//		}

		private void gm_MapProperties(object sender, EventArgs e)
		{
			if(MapProperties != null)
			{
				MapProperties(sender,e);
			}
		}

		private void gm_ShowAttributeDetails(object sender, EventArgs e)
		{
			if(ShowAttributeDetails != null)
			{
				ShowAttributeDetails(sender,e);
			}
		}

        private void gm_SelectedAttributeDetails(object sender, EventArgs e)
        {
            if (SelectedAttributeDetails != null)
            {
                SelectedAttributeDetails(sender, e);
            }
        }

		private void gm_SelectDisplayUOM(object sender, EventArgs e)
		{
			if(SelectDisplayUOM != null)
			{
				SelectDisplayUOM(sender,e);
			}
		}

		/*private void gm_LabelDoubleClick(object sender, NodeMouseEventArgs evtArgs)
		{
			if(LabelDoubleClick != null)
			{
				//LabelDoubleClick(sender,evtArgs);
                LabelDoubleClick(evtArgs);
			}
		}*/

		private void gm_ViewTrend(object sender, EventArgs e)
		{
			if(ViewTrend != null)
			{
				ViewTrend(sender,e);
			}
		}

		private void _app_ReconnectCompleted(object sender, EventArgs e)
		{
			foreach(DictionaryEntry dEntry in _hashGraphicsManagerList)
			{
				if(dEntry.Value != null)
				{
					GraphicsManager gm = dEntry.Value as GraphicsManager;
					gm.BindSymbols(this.SelectedModes,GraphicsManagers.PropertiesMappingMode.REMAP,GraphicsManagers.UserMode.NONE);
				}
			}
			if(this.ActiveManager != null)
			{
				//this.ActiveManager.CanvasObj.Model.UpdateViews();
			}
		}

		private void gm_SetLabelsVisibility(object sender, EventArgs e)
		{
			if(SetLabelsVisibility != null)
			{
				SetLabelsVisibility(sender,e);
			}

		}

		private void gm_ChangeGridDimensions(object sender, EventArgs e)
		{
			if(ChangeGridDimensions != null)
			{
				ChangeGridDimensions(sender,e);
			}
		}

		private void gm_SetCustomFormat(object sender, EventArgs e)
		{
			if(SetCustomFormat!= null)
			{
				SetCustomFormat(sender,e);
			}
		}

        void gm_SetCustomFormatGridCell(object sender, EventArgs e)
        {
            if (SetCustomFormatGridCell != null)
            {
                SetCustomFormatGridCell(sender, e);
            }
        }

		public void SetCustomFormatCalled()
		{
			try
			{
				//Set active canvas
				Canvas activeCanvas	 = this.ActiveManager.CanvasObj;
				
				//Set the Symbol
				Group smbl	= activeCanvas.Controller.SelectionList.First as Group;
				ISymbolPropertiesMapping isymbolMapping;
				
				if(smbl	== null)
					return;
				//Set the interface based on symbol type
				if(smbl.GetType().Name == "Aggregates")
					isymbolMapping = new AggregatesMapping();
				else
					isymbolMapping = new SiteComponentMapping();

				if(smbl.GetPropertyContainerByName("PlantItem") != null )
				{
					string siteItemID = GraphicsUtilities.GetSiteItemIdForSymbol(smbl);
					CustomCollection customCollection = isymbolMapping.GetDataSource(siteItemID);
					ConditionalFormattingDialog setFormatDialog = new ConditionalFormattingDialog(isymbolMapping,customCollection);
					if(setFormatDialog.ShowDialog(_app.MainFrame) == DialogResult.OK)
                    {
                        if (setFormatDialog.SelectedPropertyValue != null && setFormatDialog.IsSymbolSelected)
                        {
                            string oldID = smbl.GetPropertyContainerByName("CustomFormatID") as string;
                            if (oldID != null && oldID.Trim() != "")
                            {
                                IPropertyValue lrrscpv;
                                if (smbl.GetType() == typeof(Aggregates))
                                {
                                    lrrscpv = LRRModel.AggregatePropertyValuesObj.FindAggregatePropertyValueByID(oldID);
                                }
                                else
                                {
                                    lrrscpv = LRRModel.PropertyValuesObj.FindBySiteComponentPropID(oldID);
                                }

                                this.ActiveManager.LRRBindingManagerObj.RemoveBinding(lrrscpv, "PropertyValue", smbl);
 
                            }
                            // scp added by ashwin for custom formatting

                            string scp = setFormatDialog.SelectedPropertyValue.GetPropertyID();
                            //smbl.SetPropertyValue("SCP", scp);
                            
                            string mode = setFormatDialog.SelectedPropertyValue.GetModeID();
                            //smbl.SetPropertyValue("ModeID", mode);

                            //smbl.SetPropertyValue("CustomFormatID", setFormatDialog.SelectedPropertyValue.GetID());
                            //smbl.BackgroundStyle.Color = setFormatDialog.SelectedPropertyValue.GetGraphicsBackColor();
                            smbl.LineStyle.LineColor = setFormatDialog.SelectedPropertyValue.GetForeColor();
                            this.ActiveManager.LRRBindingManagerObj.AddBinding(setFormatDialog.SelectedPropertyValue, "PropertyValue", smbl, "ID");
                          //  this._activeGraphicsManager.LRRBindingManagerObj.AddBinding(setFormatDialog.SelectedPropertyValue, "GraphicsBackColor", fs, "Color", true);
                         //   this._activeGraphicsManager.LRRBindingManagerObj.AddBinding(setFormatDialog.SelectedPropertyValue, "ForeColor", fs, "LineColor", true);

                        }
                      //  smbl.GetPropertyContainerByName("CustomFormatID");
					}
				}
				else
				{
					LRRMessagBox.ShowMessage("SID_NODETAILS","SID_LABEL",MessageBoxButtons.OK,MessageBoxIcon.Information);     
				}
			}
			catch(Exception ex)
			{
				Logger.LogMessage(typeof(GraphicsManagers),"MapProperties :"+ex.Message  ,Logger.Level.Debug);
			}
		}

        public void SetCustomFormatGridCellCalled()
        {
            try
            {
                //Set active canvas
                Canvas activeCanvas = this.ActiveManager.CanvasObj;

                //Set the Symbol
                Symbol smbl = activeCanvas.Controller.SelectionList.First as Symbol;
                ISymbolPropertiesMapping isymbolMapping;

                if (smbl == null)
                    return;
                //Set the interface based on symbol type
                if (smbl.GetType().Name == "Aggregates")
                    isymbolMapping = new AggregatesMapping();
                else
                    isymbolMapping = new SiteComponentMapping();

                //SymbolLabel slbl = (smbl as DynamicGridcontainer).SelectedCell as SymbolLabel;
                
                
                
                /*if (slbl.GetPropertyValue("PlantItem") != null)
                {
                    string siteItemID = (slbl as GridCell).PlantItem.ID;
                    CustomCollection customCollection = isymbolMapping.GetDataSource(siteItemID);
                    ConditionalFormattingDialog setFormatDialog = new ConditionalFormattingDialog(isymbolMapping, customCollection);
                    if (setFormatDialog.ShowDialog(_app.MainFrame) == DialogResult.OK)
                    {
                        if (setFormatDialog.SelectedPropertyValue != null && setFormatDialog.IsSymbolSelected)
                        {
                            string oldID = slbl.GetPropertyValue("CustomFormatID") as string;
                            if (oldID != null && oldID.Trim() != "")
                            {
                                IPropertyValue lrrscpv;
                                if (smbl.GetType() == typeof(Aggregates))
                                {
                                    lrrscpv = LRRModel.AggregatePropertyValuesObj.FindAggregatePropertyValueByID(oldID);
                                }
                                else
                                {
                                    lrrscpv = LRRModel.PropertyValuesObj.FindBySiteComponentPropID(oldID);
                                }

                                this.ActiveManager.LRRBindingManagerObj.RemoveBinding(lrrscpv, "PropertyValue", smbl);

                            }

                           // smbl.SetPropertyValue("CustomFormatID", setFormatDialog.SelectedPropertyValue.GetID());
                            //smbl.BackgroundStyle.Color = setFormatDialog.SelectedPropertyValue.GetGraphicsBackColor();
                            smbl.LineStyle.LineColor = setFormatDialog.SelectedPropertyValue.GetForeColor();
                            this.ActiveManager.LRRBindingManagerObj.AddBinding(setFormatDialog.SelectedPropertyValue, "PropertyValue", smbl, "ID");
                            //  this._activeGraphicsManager.LRRBindingManagerObj.AddBinding(setFormatDialog.SelectedPropertyValue, "GraphicsBackColor", fs, "Color", true);
                            //   this._activeGraphicsManager.LRRBindingManagerObj.AddBinding(setFormatDialog.SelectedPropertyValue, "ForeColor", fs, "LineColor", true);

                        }
                        //  smbl.GetPropertyContainerByName("CustomFormatID");
                    }
                }*/
                //else
                //{
                    //LRRMessagBox.ShowMessage("SID_NODETAILS", "SID_LABEL", MessageBoxButtons.OK, MessageBoxIcon.Information);
               // }
            }
            catch (Exception ex)
            {
                Logger.LogMessage(typeof(GraphicsManagers), "MapProperties :" + ex.Message, Logger.Level.Debug);
            }
        }
	}
}