using System;
using System.Drawing;
using System.Drawing.Printing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Reflection;
using System.Diagnostics;
using System.IO;
using System.Resources;
using System.Runtime.Serialization.Formatters.Binary;
using System.Runtime.Serialization.Formatters;
using System.Data;
using System.Text.RegularExpressions;
using Symcon.Utils.MessageLogger;
using Symcon.Lightridge.LRRUI;
using Symcon.Lightridge.LRRUI.Controls;
using Symcon.LightRidge.BusinessObjects.TypeConverters;
using Symcon.LightRidge.PEAdvisor.DataStore;
using Symcon.LightRidge.BusinessObjects;
using Symcon.LightRidge.PEAdvisor.GridUtilities;
using Symcon.Utils.MessageDispatcher;
using Symcon.Utils.HeaderDispatcher;
using Syncfusion.Scripting;
using Syncfusion.Diagram.Base;
using Syncfusion.Windows.Forms.Diagram;
using Syncfusion.Windows.Forms.Diagram.Controls;
using Syncfusion.Windows.Forms.Tools;
using Syncfusion.Windows.Forms.Tools.XPMenus;
using System.Collections.Generic;
using Symcon.LightRidge.PEAdvisor.DashBoard;
using Symcon.LightRidge.PEAdvisor.ScreenManagement;


//Copyright	(C)	2004-2005 Symcom Global	Technologies.  All rights reserved.

namespace Symcon.LightRidge.PEAdvisor
{
	public class ImplementerScreen : System.Windows.Forms.Form, Symcon.BusinessObjects.ILRRUIContainer, Symcon.BusinessObjects.ILRRUISpecificContainer
	{
		[System.Runtime.InteropServices.DllImport("user32.dll", EntryPoint = "LoadCursorFromFileW", CharSet = System.Runtime.InteropServices.CharSet.Unicode)]
		private static extern System.IntPtr LoadCursorFromFile(string str);

		#region	Fields
		private Syncfusion.Windows.Forms.Tools.XPMenus.ChildFrameBarManager childFrameBarManager1;
		private Syncfusion.Windows.Forms.Tools.XPMenus.ParentBarItem parentBarItemFormat;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem bItemNew;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem bItemOpen;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem bItemSave;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem bItemSaveAs;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem bItemClose;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem bItemText;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem bItemRichText;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem bItemBold;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem bItemItalic;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem bItemUnderline;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem bItemAlignLeft;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem bItemAlignCenter;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem bItemAlignRight;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem bItemTextColor;
		private System.ComponentModel.IContainer components;
		private Syncfusion.Windows.Forms.Tools.XPMenus.Bar bar1;
		private Syncfusion.Windows.Forms.Tools.XPMenus.Bar bar2;
		private Symcon.Lightridge.LRRUI.Controls.PropertyEditor propertyEditor2;
		private FileDialog fileDialog;
		private LRRApp _app;
		private LRRSavedViews lrrSavedViews;
		private Symcon.Lightridge.LRRUI.Controls.SymbolsList symbolsList1;
		private LRRModes lrrModes;
		private string typePropValue;
		private TabControl _parentTabControl;
		private TabPage _parentTabPage;
		private int canvasCount = 1;
		public GraphicsManagers gms;
		private bool _isFormClosing = false;
		private EventHandler idleEventHandler;
		private bool _implementerPanAndZoom = false;
		private ToolTip _toolTip = new ToolTip();
		private delegate void OpenFile(string fileID);
        //public delegate void ViewMagnificationEventHandler(ViewMagnificationEventArgs evtArgs);
		Symbol sourceSymbol;
		private Syncfusion.Windows.Forms.Tools.XPMenus.Bar barToolBar;
		private Syncfusion.Windows.Forms.Tools.XPMenus.ParentBarItem parentBarItem1;
		private BarItem barItemPropertiesWindow;
		private ImageList CanvasToolbarImages;
		private BarItem biPrintZooming;
		private BarItem barItemSymbolPallette;
		private ParentBarItem parentBarItemSession;
		private ParentBarItem parentBarItem2;
		private BarItem barItemNavigation;
		private ImageList smallImageList;
		private BarItem bItemShowObjectBrowser;
		private BarItem barItem2;
		private Syncfusion.Windows.Forms.Diagram.Controls.OverviewControl overViewNavigation;
		private Panel pnlQueryView;
		private ImageList smBarItemImages;
		private BarItem barItem1;
		private ImageList imageList1;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem bItemRuler;
        private Syncfusion.Windows.Forms.Diagram.Controls.Diagram diagram1;
		//private ComboBoxBarItem comboBoxPointSize;
		//private ComboBoxBarItem comboBoxFontFamily;
		//private BarItem barItemNudgeDown;
		private DockingManager dockingManager1;
		private DockingClientPanel dcPanel;
		private Panel pnlCanvasHeader;
		private Syncfusion.Windows.Forms.ButtonAdv btnMoveLeft;
		private Button btnClose;
		private Syncfusion.Windows.Forms.ButtonAdv btnMoveRight;
		private TabControlAdv tabControlAdv1;
		private Splitter splitter1;
		private ToolStripPanel toolStripPanel1;
		private ToolStrip toolStripFileOptions;
		private ToolStripButton toolStripBtnNew;
		private ToolStripButton toolStripBtnSave;
		private ToolStripButton toolStripBtnOpen;
		private ToolStripLabel toolStripLblSaveAs;
		private ToolStrip toolStripLayout;
		private ToolStripButton toolStripbtnChangeDemsion;
		private ToolStripButton toolStripBtnSpaceAcross;
		private ToolStripButton toolStripBtnSpaceDown;
		private ToolStripButton toolStripBtnSameWidth;
		private ToolStripButton toolStripBtnSameHeight;
		private ToolStripButton toolStripBtnSameSize;
		private ToolStrip toolStripDrawing;
		private ToolStripButton toolStripBtnLine;
		private ToolStripButton toolStripBtnRectangle;
		private ToolStripButton toolStripBtnEcllipse;
		private ToolStripButton toolStripBtnPolyLine;
		private ToolStripButton toolStripBtnCurve;
		private ToolStripButton toolStripBtnFormatPainter;
		private ToolStripButton toolStripBtnRRect;
		private ToolStrip toolStripNudgeTools;
		private ToolStripButton toolStripBtnNudgeUp;
		private ToolStripButton toolStripBtnNudgeDown;
		private ToolStripButton toolStripBtnNudgeLeft;
		private ToolStripButton toolStripBtnNudgeRight;
		private ToolStrip toolStripAlign;
		private ToolStripButton toolStripBtnAlignLeft;
		private ToolStripButton toolStripBtnAlignCenter;
		private ToolStripButton toolStripBtnAlignRight;
		private ToolStripButton toolStripBtnAlignTop;
		private ToolStripButton toolStripBtnAlignMiddle;
		private ToolStripButton toolStripBtnAlignBottom;
		private ToolStrip toolStripNodes;
		private ToolStripButton toolStripBtnBToFront;
		private ToolStripButton toolStripBtnSToBack;
		private ToolStripButton toolStripBtnToForward;
		private ToolStripButton toolStripBtnSendBackwards;
		private ToolStripButton toolStripBtnGroup;
		private ToolStripButton toolStripBtnUnGroup;
		private ToolStrip toolStripConnectors;
		private ToolStripButton toolStripBtnConnectors;
		private ToolStripButton toolStripBtnOrthoConn;
		private ToolStripButton toolStripBtnDirectedConn;
		private ToolStripButton toolStripBtnVerticalConn;
		private ToolStripButton toolStripBtnRightAngleConn;
		private ToolStripButton toolStripBtnArcConn;
		private ToolStrip toolStripRotate;
		private ToolStripButton toolStripBtnRotate;
		private ToolStripButton toolStripBtnLeftRotate;
		private ToolStripButton toolStripBtnRightRotate;
		private ToolStripButton toolStripBtnFlipVertical;
		private ToolStripButton toolStripBtnFlipHorizontal;
		private ToolStrip toolStripView;
		private ToolStripButton toolStripBtnSelect;
		private ToolStripButton toolStripBtnPan;
		private ToolStripButton toolStripBtnShowGrid;
		private ToolStripButton toolStripBtnSnapToGrid;
		private ToolStripButton toolStripBtnZoom;
		private ToolStripComboBox toolStripCmbMagnify;
		private ToolStrip toolStripCanvas;
		private ToolStripComboBox toolStripCmbFontFamily;
		private ToolStripComboBox toolStripCmbPointSize;
		private ToolStripButton toolStripBtnRichText;
		private ToolStripButton toolStripBtnBold;
		private ToolStripButton toolStripBtnUnderLine;
		private ToolStripButton toolStripBtnItalic;
		private ToolStripButton toolStripBtnTLeft;
		private ToolStripButton toolStripBtnTCenter;
		private ToolStripButton toolStripBtnTRight;
		private ToolStripButton toolStripBtnTColor;
		private ToolStripSeparator toolStripSeparator1;
		private ToolStripSeparator toolStripSeparator2;
		private ToolStripSeparator toolStripSeparator3;
		private ToolStripSeparator toolStripSeparator4;
		private ToolStripSeparator toolStripSeparator5;
		private ToolStripSeparator toolStripSeparator6;
		private ToolStripSeparator toolStripSeparator7;
		private ToolStripSeparator toolStripSeparator8;
		private ToolStripSeparator toolStripSeparator9;
		private ToolStripSeparator toolStripSeparator10;
		private ToolStripSeparator toolStripSeparator11;
		private ToolStripButton toolStripButton1;
        private ToolStrip toolStripMarkers;
        private ImageList imgLstMarkers;
        private ToolStripButton toolStripBtnHMarker;
        private ToolStripButton toolStripBtnVMarker;
        private ToolStripButton toolStripBtnHVMarkerEdit;

		OpenFile _openFile;

		#endregion

		#region	Constructor

		public ImplementerScreen()
		{
			_app = AppDomain.CurrentDomain.GetData("AppObject") as LRRApp;
            // hookup events called by ashiwn
			gms = new GraphicsManagers();
            //gms.HookUpEvents();
			sourceSymbol = new Symbol();
			//UpdateGraphics ug = new UpdateGraphics();
			// ug.ShowDialog();


			//_app = AppDomain.CurrentDomain.GetData("AppObject")	as LRRApp;
			//_app.ModesPanel.ModesChanged+=new ModesChangedEventhandler(ModesPanel_ModesChanged);
			//gms = new GraphicsManagers();
			lrrModes = LRRModel.ProjectModes;

			InitializeComponent();
			//this.symbolsList1 = new SymbolsList();
			sortCmbValues(this.toolStripCmbMagnify);
			InternationalizationUtils.GetControlText(this, this.components.Components);
			//this.resStringMgr =	new	ResourceManager("Symcon.LightRidge.PEAdvisor.ImplementerGraphics.Strings", typeof(ImplementerScreen).Assembly);
			this.propertyEditor2.PropertyGrid.PropertyValueChanged += new PropertyValueChangedEventHandler(PropertyGrid_PropertyValueChanged);
			this.tabControlAdv1.SelectedIndexChanged += new EventHandler(this.tabControlAdv1_SelectedIndexChanged);
			this.Closing += new CancelEventHandler(this.ImplementerScreen_Closing);
			this.tabControlAdv1.ShowScroll = true;
			this.Closed += new EventHandler(ImplementerScreen_Closed);
			//hshOpenedViews = new Hashtable();
			lrrSavedViews = LRRModel.SavedViews;//new	LRRSavedViews();
			//_app.DBManagerObj.PopulateCollection(lrrSavedViews);
			pnlCanvasHeader.Hide();
			gms.ApplyModes();
			this.Activated += new EventHandler(ImplementerScreen_Activated);
			this.Deactivate += new EventHandler(ImplementerScreen_Deactivate);
			this.LoadFontSelections();
			WireGmsEvents(gms);
			idleEventHandler = new EventHandler(OnIdle);
			Application.Idle += idleEventHandler;
			_toolTip.InitialDelay = 500;
			_toolTip.ReshowDelay = 500;
			_toolTip.AutoPopDelay = 5000;
			_openFile = new OpenFile(OnOpenFile);


		}

		#endregion

		#region	Overrides

		///	<summary>
		///	Clean up any resources being used.
		///	</summary>
		protected override void Dispose(bool disposing)
		{
			if (disposing)
			{
				if (components != null)
				{
					UnWireGmsEvents(gms);
					Application.Idle -= idleEventHandler;
					components.Dispose();
					gms.Dispose();
                    gms = null;
				}
			}
			base.Dispose(disposing);
		}

		#endregion

		#region	Windows	Form Designer generated	code

		///	<summary>
		///	Required method	for	Designer support - do not modify
		///	the	contents of	this method	with the code editor.
		///	</summary>
		private void InitializeComponent()
		{
            this.components = new System.ComponentModel.Container();
            System.ComponentModel.ComponentResourceManager resources = new System.ComponentModel.ComponentResourceManager(typeof(ImplementerScreen));
            this.symbolsList1 = new SymbolsList();
            this.propertyEditor2 = new Symcon.Lightridge.LRRUI.Controls.PropertyEditor();
            this.childFrameBarManager1 = new Syncfusion.Windows.Forms.Tools.XPMenus.ChildFrameBarManager(this.components, this);
            this.barToolBar = new Syncfusion.Windows.Forms.Tools.XPMenus.Bar(this.childFrameBarManager1, "");
            this.parentBarItem2 = new Syncfusion.Windows.Forms.Tools.XPMenus.ParentBarItem();
            this.bItemNew = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
            this.smallImageList = new System.Windows.Forms.ImageList(this.components);
            this.bItemOpen = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
            this.bItemSave = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
            this.bItemSaveAs = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
            this.bItemClose = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
            this.parentBarItemSession = new Syncfusion.Windows.Forms.Tools.XPMenus.ParentBarItem();
            this.biPrintZooming = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
            this.parentBarItem1 = new Syncfusion.Windows.Forms.Tools.XPMenus.ParentBarItem();
            this.barItemPropertiesWindow = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
            this.barItemSymbolPallette = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
            this.barItemNavigation = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
            this.bItemShowObjectBrowser = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
            this.barItem2 = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
            this.bItemRuler = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
            this.parentBarItemFormat = new Syncfusion.Windows.Forms.Tools.XPMenus.ParentBarItem();
            this.bItemRichText = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
            this.CanvasToolbarImages = new System.Windows.Forms.ImageList(this.components);
            this.bItemBold = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
            this.bItemUnderline = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
            this.bItemItalic = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
            this.bItemAlignLeft = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
            this.bItemAlignCenter = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
            this.bItemAlignRight = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
            this.bItemTextColor = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
            this.bItemText = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
            this.barItem1 = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
            this.overViewNavigation = new Syncfusion.Windows.Forms.Diagram.Controls.OverviewControl();
            this.pnlQueryView = new System.Windows.Forms.Panel();
            this.smBarItemImages = new System.Windows.Forms.ImageList(this.components);
            this.imageList1 = new System.Windows.Forms.ImageList(this.components);
            this.dockingManager1 = new Syncfusion.Windows.Forms.Tools.DockingManager(this.components);
            this.toolStripPanel1 = new System.Windows.Forms.ToolStripPanel();
            this.toolStripFileOptions = new System.Windows.Forms.ToolStrip();
            this.toolStripBtnNew = new System.Windows.Forms.ToolStripButton();
            this.toolStripBtnOpen = new System.Windows.Forms.ToolStripButton();
            this.toolStripBtnSave = new System.Windows.Forms.ToolStripButton();
            this.toolStripLblSaveAs = new System.Windows.Forms.ToolStripLabel();
            this.toolStripLayout = new System.Windows.Forms.ToolStrip();
            this.toolStripbtnChangeDemsion = new System.Windows.Forms.ToolStripButton();
            this.toolStripBtnSpaceAcross = new System.Windows.Forms.ToolStripButton();
            this.toolStripBtnSpaceDown = new System.Windows.Forms.ToolStripButton();
            this.toolStripBtnSameWidth = new System.Windows.Forms.ToolStripButton();
            this.toolStripBtnSameHeight = new System.Windows.Forms.ToolStripButton();
            this.toolStripBtnSameSize = new System.Windows.Forms.ToolStripButton();
            this.toolStripNodes = new System.Windows.Forms.ToolStrip();
            this.toolStripBtnBToFront = new System.Windows.Forms.ToolStripButton();
            this.toolStripBtnSToBack = new System.Windows.Forms.ToolStripButton();
            this.toolStripBtnToForward = new System.Windows.Forms.ToolStripButton();
            this.toolStripBtnSendBackwards = new System.Windows.Forms.ToolStripButton();
            this.toolStripBtnGroup = new System.Windows.Forms.ToolStripButton();
            this.toolStripBtnUnGroup = new System.Windows.Forms.ToolStripButton();
            this.toolStripNudgeTools = new System.Windows.Forms.ToolStrip();
            this.toolStripBtnNudgeUp = new System.Windows.Forms.ToolStripButton();
            this.toolStripBtnNudgeDown = new System.Windows.Forms.ToolStripButton();
            this.toolStripBtnNudgeLeft = new System.Windows.Forms.ToolStripButton();
            this.toolStripBtnNudgeRight = new System.Windows.Forms.ToolStripButton();
            this.toolStripDrawing = new System.Windows.Forms.ToolStrip();
            this.toolStripBtnLine = new System.Windows.Forms.ToolStripButton();
            this.toolStripBtnRectangle = new System.Windows.Forms.ToolStripButton();
            this.toolStripBtnEcllipse = new System.Windows.Forms.ToolStripButton();
            this.toolStripBtnPolyLine = new System.Windows.Forms.ToolStripButton();
            this.toolStripBtnCurve = new System.Windows.Forms.ToolStripButton();
            this.toolStripBtnFormatPainter = new System.Windows.Forms.ToolStripButton();
            this.toolStripBtnRRect = new System.Windows.Forms.ToolStripButton();
            this.toolStripView = new System.Windows.Forms.ToolStrip();
            this.toolStripBtnSelect = new System.Windows.Forms.ToolStripButton();
            this.toolStripBtnPan = new System.Windows.Forms.ToolStripButton();
            this.toolStripBtnShowGrid = new System.Windows.Forms.ToolStripButton();
            this.toolStripBtnSnapToGrid = new System.Windows.Forms.ToolStripButton();
            this.toolStripBtnZoom = new System.Windows.Forms.ToolStripButton();
            this.toolStripCmbMagnify = new System.Windows.Forms.ToolStripComboBox();
            this.toolStripConnectors = new System.Windows.Forms.ToolStrip();
            this.toolStripBtnConnectors = new System.Windows.Forms.ToolStripButton();
            this.toolStripBtnOrthoConn = new System.Windows.Forms.ToolStripButton();
            this.toolStripBtnDirectedConn = new System.Windows.Forms.ToolStripButton();
            this.toolStripBtnVerticalConn = new System.Windows.Forms.ToolStripButton();
            this.toolStripBtnRightAngleConn = new System.Windows.Forms.ToolStripButton();
            this.toolStripBtnArcConn = new System.Windows.Forms.ToolStripButton();
            this.toolStripRotate = new System.Windows.Forms.ToolStrip();
            this.toolStripBtnRotate = new System.Windows.Forms.ToolStripButton();
            this.toolStripBtnLeftRotate = new System.Windows.Forms.ToolStripButton();
            this.toolStripBtnRightRotate = new System.Windows.Forms.ToolStripButton();
            this.toolStripBtnFlipVertical = new System.Windows.Forms.ToolStripButton();
            this.toolStripBtnFlipHorizontal = new System.Windows.Forms.ToolStripButton();
            this.toolStripCanvas = new System.Windows.Forms.ToolStrip();
            this.toolStripCmbFontFamily = new System.Windows.Forms.ToolStripComboBox();
            this.toolStripCmbPointSize = new System.Windows.Forms.ToolStripComboBox();
            this.toolStripBtnRichText = new System.Windows.Forms.ToolStripButton();
            this.toolStripBtnBold = new System.Windows.Forms.ToolStripButton();
            this.toolStripBtnUnderLine = new System.Windows.Forms.ToolStripButton();
            this.toolStripBtnItalic = new System.Windows.Forms.ToolStripButton();
            this.toolStripBtnTLeft = new System.Windows.Forms.ToolStripButton();
            this.toolStripBtnTCenter = new System.Windows.Forms.ToolStripButton();
            this.toolStripBtnTRight = new System.Windows.Forms.ToolStripButton();
            this.toolStripBtnTColor = new System.Windows.Forms.ToolStripButton();
            this.toolStripMarkers = new System.Windows.Forms.ToolStrip();
            this.imgLstMarkers = new System.Windows.Forms.ImageList(this.components);
            this.toolStripBtnHMarker = new System.Windows.Forms.ToolStripButton();
            this.toolStripBtnVMarker = new System.Windows.Forms.ToolStripButton();
            this.toolStripBtnHVMarkerEdit = new System.Windows.Forms.ToolStripButton();
            this.toolStripAlign = new System.Windows.Forms.ToolStrip();
            this.toolStripBtnAlignLeft = new System.Windows.Forms.ToolStripButton();
            this.toolStripBtnAlignCenter = new System.Windows.Forms.ToolStripButton();
            this.toolStripBtnAlignRight = new System.Windows.Forms.ToolStripButton();
            this.toolStripBtnAlignTop = new System.Windows.Forms.ToolStripButton();
            this.toolStripBtnAlignMiddle = new System.Windows.Forms.ToolStripButton();
            this.toolStripBtnAlignBottom = new System.Windows.Forms.ToolStripButton();
            this.splitter1 = new System.Windows.Forms.Splitter();
            this.dcPanel = new Syncfusion.Windows.Forms.Tools.DockingClientPanel();
            this.pnlCanvasHeader = new System.Windows.Forms.Panel();
            this.btnClose = new System.Windows.Forms.Button();
            this.btnMoveRight = new Syncfusion.Windows.Forms.ButtonAdv();
            this.btnMoveLeft = new Syncfusion.Windows.Forms.ButtonAdv();
            this.tabControlAdv1 = new Syncfusion.Windows.Forms.Tools.TabControlAdv();
            this.toolStripSeparator1 = new System.Windows.Forms.ToolStripSeparator();
            this.toolStripSeparator2 = new System.Windows.Forms.ToolStripSeparator();
            this.toolStripSeparator3 = new System.Windows.Forms.ToolStripSeparator();
            this.toolStripSeparator4 = new System.Windows.Forms.ToolStripSeparator();
            this.toolStripSeparator5 = new System.Windows.Forms.ToolStripSeparator();
            this.toolStripSeparator6 = new System.Windows.Forms.ToolStripSeparator();
            this.toolStripSeparator7 = new System.Windows.Forms.ToolStripSeparator();
            this.toolStripSeparator8 = new System.Windows.Forms.ToolStripSeparator();
            this.toolStripSeparator9 = new System.Windows.Forms.ToolStripSeparator();
            this.toolStripSeparator10 = new System.Windows.Forms.ToolStripSeparator();
            this.toolStripSeparator11 = new System.Windows.Forms.ToolStripSeparator();
            ((System.ComponentModel.ISupportInitialize)(this.childFrameBarManager1)).BeginInit();
            ((System.ComponentModel.ISupportInitialize)(this.dockingManager1)).BeginInit();
            this.toolStripPanel1.SuspendLayout();
            this.toolStripFileOptions.SuspendLayout();
            this.toolStripLayout.SuspendLayout();
            this.toolStripNodes.SuspendLayout();
            this.toolStripNudgeTools.SuspendLayout();
            this.toolStripDrawing.SuspendLayout();
            this.toolStripView.SuspendLayout();
            this.toolStripConnectors.SuspendLayout();
            this.toolStripRotate.SuspendLayout();
            this.toolStripCanvas.SuspendLayout();
            this.toolStripMarkers.SuspendLayout();
            this.toolStripAlign.SuspendLayout();
            this.dcPanel.SuspendLayout();
            this.pnlCanvasHeader.SuspendLayout();
            ((System.ComponentModel.ISupportInitialize)(this.tabControlAdv1)).BeginInit();
            this.SuspendLayout();
            // 
            // propertyEditor2
            // 
            this.propertyEditor2.Canvas = null;
            this.dockingManager1.SetEnableDocking(this.propertyEditor2, true);
            this.propertyEditor2.Location = new System.Drawing.Point(1, 21);
            this.propertyEditor2.Name = "propertyEditor2";
            this.propertyEditor2.Size = new System.Drawing.Size(166, 433);
            this.propertyEditor2.TabIndex = 10;
            // 
            // childFrameBarManager1
            // 
            this.childFrameBarManager1.BarPositionInfo = ((System.IO.MemoryStream)(resources.GetObject("childFrameBarManager1.BarPositionInfo")));
            this.childFrameBarManager1.Bars.Add(this.barToolBar);
            this.childFrameBarManager1.CategoriesToIgnoreInCustDialog.AddRange(new int[] {
            0,
            1,
            2,
            3,
            4,
            6,
            7,
            8,
            9,
            10,
            11});
            this.childFrameBarManager1.CurrentBaseFormType = "";
            this.childFrameBarManager1.DisabledImageList = null;
            this.childFrameBarManager1.DisabledLargeImageList = null;
            this.childFrameBarManager1.ExpandPartialMenusAfterDelay = false;
            this.childFrameBarManager1.Form = this;
            this.childFrameBarManager1.ImageList = null;
            this.childFrameBarManager1.Items.AddRange(new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem[] {
            this.bItemNew,
            this.bItemRichText,
            this.bItemOpen,
            this.bItemText,
            this.bItemSave,
            this.bItemBold,
            this.bItemSaveAs,
            this.bItemUnderline,
            this.bItemClose,
            this.bItemItalic,
            this.bItemAlignCenter,
            this.bItemAlignLeft,
            this.bItemAlignRight,
            this.bItemTextColor,
            this.parentBarItem1,
            this.parentBarItem2,
            this.parentBarItemSession,
            this.parentBarItemFormat,
            this.barItemPropertiesWindow,
            this.barItemSymbolPallette,
            this.barItemNavigation,
            this.barItem2,
            this.bItemRuler,
            this.bItemShowObjectBrowser,
            this.barItem1,
            this.biPrintZooming});
            this.childFrameBarManager1.LargeImageList = null;
            this.childFrameBarManager1.Style = Syncfusion.Windows.Forms.VisualStyle.Office2003;
            this.childFrameBarManager1.UpdateUIMFCStyle = true;
            // 
            // barToolBar
            // 
            this.barToolBar.BarName = "";
            this.barToolBar.BarStyle = ((Syncfusion.Windows.Forms.Tools.XPMenus.BarStyle)((Syncfusion.Windows.Forms.Tools.XPMenus.BarStyle.IsMainMenu | Syncfusion.Windows.Forms.Tools.XPMenus.BarStyle.Visible)));
            this.barToolBar.Caption = null;
            this.barToolBar.Items.AddRange(new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem[] {
            this.parentBarItem2,
            this.parentBarItemSession,
            this.parentBarItem1,
            this.parentBarItemFormat});
            this.barToolBar.Manager = this.childFrameBarManager1;
            this.barToolBar.MenuItemMergeOrder = 5;
            // 
            // parentBarItem2
            // 
            this.parentBarItem2.CategoryIndex = 0;
            this.parentBarItem2.ID = "&Graphics";
            this.parentBarItem2.Items.AddRange(new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem[] {
            this.bItemNew,
            this.bItemOpen,
            this.bItemSave,
            this.bItemSaveAs,
            this.bItemClose});
            this.parentBarItem2.SeparatorIndices.AddRange(new int[] {
            1,
            2,
            4,
            7});
            this.parentBarItem2.Tag = "SID_GRPAHICS";
            // 
            // bItemNew
            // 
            this.bItemNew.CategoryIndex = 0;
            this.bItemNew.ID = "&New";
            this.bItemNew.ImageIndex = 0;
            this.bItemNew.ImageList = this.smallImageList;
            this.bItemNew.Tag = "SID_NEW";
            this.bItemNew.Click += new System.EventHandler(this.bItemNew_Click);
            // 
            // smallImageList
            // 
            this.smallImageList.ImageStream = ((System.Windows.Forms.ImageListStreamer)(resources.GetObject("smallImageList.ImageStream")));
            this.smallImageList.TransparentColor = System.Drawing.Color.Fuchsia;
            this.smallImageList.Images.SetKeyName(0, "");
            this.smallImageList.Images.SetKeyName(1, "");
            this.smallImageList.Images.SetKeyName(2, "");
            this.smallImageList.Images.SetKeyName(3, "");
            this.smallImageList.Images.SetKeyName(4, "");
            this.smallImageList.Images.SetKeyName(5, "");
            this.smallImageList.Images.SetKeyName(6, "");
            this.smallImageList.Images.SetKeyName(7, "");
            this.smallImageList.Images.SetKeyName(8, "");
            this.smallImageList.Images.SetKeyName(9, "");
            this.smallImageList.Images.SetKeyName(10, "");
            this.smallImageList.Images.SetKeyName(11, "");
            // 
            // bItemOpen
            // 
            this.bItemOpen.CategoryIndex = 0;
            this.bItemOpen.ID = "&Open";
            this.bItemOpen.ImageIndex = 1;
            this.bItemOpen.ImageList = this.smallImageList;
            this.bItemOpen.Tag = "SID_OPEN";
            this.bItemOpen.Click += new System.EventHandler(this.bItemOpen_Click);
            // 
            // bItemSave
            // 
            this.bItemSave.CategoryIndex = 0;
            this.bItemSave.ID = "&Save";
            this.bItemSave.ImageIndex = 2;
            this.bItemSave.ImageList = this.smallImageList;
            this.bItemSave.Tag = "SID_SAVES";
            this.bItemSave.Click += new System.EventHandler(this.bItemSave_Click);
            // 
            // bItemSaveAs
            // 
            this.bItemSaveAs.CategoryIndex = 0;
            this.bItemSaveAs.ID = "Save\tAs";
            this.bItemSaveAs.Tag = "SID_SAVE_AS";
            this.bItemSaveAs.Click += new System.EventHandler(this.bItemSaveAs_Click);
            // 
            // bItemClose
            // 
            this.bItemClose.CategoryIndex = 0;
            this.bItemClose.ID = "Close";
            this.bItemClose.Tag = "SID_CLOSE";
            this.bItemClose.Click += new System.EventHandler(this.btnClose_Click);
            // 
            // parentBarItemSession
            // 
            this.parentBarItemSession.CategoryIndex = 0;
            this.parentBarItemSession.ID = "&Session";
            this.parentBarItemSession.Items.AddRange(new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem[] {
            this.biPrintZooming});
            this.parentBarItemSession.Tag = "1";
            // 
            // biPrintZooming
            // 
            this.biPrintZooming.CategoryIndex = 1;
            this.biPrintZooming.ID = "Print Zooming";
            this.biPrintZooming.Tag = "SID_PRIENT_ZOOMING";
            // 
            // parentBarItem1
            // 
            this.parentBarItem1.CategoryIndex = 5;
            this.parentBarItem1.ID = "&View";
            this.parentBarItem1.Items.AddRange(new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem[] {
            this.barItemPropertiesWindow,
            this.barItemSymbolPallette,
            this.barItemNavigation,
            this.bItemShowObjectBrowser,
            this.barItem2,
            this.bItemRuler});
            this.parentBarItem1.SeparatorIndices.AddRange(new int[] {
            0,
            6});
            this.parentBarItem1.Tag = "10";
            // 
            // barItemPropertiesWindow
            // 
            this.barItemPropertiesWindow.CategoryIndex = 5;
            this.barItemPropertiesWindow.Checked = true;
            this.barItemPropertiesWindow.ID = "Properties Window";
            this.barItemPropertiesWindow.Shortcut = System.Windows.Forms.Shortcut.F4;
            this.barItemPropertiesWindow.Tag = "SID_PROPERTIES_WND";
            this.barItemPropertiesWindow.Click += new System.EventHandler(this.barItemPropertiesWindow_Click);
            // 
            // barItemSymbolPallette
            // 
            this.barItemSymbolPallette.CategoryIndex = 5;
            this.barItemSymbolPallette.Checked = true;
            this.barItemSymbolPallette.ID = "Symbol\t&Pallette";
            this.barItemSymbolPallette.Shortcut = System.Windows.Forms.Shortcut.CtrlShiftP;
            this.barItemSymbolPallette.Tag = "SID_SHAPES_WINDOW";
            this.barItemSymbolPallette.Click += new System.EventHandler(this.barItemSymbolPallette_Click);
            // 
            // barItemNavigation
            // 
            this.barItemNavigation.CategoryIndex = 5;
            this.barItemNavigation.Checked = true;
            this.barItemNavigation.ID = "Na&vigation Pane";
            this.barItemNavigation.Shortcut = System.Windows.Forms.Shortcut.CtrlShiftN;
            this.barItemNavigation.Tag = "SID_PAN_AND_ZOOM";
            this.barItemNavigation.Click += new System.EventHandler(this.barItemNavigation_Click);
            // 
            // bItemShowObjectBrowser
            // 
            this.bItemShowObjectBrowser.CategoryIndex = 5;
            this.bItemShowObjectBrowser.Enabled = false;
            this.bItemShowObjectBrowser.ID = "OverView Control";
            this.bItemShowObjectBrowser.Shortcut = System.Windows.Forms.Shortcut.CtrlShiftO;
            this.bItemShowObjectBrowser.Tag = "SID_OBJECT_BROWSER";
            this.bItemShowObjectBrowser.Click += new System.EventHandler(this.bItemShowObjectBrowser_Click);
            // 
            // barItem2
            // 
            this.barItem2.CategoryIndex = 5;
            this.barItem2.ID = "PropertyDetails";
            this.barItem2.Tag = "SID_ATT_DETL_WND";
            this.barItem2.Click += new System.EventHandler(this.barItem2_Click);
            // 
            // bItemRuler
            // 
            this.bItemRuler.CategoryIndex = 5;
            this.bItemRuler.Checked = true;
            this.bItemRuler.ID = "Ruler";
            this.bItemRuler.Tag = "SID_RULERS";
            this.bItemRuler.Click += new System.EventHandler(this.bItemRuler_Click);
            // 
            // parentBarItemFormat
            // 
            this.parentBarItemFormat.CategoryIndex = 4;
            this.parentBarItemFormat.ID = "Format";
            this.parentBarItemFormat.Items.AddRange(new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem[] {
            this.bItemRichText,
            this.bItemBold,
            this.bItemUnderline,
            this.bItemItalic,
            this.bItemAlignLeft,
            this.bItemAlignCenter,
            this.bItemAlignRight,
            this.bItemTextColor});
            this.parentBarItemFormat.SeparatorIndices.AddRange(new int[] {
            1,
            4,
            7});
            this.parentBarItemFormat.Tag = "SID_FORMAT";
            // 
            // bItemRichText
            // 
            this.bItemRichText.CategoryIndex = 4;
            this.bItemRichText.ID = "Rich Text";
            this.bItemRichText.ImageIndex = 48;
            this.bItemRichText.ImageList = this.CanvasToolbarImages;
            this.bItemRichText.Tag = "RichTextTool";
            this.bItemRichText.Click += new System.EventHandler(this.ToolActivate);

            // 
            // symbolsList1
            // 
            this.symbolsList1.AllowDrop = true;
            this.symbolsList1.AnimatedSelection = false;
            this.symbolsList1.BackColor = System.Drawing.Color.LightSkyBlue;
            this.symbolsList1.EditMode = false;
            this.dockingManager1.SetEnableDocking(this.symbolsList1, true);
            this.symbolsList1.Location = new System.Drawing.Point(1, 21);
            this.symbolsList1.Name = "Shapes";
            this.symbolsList1.SelectedItem = 1;
            this.symbolsList1.Size = new System.Drawing.Size(137, 456);
            this.symbolsList1.StackedMode = true;
            this.symbolsList1.TabIndex = 13;
            this.symbolsList1.Tag = "SID_SYMBOLS";
            this.symbolsList1.Text = "";
            this.symbolsList1.VisualStyle = Syncfusion.Windows.Forms.VisualStyle.Office2003;
            this.symbolsList1.Visible = true;
            // 
            // CanvasToolbarImages
            // 
            this.CanvasToolbarImages.ImageStream = ((System.Windows.Forms.ImageListStreamer)(resources.GetObject("CanvasToolbarImages.ImageStream")));
            this.CanvasToolbarImages.TransparentColor = System.Drawing.Color.Fuchsia;
            this.CanvasToolbarImages.Images.SetKeyName(0, "");
            this.CanvasToolbarImages.Images.SetKeyName(1, "");
            this.CanvasToolbarImages.Images.SetKeyName(2, "");
            this.CanvasToolbarImages.Images.SetKeyName(3, "");
            this.CanvasToolbarImages.Images.SetKeyName(4, "");
            this.CanvasToolbarImages.Images.SetKeyName(5, "");
            this.CanvasToolbarImages.Images.SetKeyName(6, "");
            this.CanvasToolbarImages.Images.SetKeyName(7, "");
            this.CanvasToolbarImages.Images.SetKeyName(8, "");
            this.CanvasToolbarImages.Images.SetKeyName(9, "");
            this.CanvasToolbarImages.Images.SetKeyName(10, "");
            this.CanvasToolbarImages.Images.SetKeyName(11, "");
            this.CanvasToolbarImages.Images.SetKeyName(12, "");
            this.CanvasToolbarImages.Images.SetKeyName(13, "");
            this.CanvasToolbarImages.Images.SetKeyName(14, "");
            this.CanvasToolbarImages.Images.SetKeyName(15, "");
            this.CanvasToolbarImages.Images.SetKeyName(16, "");
            this.CanvasToolbarImages.Images.SetKeyName(17, "");
            this.CanvasToolbarImages.Images.SetKeyName(18, "");
            this.CanvasToolbarImages.Images.SetKeyName(19, "");
            this.CanvasToolbarImages.Images.SetKeyName(20, "");
            this.CanvasToolbarImages.Images.SetKeyName(21, "");
            this.CanvasToolbarImages.Images.SetKeyName(22, "");
            this.CanvasToolbarImages.Images.SetKeyName(23, "");
            this.CanvasToolbarImages.Images.SetKeyName(24, "");
            this.CanvasToolbarImages.Images.SetKeyName(25, "");
            this.CanvasToolbarImages.Images.SetKeyName(26, "");
            this.CanvasToolbarImages.Images.SetKeyName(27, "");
            this.CanvasToolbarImages.Images.SetKeyName(28, "");
            this.CanvasToolbarImages.Images.SetKeyName(29, "");
            this.CanvasToolbarImages.Images.SetKeyName(30, "");
            this.CanvasToolbarImages.Images.SetKeyName(31, "");
            this.CanvasToolbarImages.Images.SetKeyName(32, "");
            this.CanvasToolbarImages.Images.SetKeyName(33, "");
            this.CanvasToolbarImages.Images.SetKeyName(34, "");
            this.CanvasToolbarImages.Images.SetKeyName(35, "");
            this.CanvasToolbarImages.Images.SetKeyName(36, "");
            this.CanvasToolbarImages.Images.SetKeyName(37, "");
            this.CanvasToolbarImages.Images.SetKeyName(38, "");
            this.CanvasToolbarImages.Images.SetKeyName(39, "");
            this.CanvasToolbarImages.Images.SetKeyName(40, "");
            this.CanvasToolbarImages.Images.SetKeyName(41, "");
            this.CanvasToolbarImages.Images.SetKeyName(42, "");
            this.CanvasToolbarImages.Images.SetKeyName(43, "");
            this.CanvasToolbarImages.Images.SetKeyName(44, "");
            this.CanvasToolbarImages.Images.SetKeyName(45, "");
            this.CanvasToolbarImages.Images.SetKeyName(46, "");
            this.CanvasToolbarImages.Images.SetKeyName(47, "");
            this.CanvasToolbarImages.Images.SetKeyName(48, "");
            this.CanvasToolbarImages.Images.SetKeyName(49, "");
            this.CanvasToolbarImages.Images.SetKeyName(50, "");
            this.CanvasToolbarImages.Images.SetKeyName(51, "");
            this.CanvasToolbarImages.Images.SetKeyName(52, "");
            this.CanvasToolbarImages.Images.SetKeyName(53, "");
            this.CanvasToolbarImages.Images.SetKeyName(54, "");
            this.CanvasToolbarImages.Images.SetKeyName(55, "");
            this.CanvasToolbarImages.Images.SetKeyName(56, "");
            this.CanvasToolbarImages.Images.SetKeyName(57, "");
            this.CanvasToolbarImages.Images.SetKeyName(58, "");
            this.CanvasToolbarImages.Images.SetKeyName(59, "");
            this.CanvasToolbarImages.Images.SetKeyName(60, "");
            this.CanvasToolbarImages.Images.SetKeyName(61, "");
            this.CanvasToolbarImages.Images.SetKeyName(62, "format.jpg");
            // 
            // bItemBold
            // 
            this.bItemBold.CategoryIndex = 4;
            this.bItemBold.ID = "Bold";
            this.bItemBold.ImageIndex = 49;
            this.bItemBold.ImageList = this.CanvasToolbarImages;
            this.bItemBold.Tag = "SID_BOLD";
            this.bItemBold.Click += new System.EventHandler(this.bItemBold_Click);
            // 
            // bItemUnderline
            // 
            this.bItemUnderline.CategoryIndex = 4;
            this.bItemUnderline.ID = "UnderLine";
            this.bItemUnderline.ImageIndex = 51;
            this.bItemUnderline.ImageList = this.CanvasToolbarImages;
            this.bItemUnderline.Tag = "SID_UNDERLINE";
            this.bItemUnderline.Click += new System.EventHandler(this.bItemUnderline_Click);
            // 
            // bItemItalic
            // 
            this.bItemItalic.CategoryIndex = 4;
            this.bItemItalic.ID = "Italic";
            this.bItemItalic.ImageIndex = 50;
            this.bItemItalic.ImageList = this.CanvasToolbarImages;
            this.bItemItalic.Tag = "SID_ITALIC";
            this.bItemItalic.Click += new System.EventHandler(this.bItemItalic_Click);
            // 
            // bItemAlignLeft
            // 
            this.bItemAlignLeft.CategoryIndex = 4;
            this.bItemAlignLeft.ID = "Align\tText Left";
            this.bItemAlignLeft.ImageIndex = 52;
            this.bItemAlignLeft.ImageList = this.CanvasToolbarImages;
            this.bItemAlignLeft.Tag = "SID_ALIGH_TEXT_LEFT";
            this.bItemAlignLeft.Click += new System.EventHandler(this.bItemAlignLeft_Click);
            // 
            // bItemAlignCenter
            // 
            this.bItemAlignCenter.CategoryIndex = 4;
            this.bItemAlignCenter.ID = "Center Align";
            this.bItemAlignCenter.ImageIndex = 53;
            this.bItemAlignCenter.ImageList = this.CanvasToolbarImages;
            this.bItemAlignCenter.Tag = "SID_CENTER_ALIGN";
            this.bItemAlignCenter.Click += new System.EventHandler(this.bItemAlignCenter_Click);
            // 
            // bItemAlignRight
            // 
            this.bItemAlignRight.CategoryIndex = 4;
            this.bItemAlignRight.ID = "Align Text Right";
            this.bItemAlignRight.ImageIndex = 54;
            this.bItemAlignRight.ImageList = this.CanvasToolbarImages;
            this.bItemAlignRight.Tag = "SID_ALIGN_TEXT_RIGHT";
            this.bItemAlignRight.Click += new System.EventHandler(this.bItemAlignRight_Click);
            // 
            // bItemTextColor
            // 
            this.bItemTextColor.CategoryIndex = 4;
            this.bItemTextColor.ID = "Text Color";
            this.bItemTextColor.ImageIndex = 55;
            this.bItemTextColor.ImageList = this.CanvasToolbarImages;
            this.bItemTextColor.Tag = "SID_TEXT_COLOR";
            this.bItemTextColor.Click += new System.EventHandler(this.bItemTextColor_Click);
            // 
            // bItemText
            // 
            this.bItemText.CategoryIndex = 4;
            this.bItemText.ID = "Plain Text\tBox";
            this.bItemText.ImageIndex = 12;
            this.bItemText.ImageList = this.CanvasToolbarImages;
            this.bItemText.Tag = "TextTool";
            this.bItemText.Click += new System.EventHandler(this.ToolActivate);
            // 
            // barItem1
            // 
            this.barItem1.CategoryIndex = -1;
            this.barItem1.ID = "_3";
            // 
            // overViewNavigation
            // 
            this.overViewNavigation.BackColor = System.Drawing.SystemColors.AppWorkspace;
            this.dockingManager1.SetEnableDocking(this.overViewNavigation, true);
            this.overViewNavigation.ForeColor = System.Drawing.Color.Red;
            this.overViewNavigation.Location = new System.Drawing.Point(1, 21);
            this.overViewNavigation.Name = "overViewNavigation";
            this.overViewNavigation.Size = new System.Drawing.Size(160, 433);
            this.overViewNavigation.TabIndex = 1;
            // 
            // pnlQueryView
            // 
            this.pnlQueryView.AutoScroll = true;
            this.pnlQueryView.BackColor = System.Drawing.SystemColors.ControlLightLight;
            this.dockingManager1.SetEnableDocking(this.pnlQueryView, true);
            this.pnlQueryView.Location = new System.Drawing.Point(1, 21);
            this.pnlQueryView.Name = "pnlQueryView";
            this.pnlQueryView.Size = new System.Drawing.Size(395, 433);
            this.pnlQueryView.TabIndex = 101;
            // 
            // smBarItemImages
            // 
            this.smBarItemImages.ImageStream = ((System.Windows.Forms.ImageListStreamer)(resources.GetObject("smBarItemImages.ImageStream")));
            this.smBarItemImages.TransparentColor = System.Drawing.Color.Fuchsia;
            this.smBarItemImages.Images.SetKeyName(0, "");
            this.smBarItemImages.Images.SetKeyName(1, "");
            this.smBarItemImages.Images.SetKeyName(2, "");
            this.smBarItemImages.Images.SetKeyName(3, "");
            this.smBarItemImages.Images.SetKeyName(4, "");
            this.smBarItemImages.Images.SetKeyName(5, "");
            this.smBarItemImages.Images.SetKeyName(6, "");
            this.smBarItemImages.Images.SetKeyName(7, "");
            this.smBarItemImages.Images.SetKeyName(8, "");
            this.smBarItemImages.Images.SetKeyName(9, "");
            this.smBarItemImages.Images.SetKeyName(10, "");
            this.smBarItemImages.Images.SetKeyName(11, "");
            this.smBarItemImages.Images.SetKeyName(12, "");
            this.smBarItemImages.Images.SetKeyName(13, "");
            this.smBarItemImages.Images.SetKeyName(14, "");
            this.smBarItemImages.Images.SetKeyName(15, "");
            this.smBarItemImages.Images.SetKeyName(16, "");
            this.smBarItemImages.Images.SetKeyName(17, "");
            this.smBarItemImages.Images.SetKeyName(18, "");
            this.smBarItemImages.Images.SetKeyName(19, "");
            this.smBarItemImages.Images.SetKeyName(20, "");
            this.smBarItemImages.Images.SetKeyName(21, "");
            this.smBarItemImages.Images.SetKeyName(22, "");
            this.smBarItemImages.Images.SetKeyName(23, "");
            this.smBarItemImages.Images.SetKeyName(24, "");
            this.smBarItemImages.Images.SetKeyName(25, "");
            this.smBarItemImages.Images.SetKeyName(26, "");
            this.smBarItemImages.Images.SetKeyName(27, "");
            this.smBarItemImages.Images.SetKeyName(28, "");
            this.smBarItemImages.Images.SetKeyName(29, "");
            this.smBarItemImages.Images.SetKeyName(30, "");
            this.smBarItemImages.Images.SetKeyName(31, "");
            this.smBarItemImages.Images.SetKeyName(32, "");
            this.smBarItemImages.Images.SetKeyName(33, "");
            this.smBarItemImages.Images.SetKeyName(34, "");
            this.smBarItemImages.Images.SetKeyName(35, "");
            this.smBarItemImages.Images.SetKeyName(36, "");
            this.smBarItemImages.Images.SetKeyName(37, "");
            this.smBarItemImages.Images.SetKeyName(38, "");
            this.smBarItemImages.Images.SetKeyName(39, "");
            this.smBarItemImages.Images.SetKeyName(40, "");
            this.smBarItemImages.Images.SetKeyName(41, "");
            this.smBarItemImages.Images.SetKeyName(42, "");
            this.smBarItemImages.Images.SetKeyName(43, "");
            this.smBarItemImages.Images.SetKeyName(44, "");
            this.smBarItemImages.Images.SetKeyName(45, "");
            this.smBarItemImages.Images.SetKeyName(46, "");
            this.smBarItemImages.Images.SetKeyName(47, "");
            this.smBarItemImages.Images.SetKeyName(48, "");
            this.smBarItemImages.Images.SetKeyName(49, "");
            this.smBarItemImages.Images.SetKeyName(50, "");
            this.smBarItemImages.Images.SetKeyName(51, "");
            this.smBarItemImages.Images.SetKeyName(52, "");
            this.smBarItemImages.Images.SetKeyName(53, "");
            this.smBarItemImages.Images.SetKeyName(54, "");
            // 
            // imageList1
            // 
            this.imageList1.ImageStream = ((System.Windows.Forms.ImageListStreamer)(resources.GetObject("imageList1.ImageStream")));
            this.imageList1.TransparentColor = System.Drawing.Color.Fuchsia;
            this.imageList1.Images.SetKeyName(0, "");
            this.imageList1.Images.SetKeyName(1, "");
            this.imageList1.Images.SetKeyName(2, "");
            this.imageList1.Images.SetKeyName(3, "");
            this.imageList1.Images.SetKeyName(4, "");
            this.imageList1.Images.SetKeyName(5, "");
            this.imageList1.Images.SetKeyName(6, "");
            this.imageList1.Images.SetKeyName(7, "");
            this.imageList1.Images.SetKeyName(8, "");
            this.imageList1.Images.SetKeyName(9, "");
            this.imageList1.Images.SetKeyName(10, "");
            this.imageList1.Images.SetKeyName(11, "");
            this.imageList1.Images.SetKeyName(12, "");
            this.imageList1.Images.SetKeyName(13, "");
            this.imageList1.Images.SetKeyName(14, "");
            this.imageList1.Images.SetKeyName(15, "");
            this.imageList1.Images.SetKeyName(16, "");
            this.imageList1.Images.SetKeyName(17, "");
            this.imageList1.Images.SetKeyName(18, "");
            this.imageList1.Images.SetKeyName(19, "");
            this.imageList1.Images.SetKeyName(20, "");
            this.imageList1.Images.SetKeyName(21, "");
            this.imageList1.Images.SetKeyName(22, "");
            this.imageList1.Images.SetKeyName(23, "");
            this.imageList1.Images.SetKeyName(24, "");
            this.imageList1.Images.SetKeyName(25, "");
            this.imageList1.Images.SetKeyName(26, "");
            this.imageList1.Images.SetKeyName(27, "");
            this.imageList1.Images.SetKeyName(28, "");
            this.imageList1.Images.SetKeyName(29, "");
            this.imageList1.Images.SetKeyName(30, "");
            this.imageList1.Images.SetKeyName(31, "");
            this.imageList1.Images.SetKeyName(32, "");
            // 
            // dockingManager1
            // 
            this.dockingManager1.AutoHideInterval = 200;
            this.dockingManager1.DockLayoutStream = ((System.IO.MemoryStream)(resources.GetObject("dockingManager1.DockLayoutStream")));
            this.dockingManager1.DockTabFont = new System.Drawing.Font("Tahoma", 10F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.World);
            this.dockingManager1.FullCaptionsInAutoHideMode = true;
            this.dockingManager1.HostControl = this;
            this.dockingManager1.HostFormClientBorder = false;
            this.dockingManager1.ShowToolTips = true;
            this.dockingManager1.SplitterWidth = 1;
            this.dockingManager1.ThemesEnabled = true;
            this.dockingManager1.PersistState = true;
            this.dockingManager1.DockVisibilityChanged += new Syncfusion.Windows.Forms.Tools.DockVisibilityChangedEventHandler(this.dockingManager1_DockVisibilityChanged);
            this.dockingManager1.SetDockLabel(this.propertyEditor2, "Properties");
            this.dockingManager1.SetDockLabel(this.overViewNavigation, "Pan And Zoom");
            this.dockingManager1.SetFloatOnly(this.overViewNavigation, true);
            this.dockingManager1.SetDockLabel(this.pnlQueryView, "Query View");
            this.dockingManager1.SetDockLabel(this.symbolsList1, "Symbols");
            // 
            // toolStripPanel1
            // 
            this.toolStripPanel1.BackColor = System.Drawing.SystemColors.InactiveCaptionText;
            this.toolStripPanel1.Controls.Add(this.toolStripFileOptions);
            this.toolStripPanel1.Controls.Add(this.toolStripLayout);
            this.toolStripPanel1.Controls.Add(this.toolStripNodes);
            this.toolStripPanel1.Controls.Add(this.toolStripNudgeTools);
            this.toolStripPanel1.Controls.Add(this.toolStripDrawing);
            this.toolStripPanel1.Controls.Add(this.toolStripView);
            this.toolStripPanel1.Controls.Add(this.toolStripConnectors);
            this.toolStripPanel1.Controls.Add(this.toolStripRotate);
            this.toolStripPanel1.Controls.Add(this.toolStripCanvas);
            this.toolStripPanel1.Controls.Add(this.toolStripAlign);
            this.toolStripPanel1.Controls.Add(this.toolStripMarkers);
            this.toolStripPanel1.Dock = System.Windows.Forms.DockStyle.Top;
            this.toolStripPanel1.Location = new System.Drawing.Point(0, 0);
            this.toolStripPanel1.Name = "toolStripPanel1";
            this.toolStripPanel1.Orientation = System.Windows.Forms.Orientation.Horizontal;
            this.toolStripPanel1.RowMargin = new System.Windows.Forms.Padding(3, 0, 0, 0);
            this.toolStripPanel1.Size = new System.Drawing.Size(800, 52);
            // 
            // toolStripFileOptions
            // 
            this.toolStripFileOptions.BackColor = System.Drawing.SystemColors.InactiveCaptionText;
            this.toolStripFileOptions.Dock = System.Windows.Forms.DockStyle.None;
            this.toolStripFileOptions.ImageList = this.smallImageList;
            this.toolStripFileOptions.Items.AddRange(new System.Windows.Forms.ToolStripItem[] {
            this.toolStripBtnNew,
            this.toolStripBtnOpen,
            this.toolStripBtnSave,
            this.toolStripLblSaveAs});
            this.toolStripFileOptions.LayoutStyle = System.Windows.Forms.ToolStripLayoutStyle.HorizontalStackWithOverflow;
            this.toolStripFileOptions.Location = new System.Drawing.Point(3, 0);
            this.toolStripFileOptions.Margin = new System.Windows.Forms.Padding(1);
            this.toolStripFileOptions.Name = "toolStripFileOptions";
            this.toolStripFileOptions.Padding = new System.Windows.Forms.Padding(1);
            this.toolStripFileOptions.RenderMode = System.Windows.Forms.ToolStripRenderMode.System;
            this.toolStripFileOptions.Size = new System.Drawing.Size(128, 25);
            this.toolStripFileOptions.TabIndex = 0;
            // 
            // toolStripBtnNew
            // 
            this.toolStripBtnNew.DisplayStyle = System.Windows.Forms.ToolStripItemDisplayStyle.Image;
            this.toolStripBtnNew.ImageIndex = 0;
            this.toolStripBtnNew.Name = "toolStripBtnNew";
            this.toolStripBtnNew.Size = new System.Drawing.Size(23, 20);
            this.toolStripBtnNew.Tag = "SID_NEW";
            this.toolStripBtnNew.Text = "&New";
            this.toolStripBtnNew.Click += new System.EventHandler(this.toolStripBtnNew_Click);
            // 
            // toolStripBtnOpen
            // 
            this.toolStripBtnOpen.DisplayStyle = System.Windows.Forms.ToolStripItemDisplayStyle.Image;
            this.toolStripBtnOpen.ImageIndex = 1;
            this.toolStripBtnOpen.Name = "toolStripBtnOpen";
            this.toolStripBtnOpen.Size = new System.Drawing.Size(23, 20);
            this.toolStripBtnOpen.Tag = "SID_OPEN";
            this.toolStripBtnOpen.Text = "&Open";
            this.toolStripBtnOpen.Click += new System.EventHandler(this.toolStripBtnOpen_Click);
            // 
            // toolStripBtnSave
            // 
            this.toolStripBtnSave.DisplayStyle = System.Windows.Forms.ToolStripItemDisplayStyle.Image;
            this.toolStripBtnSave.ImageIndex = 2;
            this.toolStripBtnSave.Name = "toolStripBtnSave";
            this.toolStripBtnSave.Size = new System.Drawing.Size(23, 20);
            this.toolStripBtnSave.Tag = "SID_SAVES";
            this.toolStripBtnSave.Text = "&Save";
            this.toolStripBtnSave.Click += new System.EventHandler(this.toolStripBtnSave_Click);
            // 
            // toolStripLblSaveAs
            // 
            this.toolStripLblSaveAs.Name = "toolStripLblSaveAs";
            this.toolStripLblSaveAs.Size = new System.Drawing.Size(46, 20);
            this.toolStripLblSaveAs.Tag = "SID_SAVE_AS";
            this.toolStripLblSaveAs.Text = "Save As";
            this.toolStripLblSaveAs.ToolTipText = "Save As";
            this.toolStripLblSaveAs.Click += new System.EventHandler(this.toolStripLblSaveAs_Click);
            // 
            // toolStripLayout
            // 
            this.toolStripLayout.BackColor = System.Drawing.SystemColors.InactiveCaptionText;
            this.toolStripLayout.Dock = System.Windows.Forms.DockStyle.None;
            this.toolStripLayout.ImageList = this.smBarItemImages;
            this.toolStripLayout.Items.AddRange(new System.Windows.Forms.ToolStripItem[] {
            this.toolStripbtnChangeDemsion,
            this.toolStripBtnSpaceAcross,
            this.toolStripBtnSpaceDown,
            this.toolStripBtnSameWidth,
            this.toolStripBtnSameHeight,
            this.toolStripBtnSameSize});
            this.toolStripLayout.Location = new System.Drawing.Point(131, 0);
            this.toolStripLayout.Margin = new System.Windows.Forms.Padding(1);
            this.toolStripLayout.Name = "toolStripLayout";
            this.toolStripLayout.Padding = new System.Windows.Forms.Padding(1);
            this.toolStripLayout.RenderMode = System.Windows.Forms.ToolStripRenderMode.System;
            this.toolStripLayout.Size = new System.Drawing.Size(182, 25);
            this.toolStripLayout.TabIndex = 1;
            // 
            // toolStripbtnChangeDemsion
            // 
            this.toolStripbtnChangeDemsion.DisplayStyle = System.Windows.Forms.ToolStripItemDisplayStyle.Image;
            this.toolStripbtnChangeDemsion.ImageIndex = 54;
            this.toolStripbtnChangeDemsion.Name = "toolStripbtnChangeDemsion";
            this.toolStripbtnChangeDemsion.Size = new System.Drawing.Size(23, 20);
            this.toolStripbtnChangeDemsion.Tag = "SID_CHANGE_CANVAS_DIMENSIONS";
            this.toolStripbtnChangeDemsion.Text = "Change Canvas Dimensions";
            this.toolStripbtnChangeDemsion.Click += new System.EventHandler(this.toolStripbtnChangeDemsion_Click);
            // 
            // toolStripBtnSpaceAcross
            // 
            this.toolStripBtnSpaceAcross.DisplayStyle = System.Windows.Forms.ToolStripItemDisplayStyle.Image;
            this.toolStripBtnSpaceAcross.ImageIndex = 40;
            this.toolStripBtnSpaceAcross.Name = "toolStripBtnSpaceAcross";
            this.toolStripBtnSpaceAcross.Size = new System.Drawing.Size(23, 20);
            this.toolStripBtnSpaceAcross.Tag = "SID_SPACE_ACROSS";
            this.toolStripBtnSpaceAcross.Text = "Space Across";
            this.toolStripBtnSpaceAcross.Click += new System.EventHandler(this.toolStripBtnSpaceAcross_Click);
            // 
            // toolStripBtnSpaceDown
            // 
            this.toolStripBtnSpaceDown.DisplayStyle = System.Windows.Forms.ToolStripItemDisplayStyle.Image;
            this.toolStripBtnSpaceDown.ImageIndex = 41;
            this.toolStripBtnSpaceDown.Name = "toolStripBtnSpaceDown";
            this.toolStripBtnSpaceDown.Size = new System.Drawing.Size(23, 20);
            this.toolStripBtnSpaceDown.Tag = "SID_SPACE_DOWN";
            this.toolStripBtnSpaceDown.Text = "Space Down";
            this.toolStripBtnSpaceDown.Click += new System.EventHandler(this.toolStripBtnSpaceDown_Click);
            // 
            // toolStripBtnSameWidth
            // 
            this.toolStripBtnSameWidth.DisplayStyle = System.Windows.Forms.ToolStripItemDisplayStyle.Image;
            this.toolStripBtnSameWidth.ImageIndex = 42;
            this.toolStripBtnSameWidth.Name = "toolStripBtnSameWidth";
            this.toolStripBtnSameWidth.Size = new System.Drawing.Size(23, 20);
            this.toolStripBtnSameWidth.Tag = "SID_SAME_WIDTH";
            this.toolStripBtnSameWidth.Text = "Same Width";
            this.toolStripBtnSameWidth.Click += new System.EventHandler(this.toolStripBtnSameWidth_Click);
            // 
            // toolStripBtnSameHeight
            // 
            this.toolStripBtnSameHeight.DisplayStyle = System.Windows.Forms.ToolStripItemDisplayStyle.Image;
            this.toolStripBtnSameHeight.ImageIndex = 43;
            this.toolStripBtnSameHeight.Name = "toolStripBtnSameHeight";
            this.toolStripBtnSameHeight.Size = new System.Drawing.Size(23, 20);
            this.toolStripBtnSameHeight.Tag = "SID_SAME_HIEGHT";
            this.toolStripBtnSameHeight.Text = "Same Height";
            this.toolStripBtnSameHeight.Click += new System.EventHandler(this.toolStripBtnSameHeight_Click);
            // 
            // toolStripBtnSameSize
            // 
            this.toolStripBtnSameSize.DisplayStyle = System.Windows.Forms.ToolStripItemDisplayStyle.Image;
            this.toolStripBtnSameSize.ImageIndex = 44;
            this.toolStripBtnSameSize.Name = "toolStripBtnSameSize";
            this.toolStripBtnSameSize.Size = new System.Drawing.Size(23, 20);
            this.toolStripBtnSameSize.Tag = "SID_SAME_SIZE";
            this.toolStripBtnSameSize.Text = "Same Size";
            this.toolStripBtnSameSize.Click += new System.EventHandler(this.toolStripBtnSameSize_Click);
            // 
            // toolStripNodes
            // 
            this.toolStripNodes.BackColor = System.Drawing.SystemColors.InactiveCaptionText;
            this.toolStripNodes.Dock = System.Windows.Forms.DockStyle.None;
            this.toolStripNodes.ImageList = this.CanvasToolbarImages;
            this.toolStripNodes.Items.AddRange(new System.Windows.Forms.ToolStripItem[] {
            this.toolStripBtnBToFront,
            this.toolStripBtnSToBack,
            this.toolStripBtnToForward,
            this.toolStripBtnSendBackwards,
            this.toolStripBtnGroup,
            this.toolStripBtnUnGroup});
            this.toolStripNodes.Location = new System.Drawing.Point(313, 0);
            this.toolStripNodes.Margin = new System.Windows.Forms.Padding(1);
            this.toolStripNodes.Name = "toolStripNodes";
            this.toolStripNodes.Padding = new System.Windows.Forms.Padding(1);
            this.toolStripNodes.RenderMode = System.Windows.Forms.ToolStripRenderMode.System;
            this.toolStripNodes.Size = new System.Drawing.Size(151, 25);
            this.toolStripNodes.TabIndex = 5;
            // 
            // toolStripBtnBToFront
            // 
            this.toolStripBtnBToFront.DisplayStyle = System.Windows.Forms.ToolStripItemDisplayStyle.Image;
            this.toolStripBtnBToFront.ImageIndex = 41;
            this.toolStripBtnBToFront.Name = "toolStripBtnBToFront";
            this.toolStripBtnBToFront.Size = new System.Drawing.Size(23, 20);
            this.toolStripBtnBToFront.Tag = "SID_BRING_FRONT";
            this.toolStripBtnBToFront.Text = "Bring To Front";
            this.toolStripBtnBToFront.Click += new System.EventHandler(this.toolStripBtnBToFront_Click);
            // 
            // toolStripBtnSToBack
            // 
            this.toolStripBtnSToBack.DisplayStyle = System.Windows.Forms.ToolStripItemDisplayStyle.Image;
            this.toolStripBtnSToBack.ImageIndex = 43;
            this.toolStripBtnSToBack.Name = "toolStripBtnSToBack";
            this.toolStripBtnSToBack.Size = new System.Drawing.Size(23, 20);
            this.toolStripBtnSToBack.Tag = "SID_SEND_BACK";
            this.toolStripBtnSToBack.Text = "Send To Back";
            this.toolStripBtnSToBack.Click += new System.EventHandler(this.toolStripBtnSToBack_Click);
            // 
            // toolStripBtnToForward
            // 
            this.toolStripBtnToForward.DisplayStyle = System.Windows.Forms.ToolStripItemDisplayStyle.Image;
            this.toolStripBtnToForward.ImageIndex = 42;
            this.toolStripBtnToForward.Name = "toolStripBtnToForward";
            this.toolStripBtnToForward.Size = new System.Drawing.Size(23, 20);
            this.toolStripBtnToForward.Tag = "SID_BRING_FORWARD";
            this.toolStripBtnToForward.Text = "Bring Forward";
            this.toolStripBtnToForward.Click += new System.EventHandler(this.toolStripBtnToForward_Click);
            // 
            // toolStripBtnSendBackwards
            // 
            this.toolStripBtnSendBackwards.DisplayStyle = System.Windows.Forms.ToolStripItemDisplayStyle.Image;
            this.toolStripBtnSendBackwards.ImageIndex = 43;
            this.toolStripBtnSendBackwards.Name = "toolStripBtnSendBackwards";
            this.toolStripBtnSendBackwards.Size = new System.Drawing.Size(23, 20);
            this.toolStripBtnSendBackwards.Tag = "SID_SEND_BACKWORD";
            this.toolStripBtnSendBackwards.Text = "Send Backward";
            this.toolStripBtnSendBackwards.Click += new System.EventHandler(this.toolStripBtnSendBackwards_Click);
            // 
            // toolStripBtnGroup
            // 
            this.toolStripBtnGroup.DisplayStyle = System.Windows.Forms.ToolStripItemDisplayStyle.Image;
            this.toolStripBtnGroup.ImageIndex = 14;
            this.toolStripBtnGroup.Name = "toolStripBtnGroup";
            this.toolStripBtnGroup.Size = new System.Drawing.Size(23, 20);
            this.toolStripBtnGroup.Tag = "GroupTool";
            this.toolStripBtnGroup.Text = "Group";
            this.toolStripBtnGroup.Click += new System.EventHandler(this.ToolActivate);
            // 
            // toolStripBtnUnGroup
            // 
            this.toolStripBtnUnGroup.DisplayStyle = System.Windows.Forms.ToolStripItemDisplayStyle.Image;
            this.toolStripBtnUnGroup.ImageIndex = 15;
            this.toolStripBtnUnGroup.Name = "toolStripBtnUnGroup";
            this.toolStripBtnUnGroup.Size = new System.Drawing.Size(23, 20);
            this.toolStripBtnUnGroup.Tag = "UngroupTool";
            this.toolStripBtnUnGroup.Text = "UnGroup";
            this.toolStripBtnUnGroup.Click += new System.EventHandler(this.ToolActivate);
            // 
            // toolStripNudgeTools
            // 
            this.toolStripNudgeTools.BackColor = System.Drawing.SystemColors.InactiveCaptionText;
            this.toolStripNudgeTools.Dock = System.Windows.Forms.DockStyle.None;
            this.toolStripNudgeTools.ImageList = this.smBarItemImages;
            this.toolStripNudgeTools.Items.AddRange(new System.Windows.Forms.ToolStripItem[] {
            this.toolStripBtnNudgeUp,
            this.toolStripBtnNudgeDown,
            this.toolStripBtnNudgeLeft,
            this.toolStripBtnNudgeRight});
            this.toolStripNudgeTools.Location = new System.Drawing.Point(464, 0);
            this.toolStripNudgeTools.Margin = new System.Windows.Forms.Padding(1);
            this.toolStripNudgeTools.Name = "toolStripNudgeTools";
            this.toolStripNudgeTools.Padding = new System.Windows.Forms.Padding(1);
            this.toolStripNudgeTools.RenderMode = System.Windows.Forms.ToolStripRenderMode.System;
            this.toolStripNudgeTools.Size = new System.Drawing.Size(105, 25);
            this.toolStripNudgeTools.TabIndex = 3;
            // 
            // toolStripBtnNudgeUp
            // 
            this.toolStripBtnNudgeUp.DisplayStyle = System.Windows.Forms.ToolStripItemDisplayStyle.Image;
            this.toolStripBtnNudgeUp.ImageIndex = 19;
            this.toolStripBtnNudgeUp.Name = "toolStripBtnNudgeUp";
            this.toolStripBtnNudgeUp.Size = new System.Drawing.Size(23, 20);
            this.toolStripBtnNudgeUp.Tag = "SID_NUDGE_UP";
            this.toolStripBtnNudgeUp.Text = "Nudge Up";
            this.toolStripBtnNudgeUp.Click += new System.EventHandler(this.toolStripBtnNudgeUp_Click);
            // 
            // toolStripBtnNudgeDown
            // 
            this.toolStripBtnNudgeDown.DisplayStyle = System.Windows.Forms.ToolStripItemDisplayStyle.Image;
            this.toolStripBtnNudgeDown.ImageIndex = 20;
            this.toolStripBtnNudgeDown.Name = "toolStripBtnNudgeDown";
            this.toolStripBtnNudgeDown.Size = new System.Drawing.Size(23, 20);
            this.toolStripBtnNudgeDown.Text = "Nudge Down";
            this.toolStripBtnNudgeDown.Click += new System.EventHandler(this.toolStripBtnNudgeDown_Click);
            // 
            // toolStripBtnNudgeLeft
            // 
            this.toolStripBtnNudgeLeft.DisplayStyle = System.Windows.Forms.ToolStripItemDisplayStyle.Image;
            this.toolStripBtnNudgeLeft.ImageIndex = 17;
            this.toolStripBtnNudgeLeft.Name = "toolStripBtnNudgeLeft";
            this.toolStripBtnNudgeLeft.Size = new System.Drawing.Size(23, 20);
            this.toolStripBtnNudgeLeft.Tag = "SID_NUDGE_LEFT";
            this.toolStripBtnNudgeLeft.Text = "Nudge Left";
            this.toolStripBtnNudgeLeft.Click += new System.EventHandler(this.toolStripBtnNudgeLeft_Click);
            // 
            // toolStripBtnNudgeRight
            // 
            this.toolStripBtnNudgeRight.DisplayStyle = System.Windows.Forms.ToolStripItemDisplayStyle.Image;
            this.toolStripBtnNudgeRight.ImageIndex = 18;
            this.toolStripBtnNudgeRight.Name = "toolStripBtnNudgeRight";
            this.toolStripBtnNudgeRight.Size = new System.Drawing.Size(23, 20);
            this.toolStripBtnNudgeRight.Tag = "SID_NUDGE_RIGHT";
            this.toolStripBtnNudgeRight.Text = "Nudge Right";
            this.toolStripBtnNudgeRight.Click += new System.EventHandler(this.toolStripBtnNudgeRight_Click);
            // 
            // toolStripDrawing
            // 
            this.toolStripDrawing.BackColor = System.Drawing.SystemColors.InactiveCaptionText;
            this.toolStripDrawing.Dock = System.Windows.Forms.DockStyle.None;
            this.toolStripDrawing.ImageList = this.CanvasToolbarImages;
            this.toolStripDrawing.Items.AddRange(new System.Windows.Forms.ToolStripItem[] {
            this.toolStripBtnLine,
            this.toolStripBtnRectangle,
            this.toolStripBtnEcllipse,
            this.toolStripBtnPolyLine,
            this.toolStripBtnCurve,
            this.toolStripBtnFormatPainter,
            this.toolStripBtnRRect});
            this.toolStripDrawing.Location = new System.Drawing.Point(569, 0);
            this.toolStripDrawing.Margin = new System.Windows.Forms.Padding(1);
            this.toolStripDrawing.Name = "toolStripDrawing";
            this.toolStripDrawing.Padding = new System.Windows.Forms.Padding(1);
            this.toolStripDrawing.RenderMode = System.Windows.Forms.ToolStripRenderMode.System;
            this.toolStripDrawing.Size = new System.Drawing.Size(174, 25);
            this.toolStripDrawing.TabIndex = 2;
            // 
            // toolStripBtnLine
            // 
            this.toolStripBtnLine.DisplayStyle = System.Windows.Forms.ToolStripItemDisplayStyle.Image;
            this.toolStripBtnLine.ImageIndex = 1;
            this.toolStripBtnLine.Name = "toolStripBtnLine";
            this.toolStripBtnLine.Size = new System.Drawing.Size(23, 20);
            this.toolStripBtnLine.Tag = "LineTool";
            this.toolStripBtnLine.Text = "Line";
            this.toolStripBtnLine.Click += new System.EventHandler(this.ToolActivate);
            // 
            // toolStripBtnRectangle
            // 
            this.toolStripBtnRectangle.DisplayStyle = System.Windows.Forms.ToolStripItemDisplayStyle.Image;
            this.toolStripBtnRectangle.ImageIndex = 4;
            this.toolStripBtnRectangle.Name = "toolStripBtnRectangle";
            this.toolStripBtnRectangle.Size = new System.Drawing.Size(23, 20);
            this.toolStripBtnRectangle.Tag = "RectangleTool";
            this.toolStripBtnRectangle.Text = "Rectangle";
            this.toolStripBtnRectangle.Click += new System.EventHandler(this.ToolActivate);
            // 
            // toolStripBtnEcllipse
            // 
            this.toolStripBtnEcllipse.DisplayStyle = System.Windows.Forms.ToolStripItemDisplayStyle.Image;
            this.toolStripBtnEcllipse.ImageIndex = 7;
            this.toolStripBtnEcllipse.Name = "toolStripBtnEcllipse";
            this.toolStripBtnEcllipse.Size = new System.Drawing.Size(23, 20);
            this.toolStripBtnEcllipse.Tag = "EllipseTool";
            this.toolStripBtnEcllipse.Text = "Ellipse";
            this.toolStripBtnEcllipse.Click += new System.EventHandler(this.ToolActivate);
            // 
            // toolStripBtnPolyLine
            // 
            this.toolStripBtnPolyLine.DisplayStyle = System.Windows.Forms.ToolStripItemDisplayStyle.Image;
            this.toolStripBtnPolyLine.ImageIndex = 6;
            this.toolStripBtnPolyLine.Name = "toolStripBtnPolyLine";
            this.toolStripBtnPolyLine.Size = new System.Drawing.Size(23, 20);
            this.toolStripBtnPolyLine.Tag = "PolyLineTool";
            this.toolStripBtnPolyLine.Text = "Polyline";
            this.toolStripBtnPolyLine.Click += new System.EventHandler(this.ToolActivate);
            // 
            // toolStripBtnCurve
            // 
            this.toolStripBtnCurve.DisplayStyle = System.Windows.Forms.ToolStripItemDisplayStyle.Image;
            this.toolStripBtnCurve.ImageIndex = 9;
            this.toolStripBtnCurve.Name = "toolStripBtnCurve";
            this.toolStripBtnCurve.Size = new System.Drawing.Size(23, 20);
            this.toolStripBtnCurve.Tag = "CurveTool";
            this.toolStripBtnCurve.Text = "Curve";
            this.toolStripBtnCurve.Click += new System.EventHandler(this.ToolActivate);
            // 
            // toolStripBtnFormatPainter
            // 
            this.toolStripBtnFormatPainter.DisplayStyle = System.Windows.Forms.ToolStripItemDisplayStyle.Image;
            this.toolStripBtnFormatPainter.ImageIndex = 62;
            this.toolStripBtnFormatPainter.Name = "toolStripBtnFormatPainter";
            this.toolStripBtnFormatPainter.Size = new System.Drawing.Size(23, 20);
            this.toolStripBtnFormatPainter.Tag = "SID_FORMAT_PAINTER";
            this.toolStripBtnFormatPainter.Text = "Format Painter";
            this.toolStripBtnFormatPainter.Click += new System.EventHandler(this.toolStripBtnFormatPainter_Click);
            // 
            // toolStripBtnRRect
            // 
            this.toolStripBtnRRect.DisplayStyle = System.Windows.Forms.ToolStripItemDisplayStyle.Image;
            this.toolStripBtnRRect.ImageIndex = 5;
            this.toolStripBtnRRect.Name = "toolStripBtnRRect";
            this.toolStripBtnRRect.Size = new System.Drawing.Size(23, 20);
            this.toolStripBtnRRect.Tag = "RoundRectTool";
            this.toolStripBtnRRect.Text = "Rounded Rectangle";
            this.toolStripBtnRRect.Click += new System.EventHandler(this.ToolActivate);
            // 
            // toolStripView
            // 
            this.toolStripView.BackColor = System.Drawing.SystemColors.InactiveCaptionText;
            this.toolStripView.Dock = System.Windows.Forms.DockStyle.None;
            this.toolStripView.ImageList = this.CanvasToolbarImages;
            this.toolStripView.Items.AddRange(new System.Windows.Forms.ToolStripItem[] {
            this.toolStripBtnSelect,
            this.toolStripBtnPan,
            this.toolStripBtnShowGrid,
            this.toolStripBtnSnapToGrid,
            this.toolStripBtnZoom,
            this.toolStripCmbMagnify});
            this.toolStripView.Location = new System.Drawing.Point(743, 0);
            this.toolStripView.Margin = new System.Windows.Forms.Padding(1);
            this.toolStripView.Name = "toolStripView";
            this.toolStripView.Padding = new System.Windows.Forms.Padding(1);
            this.toolStripView.RenderMode = System.Windows.Forms.ToolStripRenderMode.System;
            this.toolStripView.Size = new System.Drawing.Size(57, 27);
            this.toolStripView.TabIndex = 8;
            // 
            // toolStripBtnSelect
            // 
            this.toolStripBtnSelect.DisplayStyle = System.Windows.Forms.ToolStripItemDisplayStyle.Image;
            this.toolStripBtnSelect.ImageIndex = 0;
            this.toolStripBtnSelect.Name = "toolStripBtnSelect";
            this.toolStripBtnSelect.Size = new System.Drawing.Size(23, 22);
            this.toolStripBtnSelect.Tag = "SelectTool";
            this.toolStripBtnSelect.Text = "Select";
            this.toolStripBtnSelect.Click += new System.EventHandler(this.ToolActivate);
            // 
            // toolStripBtnPan
            // 
            this.toolStripBtnPan.DisplayStyle = System.Windows.Forms.ToolStripItemDisplayStyle.Image;
            this.toolStripBtnPan.ImageIndex = 16;
            this.toolStripBtnPan.Name = "toolStripBtnPan";
            this.toolStripBtnPan.Size = new System.Drawing.Size(23, 20);
            this.toolStripBtnPan.Tag = "PanTool";
            this.toolStripBtnPan.Text = "Pan";
            this.toolStripBtnPan.Click += new System.EventHandler(this.ToolActivate);
            // 
            // toolStripBtnShowGrid
            // 
            this.toolStripBtnShowGrid.DisplayStyle = System.Windows.Forms.ToolStripItemDisplayStyle.Image;
            this.toolStripBtnShowGrid.ImageIndex = 18;
            this.toolStripBtnShowGrid.Name = "toolStripBtnShowGrid";
            this.toolStripBtnShowGrid.Size = new System.Drawing.Size(23, 20);
            this.toolStripBtnShowGrid.Tag = "SID_SHOW_GRID";
            this.toolStripBtnShowGrid.Text = "Show Grid";
            this.toolStripBtnShowGrid.Click += new System.EventHandler(this.toolStripBtnShowGrid_Click);
            // 
            // toolStripBtnSnapToGrid
            // 
            this.toolStripBtnSnapToGrid.DisplayStyle = System.Windows.Forms.ToolStripItemDisplayStyle.Image;
            this.toolStripBtnSnapToGrid.ImageIndex = 19;
            this.toolStripBtnSnapToGrid.Name = "toolStripBtnSnapToGrid";
            this.toolStripBtnSnapToGrid.Size = new System.Drawing.Size(23, 20);
            this.toolStripBtnSnapToGrid.Tag = "SID_SNAP_GRID";
            this.toolStripBtnSnapToGrid.Text = "Snap To Grid";
            this.toolStripBtnSnapToGrid.Click += new System.EventHandler(this.toolStripBtnSnapToGrid_Click);
            // 
            // toolStripBtnZoom
            // 
            this.toolStripBtnZoom.DisplayStyle = System.Windows.Forms.ToolStripItemDisplayStyle.Image;
            this.toolStripBtnZoom.ImageIndex = 17;
            this.toolStripBtnZoom.Name = "toolStripBtnZoom";
            this.toolStripBtnZoom.Size = new System.Drawing.Size(23, 20);
            this.toolStripBtnZoom.Tag = "ZoomTool";
            this.toolStripBtnZoom.Text = "Zoom";
            this.toolStripBtnZoom.Click += new System.EventHandler(this.ToolActivate);
            // 
            // toolStripCmbMagnify
            // 
            this.toolStripCmbMagnify.AutoCompleteMode = System.Windows.Forms.AutoCompleteMode.SuggestAppend;
            this.toolStripCmbMagnify.AutoCompleteSource = System.Windows.Forms.AutoCompleteSource.CustomSource;
            this.toolStripCmbMagnify.FlatStyle = System.Windows.Forms.FlatStyle.Standard;
            this.toolStripCmbMagnify.IntegralHeight = false;
            this.toolStripCmbMagnify.Items.AddRange(new object[] {
            "100%",
            "150%",
            "200%",
            "25%",
            "300%",
            "400%",
            "50%",
            "500%",
            "75%"});
            this.toolStripCmbMagnify.Name = "toolStripCmbMagnify";
            this.toolStripCmbMagnify.Size = new System.Drawing.Size(121, 21);
            this.toolStripCmbMagnify.Text = "100%";
            this.toolStripCmbMagnify.SelectedIndexChanged += new System.EventHandler(this.toolStripCmbMagnify_SelectedIndexChanged);
            this.toolStripCmbMagnify.LostFocus += new System.EventHandler(this.toolStripCmbMagnify_LostFocus);
            this.toolStripCmbMagnify.Click += new System.EventHandler(this.toolStripCmbMagnify_Click);
            // 
            // toolStripConnectors
            // 
            this.toolStripConnectors.BackColor = System.Drawing.SystemColors.InactiveCaptionText;
            this.toolStripConnectors.Dock = System.Windows.Forms.DockStyle.None;
            this.toolStripConnectors.ImageList = this.CanvasToolbarImages;
            this.toolStripConnectors.Items.AddRange(new System.Windows.Forms.ToolStripItem[] {
            this.toolStripBtnConnectors,
            this.toolStripBtnOrthoConn,
            this.toolStripBtnDirectedConn,
            this.toolStripBtnVerticalConn,
            this.toolStripBtnRightAngleConn,
            this.toolStripBtnArcConn});
            this.toolStripConnectors.Location = new System.Drawing.Point(3, 27);
            this.toolStripConnectors.Name = "toolStripConnectors";
            this.toolStripConnectors.Padding = new System.Windows.Forms.Padding(1);
            this.toolStripConnectors.RenderMode = System.Windows.Forms.ToolStripRenderMode.System;
            this.toolStripConnectors.Size = new System.Drawing.Size(151, 25);
            this.toolStripConnectors.TabIndex = 6;
            // 
            // toolStripBtnConnectors
            // 
            this.toolStripBtnConnectors.DisplayStyle = System.Windows.Forms.ToolStripItemDisplayStyle.Image;
            this.toolStripBtnConnectors.ImageIndex = 44;
            this.toolStripBtnConnectors.Name = "toolStripBtnConnectors";
            this.toolStripBtnConnectors.Size = new System.Drawing.Size(23, 20);
            this.toolStripBtnConnectors.Tag = "SID_CONNECTORS";
            this.toolStripBtnConnectors.Text = "Connector";
            this.toolStripBtnConnectors.Click += new System.EventHandler(this.toolStripBtnConnectors_Click);
            // 
            // toolStripBtnOrthoConn
            // 
            this.toolStripBtnOrthoConn.DisplayStyle = System.Windows.Forms.ToolStripItemDisplayStyle.Image;
            this.toolStripBtnOrthoConn.ImageIndex = 45;
            this.toolStripBtnOrthoConn.Name = "toolStripBtnOrthoConn";
            this.toolStripBtnOrthoConn.Size = new System.Drawing.Size(23, 20);
            this.toolStripBtnOrthoConn.Tag = "SID_ORTHOGONAL_CONNECTOR";
            this.toolStripBtnOrthoConn.Text = "Orthogonal Connector";
            this.toolStripBtnOrthoConn.Click += new System.EventHandler(this.toolStripBtnOrthoConn_Click);
            // 
            // toolStripBtnDirectedConn
            // 
            this.toolStripBtnDirectedConn.DisplayStyle = System.Windows.Forms.ToolStripItemDisplayStyle.Image;
            this.toolStripBtnDirectedConn.ImageIndex = 46;
            this.toolStripBtnDirectedConn.Name = "toolStripBtnDirectedConn";
            this.toolStripBtnDirectedConn.Size = new System.Drawing.Size(23, 20);
            this.toolStripBtnDirectedConn.Tag = "SID_DIRCT_CONNECTOR";
            this.toolStripBtnDirectedConn.Text = "Direct Connector";
            this.toolStripBtnDirectedConn.Click += new System.EventHandler(this.toolStripBtnDirectedConn_Click);
            // 
            // toolStripBtnVerticalConn
            // 
            this.toolStripBtnVerticalConn.DisplayStyle = System.Windows.Forms.ToolStripItemDisplayStyle.Image;
            this.toolStripBtnVerticalConn.ImageIndex = 61;
            this.toolStripBtnVerticalConn.Name = "toolStripBtnVerticalConn";
            this.toolStripBtnVerticalConn.Size = new System.Drawing.Size(23, 20);
            this.toolStripBtnVerticalConn.Tag = "SID_VERTICAL_CONNECTOR";
            this.toolStripBtnVerticalConn.Text = "Vertical Connector";
            this.toolStripBtnVerticalConn.Click += new System.EventHandler(this.toolStripBtnVerticalConn_Click);
            // 
            // toolStripBtnRightAngleConn
            // 
            this.toolStripBtnRightAngleConn.DisplayStyle = System.Windows.Forms.ToolStripItemDisplayStyle.Image;
            this.toolStripBtnRightAngleConn.ImageIndex = 60;
            this.toolStripBtnRightAngleConn.ImageTransparentColor = System.Drawing.Color.Magenta;
            this.toolStripBtnRightAngleConn.Name = "toolStripBtnRightAngleConn";
            this.toolStripBtnRightAngleConn.Size = new System.Drawing.Size(23, 20);
            this.toolStripBtnRightAngleConn.Tag = "Right Angle Connector";
            this.toolStripBtnRightAngleConn.Text = "Right Angle Link";
            this.toolStripBtnRightAngleConn.Click += new System.EventHandler(this.toolStripBtnRightAngleConn_Click);
            // 
            // toolStripBtnArcConn
            // 
            this.toolStripBtnArcConn.DisplayStyle = System.Windows.Forms.ToolStripItemDisplayStyle.Image;
            this.toolStripBtnArcConn.ImageIndex = 47;
            this.toolStripBtnArcConn.Name = "toolStripBtnArcConn";
            this.toolStripBtnArcConn.Size = new System.Drawing.Size(23, 20);
            this.toolStripBtnArcConn.Tag = "SID_ARCH_CONNECTOR";
            this.toolStripBtnArcConn.Text = "Arch Connector";
            this.toolStripBtnArcConn.Click += new System.EventHandler(this.toolStripBtnArcConn_Click);
            // 
            // toolStripRotate
            // 
            this.toolStripRotate.BackColor = System.Drawing.SystemColors.InactiveCaptionText;
            this.toolStripRotate.Dock = System.Windows.Forms.DockStyle.None;
            this.toolStripRotate.ImageList = this.CanvasToolbarImages;
            this.toolStripRotate.Items.AddRange(new System.Windows.Forms.ToolStripItem[] {
            this.toolStripBtnRotate,
            this.toolStripBtnLeftRotate,
            this.toolStripBtnRightRotate,
            this.toolStripBtnFlipVertical,
            this.toolStripBtnFlipHorizontal});
            this.toolStripRotate.Location = new System.Drawing.Point(154, 27);
            this.toolStripRotate.Margin = new System.Windows.Forms.Padding(1);
            this.toolStripRotate.Name = "toolStripRotate";
            this.toolStripRotate.Padding = new System.Windows.Forms.Padding(1);
            this.toolStripRotate.RenderMode = System.Windows.Forms.ToolStripRenderMode.System;
            this.toolStripRotate.Size = new System.Drawing.Size(128, 25);
            this.toolStripRotate.TabIndex = 7;
            // 
            // toolStripBtnRotate
            // 
            this.toolStripBtnRotate.DisplayStyle = System.Windows.Forms.ToolStripItemDisplayStyle.Image;
            this.toolStripBtnRotate.ImageIndex = 35;
            this.toolStripBtnRotate.Name = "toolStripBtnRotate";
            this.toolStripBtnRotate.Size = new System.Drawing.Size(23, 20);
            this.toolStripBtnRotate.Tag = "RotateTool";
            this.toolStripBtnRotate.Text = "Rotate";
            this.toolStripBtnRotate.Click += new System.EventHandler(this.ToolActivate);
            // 
            // toolStripBtnLeftRotate
            // 
            this.toolStripBtnLeftRotate.DisplayStyle = System.Windows.Forms.ToolStripItemDisplayStyle.Image;
            this.toolStripBtnLeftRotate.ImageIndex = 36;
            this.toolStripBtnLeftRotate.Name = "toolStripBtnLeftRotate";
            this.toolStripBtnLeftRotate.Size = new System.Drawing.Size(23, 20);
            this.toolStripBtnLeftRotate.Tag = "SID_ROTATE_LEFT";
            this.toolStripBtnLeftRotate.Text = "Rotate Left";
            this.toolStripBtnLeftRotate.Click += new System.EventHandler(this.toolStripBtnLeftRotate_Click);
            // 
            // toolStripBtnRightRotate
            // 
            this.toolStripBtnRightRotate.DisplayStyle = System.Windows.Forms.ToolStripItemDisplayStyle.Image;
            this.toolStripBtnRightRotate.ImageIndex = 37;
            this.toolStripBtnRightRotate.Name = "toolStripBtnRightRotate";
            this.toolStripBtnRightRotate.Size = new System.Drawing.Size(23, 20);
            this.toolStripBtnRightRotate.Tag = "SID_ROTATE_RIGHT";
            this.toolStripBtnRightRotate.Text = "Rotate Right";
            this.toolStripBtnRightRotate.Click += new System.EventHandler(this.toolStripBtnRightRotate_Click);
            // 
            // toolStripBtnFlipVertical
            // 
            this.toolStripBtnFlipVertical.DisplayStyle = System.Windows.Forms.ToolStripItemDisplayStyle.Image;
            this.toolStripBtnFlipVertical.ImageIndex = 39;
            this.toolStripBtnFlipVertical.Name = "toolStripBtnFlipVertical";
            this.toolStripBtnFlipVertical.Size = new System.Drawing.Size(23, 20);
            this.toolStripBtnFlipVertical.Tag = "SID_FLIP_VERTICAL";
            this.toolStripBtnFlipVertical.Text = "Flip Vertical";
            this.toolStripBtnFlipVertical.Click += new System.EventHandler(this.toolStripBtnFlipVertical_Click);
            // 
            // toolStripBtnFlipHorizontal
            // 
            this.toolStripBtnFlipHorizontal.DisplayStyle = System.Windows.Forms.ToolStripItemDisplayStyle.Image;
            this.toolStripBtnFlipHorizontal.ImageIndex = 38;
            this.toolStripBtnFlipHorizontal.Name = "toolStripBtnFlipHorizontal";
            this.toolStripBtnFlipHorizontal.Size = new System.Drawing.Size(23, 20);
            this.toolStripBtnFlipHorizontal.Tag = "SID_FLIP_HORIZONTEL";
            this.toolStripBtnFlipHorizontal.Text = "Flip Horizontal";
            this.toolStripBtnFlipHorizontal.Click += new System.EventHandler(this.toolStripBtnFlipHorizontal_Click);
            // 
            // toolStripCanvas
            // 
            this.toolStripCanvas.BackColor = System.Drawing.SystemColors.InactiveCaptionText;
            this.toolStripCanvas.Dock = System.Windows.Forms.DockStyle.None;
            this.toolStripCanvas.ImageList = this.CanvasToolbarImages;
            this.toolStripCanvas.Items.AddRange(new System.Windows.Forms.ToolStripItem[] {
            this.toolStripCmbFontFamily,
            this.toolStripCmbPointSize,
            this.toolStripBtnRichText,
            this.toolStripBtnBold,
            this.toolStripBtnUnderLine,
            this.toolStripBtnItalic,
            this.toolStripBtnTLeft,
            this.toolStripBtnTCenter,
            this.toolStripBtnTRight,
            this.toolStripBtnTColor});
            this.toolStripCanvas.Location = new System.Drawing.Point(282, 27);
            this.toolStripCanvas.Margin = new System.Windows.Forms.Padding(1);
            this.toolStripCanvas.Name = "toolStripCanvas";
            this.toolStripCanvas.Padding = new System.Windows.Forms.Padding(1);
            this.toolStripCanvas.RenderMode = System.Windows.Forms.ToolStripRenderMode.System;
            this.toolStripCanvas.Size = new System.Drawing.Size(418, 25);
            this.toolStripCanvas.TabIndex = 9;
            // 
            // toolStripCmbFontFamily
            // 
            this.toolStripCmbFontFamily.AutoCompleteSource = System.Windows.Forms.AutoCompleteSource.CustomSource;
            this.toolStripCmbFontFamily.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
            this.toolStripCmbFontFamily.FlatStyle = System.Windows.Forms.FlatStyle.Standard;
            this.toolStripCmbFontFamily.Name = "toolStripCmbFontFamily";
            this.toolStripCmbFontFamily.Size = new System.Drawing.Size(121, 23);
            this.toolStripCmbFontFamily.Tag = "SID_FON_FAMILY";
            // 
            // toolStripCmbPointSize
            // 
            this.toolStripCmbPointSize.AutoCompleteSource = System.Windows.Forms.AutoCompleteSource.CustomSource;
            this.toolStripCmbPointSize.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
            this.toolStripCmbPointSize.FlatStyle = System.Windows.Forms.FlatStyle.Standard;
            this.toolStripCmbPointSize.Name = "toolStripCmbPointSize";
            this.toolStripCmbPointSize.Size = new System.Drawing.Size(121, 23);
            this.toolStripCmbPointSize.Tag = "SID_POINT_SIZE";
            // 
            // toolStripBtnRichText
            // 
            this.toolStripBtnRichText.DisplayStyle = System.Windows.Forms.ToolStripItemDisplayStyle.Image;
            this.toolStripBtnRichText.ImageIndex = 48;
            this.toolStripBtnRichText.Name = "toolStripBtnRichText";
            this.toolStripBtnRichText.Size = new System.Drawing.Size(23, 20);
            this.toolStripBtnRichText.Tag = "RichTextTool";
            this.toolStripBtnRichText.Text = "Rich Text";
            this.toolStripBtnRichText.Click += new System.EventHandler(this.ToolActivate);
            // 
            // toolStripBtnBold
            // 
            this.toolStripBtnBold.DisplayStyle = System.Windows.Forms.ToolStripItemDisplayStyle.Image;
            this.toolStripBtnBold.ImageIndex = 49;
            this.toolStripBtnBold.Name = "toolStripBtnBold";
            this.toolStripBtnBold.Size = new System.Drawing.Size(23, 20);
            this.toolStripBtnBold.Tag = "SID_BOLD";
            this.toolStripBtnBold.Text = "Bold";
            this.toolStripBtnBold.Click += new System.EventHandler(this.toolStripBtnBold_Click);
            // 
            // toolStripBtnUnderLine
            // 
            this.toolStripBtnUnderLine.DisplayStyle = System.Windows.Forms.ToolStripItemDisplayStyle.Image;
            this.toolStripBtnUnderLine.ImageIndex = 51;
            this.toolStripBtnUnderLine.Name = "toolStripBtnUnderLine";
            this.toolStripBtnUnderLine.Size = new System.Drawing.Size(23, 20);
            this.toolStripBtnUnderLine.Tag = "SID_UNDERLINE";
            this.toolStripBtnUnderLine.Text = "Under Line";
            this.toolStripBtnUnderLine.Click += new System.EventHandler(this.toolStripBtnUnderLine_Click);
            // 
            // toolStripBtnItalic
            // 
            this.toolStripBtnItalic.DisplayStyle = System.Windows.Forms.ToolStripItemDisplayStyle.Image;
            this.toolStripBtnItalic.ImageIndex = 50;
            this.toolStripBtnItalic.Name = "toolStripBtnItalic";
            this.toolStripBtnItalic.Size = new System.Drawing.Size(23, 20);
            this.toolStripBtnItalic.Tag = "SID_ITALIC";
            this.toolStripBtnItalic.Text = "Italic";
            this.toolStripBtnItalic.Click += new System.EventHandler(this.toolStripBtnItalic_Click);
            // 
            // toolStripBtnTLeft
            // 
            this.toolStripBtnTLeft.DisplayStyle = System.Windows.Forms.ToolStripItemDisplayStyle.Image;
            this.toolStripBtnTLeft.ImageIndex = 52;
            this.toolStripBtnTLeft.Name = "toolStripBtnTLeft";
            this.toolStripBtnTLeft.Size = new System.Drawing.Size(23, 20);
            this.toolStripBtnTLeft.Tag = "SID_ALIGH_TEXT_LEFT";
            this.toolStripBtnTLeft.Text = "Align Text Left";
            this.toolStripBtnTLeft.Click += new System.EventHandler(this.toolStripBtnTLeft_Click);
            // 
            // toolStripBtnTCenter
            // 
            this.toolStripBtnTCenter.DisplayStyle = System.Windows.Forms.ToolStripItemDisplayStyle.Image;
            this.toolStripBtnTCenter.ImageIndex = 53;
            this.toolStripBtnTCenter.Name = "toolStripBtnTCenter";
            this.toolStripBtnTCenter.Size = new System.Drawing.Size(23, 20);
            this.toolStripBtnTCenter.Tag = "SID_CENTER_ALIGN";
            this.toolStripBtnTCenter.Text = "Center Align";
            this.toolStripBtnTCenter.Click += new System.EventHandler(this.toolStripBtnTCenter_Click);
            // 
            // toolStripBtnTRight
            // 
            this.toolStripBtnTRight.DisplayStyle = System.Windows.Forms.ToolStripItemDisplayStyle.Image;
            this.toolStripBtnTRight.ImageIndex = 54;
            this.toolStripBtnTRight.ImageTransparentColor = System.Drawing.Color.Magenta;
            this.toolStripBtnTRight.Name = "toolStripBtnTRight";
            this.toolStripBtnTRight.Size = new System.Drawing.Size(23, 20);
            this.toolStripBtnTRight.Tag = "SID_ALIGN_TEXT_RIGHT";
            this.toolStripBtnTRight.Text = "Align Text Right";
            this.toolStripBtnTRight.Click += new System.EventHandler(this.toolStripBtnTRight_Click);
            // 
            // toolStripBtnTColor
            // 
            this.toolStripBtnTColor.DisplayStyle = System.Windows.Forms.ToolStripItemDisplayStyle.Image;
            this.toolStripBtnTColor.ImageIndex = 55;
            this.toolStripBtnTColor.Name = "toolStripBtnTColor";
            this.toolStripBtnTColor.Size = new System.Drawing.Size(23, 20);
            this.toolStripBtnTColor.Tag = "SID_TEXT_COLOR";
            this.toolStripBtnTColor.Text = "Text Color";
            this.toolStripBtnTColor.Click += new System.EventHandler(this.toolStripBtnTColor_Click);
            // 
            // toolStripMarkers
            // 
            this.toolStripMarkers.BackColor = System.Drawing.SystemColors.InactiveCaptionText;
            this.toolStripMarkers.Dock = System.Windows.Forms.DockStyle.None;
            this.toolStripMarkers.ImageList = this.imgLstMarkers;
            this.toolStripMarkers.Items.AddRange(new System.Windows.Forms.ToolStripItem[] {
            this.toolStripBtnHMarker,
            this.toolStripBtnVMarker,
            this.toolStripBtnHVMarkerEdit
            });
            this.toolStripMarkers.Location = new System.Drawing.Point(750, 27);
            this.toolStripMarkers.Margin = new System.Windows.Forms.Padding(1);
            this.toolStripMarkers.Name = "toolStripMarkers";
            this.toolStripMarkers.Padding = new System.Windows.Forms.Padding(1);
            this.toolStripMarkers.RenderMode = System.Windows.Forms.ToolStripRenderMode.System;
            this.toolStripMarkers.Size = new System.Drawing.Size(50, 25);
            this.toolStripMarkers.TabIndex = 10;
            // 
            // imgLstMarkers
            // 
            this.imgLstMarkers.ImageStream = ((System.Windows.Forms.ImageListStreamer)(resources.GetObject("imgLstMarkers.ImageStream")));
            this.imgLstMarkers.TransparentColor = System.Drawing.Color.Transparent;
            this.imgLstMarkers.Images.SetKeyName(0, "hsplit.PNG");
            this.imgLstMarkers.Images.SetKeyName(1, "vsplit.PNG");
            this.imgLstMarkers.Images.SetKeyName(2, "hvsplitEdt.PNG");
            // 
            // toolStripBtnHMarker
            // 
            this.toolStripBtnHMarker.DisplayStyle = System.Windows.Forms.ToolStripItemDisplayStyle.Image;
            this.toolStripBtnHMarker.ImageIndex = 1;
            this.toolStripBtnHMarker.Name = "toolStripBtnHMarker";
            this.toolStripBtnHMarker.Size = new System.Drawing.Size(23, 20);
            this.toolStripBtnHMarker.Tag = "SID_HMARKER";
            this.toolStripBtnHMarker.Text = "Horizontal Marker";
            this.toolStripBtnHMarker.Click += new System.EventHandler(this.toolStripBtnHMarker_Click);
            // 
            // toolStripBtnVMarker
            // 
            this.toolStripBtnVMarker.DisplayStyle = System.Windows.Forms.ToolStripItemDisplayStyle.Image;
            this.toolStripBtnVMarker.ImageIndex = 0;
            this.toolStripBtnVMarker.Name = "toolStripBtnVMarker";
            this.toolStripBtnVMarker.Size = new System.Drawing.Size(23, 20);
            this.toolStripBtnVMarker.Tag = "SID_VMARKER";
            this.toolStripBtnVMarker.Text = "Vertical Marker";
            this.toolStripBtnVMarker.Click += new System.EventHandler(this.toolStripBtnVMarker_Click);
            // 
            // toolStripBtnHVMarkerEdit
            // 
            this.toolStripBtnHVMarkerEdit.DisplayStyle = System.Windows.Forms.ToolStripItemDisplayStyle.Image;
            this.toolStripBtnHVMarkerEdit.ImageIndex = 2;
            this.toolStripBtnHVMarkerEdit.Name = "toolStripBtnHVMarkerEdit";
            this.toolStripBtnHVMarkerEdit.Size = new System.Drawing.Size(23, 20);
            this.toolStripBtnHVMarkerEdit.Tag = "SID_MARKEREDIT";
            this.toolStripBtnHVMarkerEdit.Text = "&Edit Markers";
            this.toolStripBtnHVMarkerEdit.Click += new System.EventHandler(this.toolStripBtnHVMarkerEdit_Click);
           
            // 
            // toolStripAlign
            // 
            this.toolStripAlign.BackColor = System.Drawing.SystemColors.InactiveCaptionText;
            this.toolStripAlign.Dock = System.Windows.Forms.DockStyle.None;
            this.toolStripAlign.ImageList = this.smBarItemImages;
            this.toolStripAlign.Items.AddRange(new System.Windows.Forms.ToolStripItem[] {
            this.toolStripBtnAlignLeft,
            this.toolStripBtnAlignCenter,
            this.toolStripBtnAlignRight,
            this.toolStripBtnAlignTop,
            this.toolStripBtnAlignMiddle,
            this.toolStripBtnAlignBottom});
            this.toolStripAlign.Location = new System.Drawing.Point(700, 27);
            this.toolStripAlign.Margin = new System.Windows.Forms.Padding(1);
            this.toolStripAlign.Name = "toolStripAlign";
            this.toolStripAlign.Padding = new System.Windows.Forms.Padding(1);
            this.toolStripAlign.RenderMode = System.Windows.Forms.ToolStripRenderMode.System;
            this.toolStripAlign.Size = new System.Drawing.Size(50, 25);
            this.toolStripAlign.TabIndex = 4;
            // 
            // toolStripBtnAlignLeft
            // 
            this.toolStripBtnAlignLeft.DisplayStyle = System.Windows.Forms.ToolStripItemDisplayStyle.Image;
            this.toolStripBtnAlignLeft.ImageIndex = 21;
            this.toolStripBtnAlignLeft.Name = "toolStripBtnAlignLeft";
            this.toolStripBtnAlignLeft.Size = new System.Drawing.Size(23, 20);
            this.toolStripBtnAlignLeft.Tag = "SID_ALIGN_LEFT";
            this.toolStripBtnAlignLeft.Text = "Align Text Left";
            this.toolStripBtnAlignLeft.Click += new System.EventHandler(this.toolStripBtnAlignLeft_Click);
            // 
            // toolStripBtnAlignCenter
            // 
            this.toolStripBtnAlignCenter.DisplayStyle = System.Windows.Forms.ToolStripItemDisplayStyle.Image;
            this.toolStripBtnAlignCenter.ImageIndex = 25;
            this.toolStripBtnAlignCenter.Name = "toolStripBtnAlignCenter";
            this.toolStripBtnAlignCenter.Size = new System.Drawing.Size(23, 20);
            this.toolStripBtnAlignCenter.Tag = "SID_ALIGN_CENTER";
            this.toolStripBtnAlignCenter.Text = "Align Center";
            this.toolStripBtnAlignCenter.Click += new System.EventHandler(this.toolStripBtnAlignCenter_Click);
            // 
            // toolStripBtnAlignRight
            // 
            this.toolStripBtnAlignRight.DisplayStyle = System.Windows.Forms.ToolStripItemDisplayStyle.Image;
            this.toolStripBtnAlignRight.ImageIndex = 22;
            this.toolStripBtnAlignRight.Name = "toolStripBtnAlignRight";
            this.toolStripBtnAlignRight.Size = new System.Drawing.Size(23, 20);
            this.toolStripBtnAlignRight.Tag = "SID_ALIGN_RIGHT";
            this.toolStripBtnAlignRight.Text = "Align Right";
            this.toolStripBtnAlignRight.Click += new System.EventHandler(this.toolStripBtnAlignRight_Click);
            // 
            // toolStripBtnAlignTop
            // 
            this.toolStripBtnAlignTop.DisplayStyle = System.Windows.Forms.ToolStripItemDisplayStyle.Image;
            this.toolStripBtnAlignTop.ImageIndex = 23;
            this.toolStripBtnAlignTop.Name = "toolStripBtnAlignTop";
            this.toolStripBtnAlignTop.Size = new System.Drawing.Size(23, 20);
            this.toolStripBtnAlignTop.Tag = "SID_ALIGN_TOP";
            this.toolStripBtnAlignTop.Text = "Align Top";
            this.toolStripBtnAlignTop.Click += new System.EventHandler(this.toolStripBtnAlignTop_Click);
            // 
            // toolStripBtnAlignMiddle
            // 
            this.toolStripBtnAlignMiddle.DisplayStyle = System.Windows.Forms.ToolStripItemDisplayStyle.Image;
            this.toolStripBtnAlignMiddle.ImageIndex = 26;
            this.toolStripBtnAlignMiddle.Name = "toolStripBtnAlignMiddle";
            this.toolStripBtnAlignMiddle.Size = new System.Drawing.Size(23, 20);
            this.toolStripBtnAlignMiddle.Tag = "SID_ALIGN_MIDDLE";
            this.toolStripBtnAlignMiddle.Text = "Align Middle";
            this.toolStripBtnAlignMiddle.Click += new System.EventHandler(this.toolStripBtnAlignMiddle_Click);
            // 
            // toolStripBtnAlignBottom
            // 
            this.toolStripBtnAlignBottom.DisplayStyle = System.Windows.Forms.ToolStripItemDisplayStyle.Image;
            this.toolStripBtnAlignBottom.ImageIndex = 24;
            this.toolStripBtnAlignBottom.Name = "toolStripBtnAlignBottom";
            this.toolStripBtnAlignBottom.Size = new System.Drawing.Size(23, 20);
            this.toolStripBtnAlignBottom.Tag = "SID_ALIGN_BOTTOM";
            this.toolStripBtnAlignBottom.Text = "Align Bottom";
            this.toolStripBtnAlignBottom.Click += new System.EventHandler(this.toolStripBtnAlignBottom_Click);
            // 
            // splitter1
            // 
            this.splitter1.Dock = System.Windows.Forms.DockStyle.Top;
            this.splitter1.Location = new System.Drawing.Point(0, 52);
            this.splitter1.Name = "splitter1";
            this.splitter1.Size = new System.Drawing.Size(800, 3);
            this.splitter1.TabIndex = 1;
            this.splitter1.TabStop = false;
            // 
            // dcPanel
            // 
            this.dcPanel.BackColor = System.Drawing.Color.Transparent;
            this.dcPanel.Controls.Add(this.pnlCanvasHeader);
            this.dcPanel.Controls.Add(this.tabControlAdv1);
            this.dcPanel.Location = new System.Drawing.Point(190, 59);
            this.dcPanel.Name = "dcPanel";
            this.dcPanel.Size = new System.Drawing.Size(464, 480);
            this.dcPanel.TabIndex = 5;
            // 
            // pnlCanvasHeader
            // 
            this.pnlCanvasHeader.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
            this.pnlCanvasHeader.BackColor = System.Drawing.Color.Transparent;
            this.pnlCanvasHeader.Controls.Add(this.btnClose);
            this.pnlCanvasHeader.Controls.Add(this.btnMoveRight);
            this.pnlCanvasHeader.Controls.Add(this.btnMoveLeft);
            this.pnlCanvasHeader.ForeColor = System.Drawing.Color.Transparent;
            this.pnlCanvasHeader.Location = new System.Drawing.Point(416, 0);
            this.pnlCanvasHeader.Name = "pnlCanvasHeader";
            this.pnlCanvasHeader.Size = new System.Drawing.Size(56, 24);
            this.pnlCanvasHeader.TabIndex = 16;
            // 
            // btnClose
            // 
            this.btnClose.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
            this.btnClose.BackColor = System.Drawing.Color.Transparent;
            this.btnClose.FlatStyle = System.Windows.Forms.FlatStyle.Flat;
            this.btnClose.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.btnClose.ForeColor = System.Drawing.Color.Black;
            this.btnClose.Location = new System.Drawing.Point(32, 0);
            this.btnClose.Name = "btnClose";
            this.btnClose.Size = new System.Drawing.Size(16, 24);
            this.btnClose.TabIndex = 10;
            this.btnClose.TabStop = false;
            this.btnClose.Text = "X";
            this.btnClose.UseVisualStyleBackColor = false;
            this.btnClose.Click += new System.EventHandler(this.btnClose_Click);
            // 
            // btnMoveRight
            // 
            this.btnMoveRight.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
            this.btnMoveRight.Appearance = Syncfusion.Windows.Forms.ButtonAppearance.Office2003;
            this.btnMoveRight.BackColor = System.Drawing.Color.Transparent;
            this.btnMoveRight.ButtonType = Syncfusion.Windows.Forms.Tools.ButtonTypes.Right;
            this.btnMoveRight.ComboEditBackColor = System.Drawing.Color.Empty;
            this.btnMoveRight.FlatStyle = System.Windows.Forms.FlatStyle.Flat;
            this.btnMoveRight.ForeColor = System.Drawing.Color.Transparent;
            this.btnMoveRight.IsMouseDown = false;
            this.btnMoveRight.Location = new System.Drawing.Point(16, 0);
            this.btnMoveRight.Name = "btnMoveRight";
            this.btnMoveRight.Size = new System.Drawing.Size(16, 24);
            this.btnMoveRight.TabIndex = 17;
            this.btnMoveRight.UseVisualStyle = true;
            this.btnMoveRight.UseVisualStyleBackColor = false;
            this.btnMoveRight.Click += new System.EventHandler(this.btnMoveRight_Click);
            // 
            // btnMoveLeft
            // 
            this.btnMoveLeft.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
            this.btnMoveLeft.Appearance = Syncfusion.Windows.Forms.ButtonAppearance.Office2003;
            this.btnMoveLeft.BackColor = System.Drawing.Color.Transparent;
            this.btnMoveLeft.ButtonType = Syncfusion.Windows.Forms.Tools.ButtonTypes.Left;
            this.btnMoveLeft.ComboEditBackColor = System.Drawing.Color.Empty;
            this.btnMoveLeft.FlatStyle = System.Windows.Forms.FlatStyle.Flat;
            this.btnMoveLeft.ForeColor = System.Drawing.Color.Transparent;
            this.btnMoveLeft.IsMouseDown = false;
            this.btnMoveLeft.Location = new System.Drawing.Point(0, 0);
            this.btnMoveLeft.Name = "btnMoveLeft";
            this.btnMoveLeft.Size = new System.Drawing.Size(16, 24);
            this.btnMoveLeft.TabIndex = 18;
            this.btnMoveLeft.UseVisualStyle = true;
            this.btnMoveLeft.UseVisualStyleBackColor = false;
            this.btnMoveLeft.Click += new System.EventHandler(this.btnMoveLeft_Click);
            // 
            // tabControlAdv1
            // 
            this.tabControlAdv1.ActiveTabColor = System.Drawing.Color.LightGoldenrodYellow;
            this.tabControlAdv1.ActiveTabFont = new System.Drawing.Font("Tahoma", 8F, System.Drawing.FontStyle.Bold);
            this.tabControlAdv1.BackColor = System.Drawing.SystemColors.AppWorkspace;
            this.tabControlAdv1.Dock = System.Windows.Forms.DockStyle.Fill;
            this.tabControlAdv1.Font = new System.Drawing.Font("Tahoma", 8.25F, System.Drawing.FontStyle.Bold);
            this.tabControlAdv1.ImageList = this.smallImageList;
            this.tabControlAdv1.Location = new System.Drawing.Point(0, 0);
            this.tabControlAdv1.Name = "tabControlAdv1";
            this.tabControlAdv1.Padding = new System.Drawing.Point(4, 0);
            this.tabControlAdv1.ShowToolTips = true;
            this.tabControlAdv1.Size = new System.Drawing.Size(464, 480);
            this.tabControlAdv1.TabGap = 2;
            this.tabControlAdv1.TabIndex = 10;
            this.tabControlAdv1.TabPanelBackColor = System.Drawing.Color.White;
            this.tabControlAdv1.UserMoveTabs = true;
            this.tabControlAdv1.ControlAdded += new System.Windows.Forms.ControlEventHandler(this.tabControlAdv1_ControlAdded);
            this.tabControlAdv1.SelectedIndexChanged += new System.EventHandler(this.tabControlAdv1_SelectedIndexChanged);
            // 
            // toolStripSeparator1
            // 
            this.toolStripSeparator1.Name = "toolStripSeparator1";
            this.toolStripSeparator1.Size = new System.Drawing.Size(6, 6);
            // 
            // toolStripSeparator2
            // 
            this.toolStripSeparator2.Name = "toolStripSeparator2";
            this.toolStripSeparator2.Size = new System.Drawing.Size(6, 6);
            // 
            // toolStripSeparator3
            // 
            this.toolStripSeparator3.Name = "toolStripSeparator3";
            this.toolStripSeparator3.Size = new System.Drawing.Size(6, 6);
            // 
            // toolStripSeparator4
            // 
            this.toolStripSeparator4.Name = "toolStripSeparator4";
            this.toolStripSeparator4.Size = new System.Drawing.Size(6, 6);
            // 
            // toolStripSeparator5
            // 
            this.toolStripSeparator5.Name = "toolStripSeparator5";
            this.toolStripSeparator5.Size = new System.Drawing.Size(6, 6);
            // 
            // toolStripSeparator6
            // 
            this.toolStripSeparator6.Name = "toolStripSeparator6";
            this.toolStripSeparator6.Size = new System.Drawing.Size(6, 6);
            // 
            // toolStripSeparator7
            // 
            this.toolStripSeparator7.Name = "toolStripSeparator7";
            this.toolStripSeparator7.Size = new System.Drawing.Size(6, 6);
            // 
            // toolStripSeparator8
            // 
            this.toolStripSeparator8.Name = "toolStripSeparator8";
            this.toolStripSeparator8.Size = new System.Drawing.Size(6, 6);
            // 
            // toolStripSeparator9
            // 
            this.toolStripSeparator9.Name = "toolStripSeparator9";
            this.toolStripSeparator9.Size = new System.Drawing.Size(6, 6);
            // 
            // toolStripSeparator10
            // 
            this.toolStripSeparator10.Name = "toolStripSeparator10";
            this.toolStripSeparator10.Size = new System.Drawing.Size(6, 6);
            // 
            // toolStripSeparator11
            // 
            this.toolStripSeparator11.Name = "toolStripSeparator11";
            this.toolStripSeparator11.Size = new System.Drawing.Size(6, 6);
            // 
            // ImplementerScreen
            // 
            this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
            this.BackColor = System.Drawing.SystemColors.InactiveCaptionText;
            this.ClientSize = new System.Drawing.Size(800, 510);
            this.Controls.Add(this.dcPanel);
            this.Controls.Add(this.splitter1);
            this.Controls.Add(this.toolStripPanel1);
            this.ForeColor = System.Drawing.SystemColors.ControlText;
            this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
            this.Name = "ImplementerScreen";
            this.Tag = "SID_IMPLEMENTER";
            this.WindowState = System.Windows.Forms.FormWindowState.Maximized;
            ((System.ComponentModel.ISupportInitialize)(this.childFrameBarManager1)).EndInit();
            ((System.ComponentModel.ISupportInitialize)(this.dockingManager1)).EndInit();
            this.toolStripPanel1.ResumeLayout(false);
            this.toolStripPanel1.PerformLayout();
            this.toolStripFileOptions.ResumeLayout(false);
            this.toolStripFileOptions.PerformLayout();
            this.toolStripLayout.ResumeLayout(false);
            this.toolStripLayout.PerformLayout();
            this.toolStripNodes.ResumeLayout(false);
            this.toolStripNodes.PerformLayout();
            this.toolStripNudgeTools.ResumeLayout(false);
            this.toolStripNudgeTools.PerformLayout();
            this.toolStripDrawing.ResumeLayout(false);
            this.toolStripDrawing.PerformLayout();
            this.toolStripView.ResumeLayout(false);
            this.toolStripView.PerformLayout();
            this.toolStripConnectors.ResumeLayout(false);
            this.toolStripConnectors.PerformLayout();
            this.toolStripRotate.ResumeLayout(false);
            this.toolStripRotate.PerformLayout();
            this.toolStripCanvas.ResumeLayout(false);
            this.toolStripCanvas.PerformLayout();
            this.toolStripMarkers.ResumeLayout(false);
            this.toolStripMarkers.PerformLayout();
            this.toolStripAlign.ResumeLayout(false);
            this.toolStripAlign.PerformLayout();
            this.dcPanel.ResumeLayout(false);
            this.pnlCanvasHeader.ResumeLayout(false);
            ((System.ComponentModel.ISupportInitialize)(this.tabControlAdv1)).EndInit();
            this.ResumeLayout(false);
            this.PerformLayout();

		}

        void toolStripBtnHVMarkerEdit_Click(object sender, EventArgs e)
        {
                   if (this.gms.ActiveManager.CanvasObj.HorizontalAnchorList.Count == 0 && this.gms.ActiveManager.CanvasObj.VerticalAnchorList.Count == 0)
            {
                MessageBox.Show("No anchors marked for the current Canvas", "Implementer Screen", MessageBoxButtons.OK, MessageBoxIcon.Information);
            }
            else
            {
                EditMarkersDialog edtMksDlg = new EditMarkersDialog(this.gms.ActiveManager.CanvasObj.VerticalAnchorList, this.gms.ActiveManager.CanvasObj.HorizontalAnchorList, this.gms.ActiveManager.CanvasObj.Controller.View.Width, this.gms.ActiveManager.CanvasObj.Controller.View.Height);
                       
                edtMksDlg.ShowDialog();
            }
        }

        void toolStripBtnHMarker_Click(object sender, EventArgs e)
        {
           if (this.gms.ActiveManager != null)
            {

                //this.barItemFormatPainter.Checked = !this.barItemFormatPainter.Checked;
                this.toolStripBtnHMarker.Checked = !this.toolStripBtnHMarker.Checked;
                if (this.toolStripBtnHMarker.Checked)
                {
                    this.gms.ActiveManager.CanvasObj.View.Cursor = Cursors.VSplit;
                    this.gms.ActiveManager.CanvasObj.MouseClick += new MouseEventHandler(HorizontalMarker_MouseClick);
                }
                else
                {
                    this.gms.ActiveManager.CanvasObj.View.Cursor = Cursors.Default;
                    this.gms.ActiveManager.CanvasObj.MouseClick -= new MouseEventHandler(HorizontalMarker_MouseClick);
                }
            } 
        }

        void toolStripBtnVMarker_Click(object sender, EventArgs e)
        {
            if (this.gms.ActiveManager != null)
            {

                //this.barItemFormatPainter.Checked = !this.barItemFormatPainter.Checked;
                this.toolStripBtnVMarker.Checked = !this.toolStripBtnVMarker.Checked;
                if (this.toolStripBtnVMarker.Checked)
                {
                    this.gms.ActiveManager.CanvasObj.View.Cursor = Cursors.HSplit;
                    this.gms.ActiveManager.CanvasObj.MouseClick += new MouseEventHandler(VerticalMarker_MouseClick);
                }
                else
                {
                    this.gms.ActiveManager.CanvasObj.View.Cursor = Cursors.Default;
                    this.gms.ActiveManager.CanvasObj.MouseClick -= new MouseEventHandler(VerticalMarker_MouseClick);
                }
            }
        }

		void toolStripCmbMagnify_LostFocus(object sender, EventArgs e)
		{
			if (this.gms.ActiveManager != null)
			{
				if (toolStripCmbMagnify.SelectedItem != null)
				{
					this.gms.ActiveManager.CanvasObj.Zoom(this.toolStripCmbMagnify.SelectedItem.ToString());
				}
				else if (toolStripCmbMagnify.Text != null && this.toolStripCmbMagnify.Text != "")
				{
					//int orignalVal = gms.ActiveManager.CanvasObj.View.Magnification.Height;
                    int orignalVal=gms.ActiveManager.CanvasObj.View.Y;
                    
					int newValue = 0;
					int.TryParse(toolStripCmbMagnify.Text, out newValue);
					if (newValue == 0 || newValue > 1000 || newValue < 10)
					{
						newValue = orignalVal;
					}

					this.gms.ActiveManager.CanvasObj.Zoom(this.toolStripCmbMagnify.Text.ToString());
				}
			}

		}




		#endregion

		#region	Events


		private void PropertyGrid_PropertyValueChanged(object s, PropertyValueChangedEventArgs e)
		{

			//Check	if tab is existing
			if (tabControlAdv1.TabPages.Count > 0)
			{
				Canvas activeCanvas = this.gms.ActiveManager.CanvasObj;
				//Check	if Node	is selected
				if (activeCanvas.Controller.SelectionList.Count != 0)
				{
					//Get the type of node
					Type type = activeCanvas.Controller.SelectionList.GetType();

					#region	Link Value Changed
					//If Node Type is Link do Nothing
					if (type.Name == "Link")
					{
						//
						// TODO: Add Link Value	Changed	Related	Logic Here
						//
					}

					#endregion
					//If NodeType is a Symbol
					else if (type.BaseType == typeof(Symbol))
					{
						try
						{
							//Get Symbol Associated	with the selected Node

                            //Node sm = activeCanvas.Controller.View.SelectionList as Node;
                            //PathNode sm = activeCanvas.Controller.View.SelectionList as PathNode;
                            Syncfusion.Windows.Forms.Diagram.Group sm = activeCanvas.Controller.View.SelectionList as Syncfusion.Windows.Forms.Diagram.Group;
                           
							//SymbolModel smblmdl =	activeCanvas.Controller.SelectionList as	SymbolModel;

							//Get the PropertyTable	Associated with	the	selected Node
							Symcon.Lightridge.LRRUI.PropertyTable pt = null;//=	activeCanvas.Controller.SelectionList.GetType().GetProperty("PT").GetValue(activeCanvas.Controller.SelectionList,	null) as Symcon.Lightridge.LRRUI.PropertyTable;
							if (type == typeof(DynamicGridcontainer))
							{
								DynamicGridcontainer dg = sm as DynamicGridcontainer;
                                //DynamicGridcontainer dg = ((PathNode)sm) as GridCell;
								if (dg.SelectedCell != null)
								{
									pt = dg.SelectedCell.PT as PropertyTable;
								}
								else
								{
									pt = dg.PT;
								}
							}
							else
							{
								pt =sm.GetPropertyContainerByName("PT") as PropertyTable;

							}

							ArrayList arryList = new ArrayList();


							#region	ItemType Changed
							//If PropertyChanged is	Type
							if (e.ChangedItem.Label == "MasterPlantItem")
							{
                                MasterPlantItem mp = e.ChangedItem.Value as MasterPlantItem;
								typePropValue = mp.ID;

								//Stores the Global	value of the Symbol	Type to	Reflect	on Bound Object	Property
								LRRTypeConverter.MasterID = mp.ID;
								LRRTypeConverter.SymbolType = type;


								if (e.OldValue != null)
								{

									if (type == typeof(DynamicGridcontainer))
									{

										DynamicGridcontainer dg = sm as DynamicGridcontainer;
										if (dg.SelectedCell != null)
										{
											for (int i = pt.Properties.Count; i > 0; i--)
											{
												PropertySpec ps = pt.Properties[i - 1] as PropertySpec;
												if (ps.Category == "Bound Properties")
												{
													pt.Properties.Remove(ps);
												}
											}
											GridCell gridCell = dg.SelectedCell;
											if (gridCell.IsBinded)
											{
												gms.ActiveManager.LRRBindingManagerObj.RemoveBinding(gridCell.Tag, "PropertyValue", gridCell, true);
												gms.ActiveManager.LRRBindingManagerObj.RemoveBinding(gridCell.Tag, "ErrCode", gridCell, true);
												gridCell.IsBinded = false;
												gridCell.UIUOMID = null;
												gridCell.UOMTypeID = null;
												gridCell.Tag = null;
												gridCell.ModeID = null;
												gridCell.Type = null;
												gridCell.PropertyID = null;
												gridCell.BackgroundStyle.Color = Color.Transparent;
												//gridCell.BorderStyle.BorderColor = dg.GridBorderColor;
												//gridCell.BorderStyle.BorderWidth = dg.GridBorderWidth;
												gridCell.Text = "";
												gridCell.Description = "";
												gridCell.FontStyle.Style = System.Drawing.FontStyle.Regular;
												gridCell.GridCellDoubleClick -= new NodeMouseEventHandler(GraphicsUtilities.OnUOMChangeForGridCell);
                                                //gCell.GridCellDoubleClick += new NodeMouseEventHandler(gCell_GridCellDoubleClick);
											}
										}
									}
									else
									{
										for (int i = pt.Properties.Count; i > 0; i--)
										{
											PropertySpec ps = pt.Properties[i - 1] as PropertySpec;
											if (ps.Category == "Bound Properties")
											{
												pt.Properties.Remove(ps);
											}
										}
										for (int i = sm.Labels.Count; i > 0; i--)
										{
											//sm.Labels[i-1].Visible = false;
											LRRLabel lbl = sm.Labels[i - 1] as LRRLabel;
											if (i == (sm.Labels.Count - 1))
											{
												lbl.Text = mp.Name;
												continue;
											}

											lbl.Text = "";
											lbl.ParentID = "";
											lbl.BackgroundStyle.Color = Color.Transparent;
                                            lbl.BackgroundStyle.Color = Color.Black;
											if (lbl.Tag != null && lbl.Tag.GetType().GetInterface("IPropertyValue") == typeof(IPropertyValue))
											{
												gms.ActiveManager.LRRBindingManagerObj.RemoveBinding(lbl.Tag, "PropertyValue", lbl, true);
												gms.ActiveManager.LRRBindingManagerObj.RemoveBinding(lbl.Tag, "ErrCode", lbl, true);
											}
											lbl.Tag = null;
										}

										ArrayList arryPropIndex = (ArrayList)sm.GetPropertyContainerByName("ArryIndexedProps");
										//									if(arryPropIndex != null)
										//									{
										for (int j = 0; j < arryPropIndex.Count; j++)
										{
											arryPropIndex[j] = "Null";
										}
									}
									//									}
								}

								//Check	if BusinessObject HashTable	value contains the information of Symbol
								if (gms.ActiveManager.LabelControllerObj.BusinessObjectCollection[sm.GetPropertyContainerByName("ID")] != null)
								{
									if (pt.Properties.Contains(gms.ActiveManager.LabelControllerObj.BusinessObjectCollection[sm.GetPropertyContainerByName("ID")].ToString()))
									{
										pt.Properties.Remove(gms.ActiveManager.LabelControllerObj.BusinessObjectCollection[sm.GetPropertyContainerByName("ID")].ToString());
										ArrayList arryPropIndex = (ArrayList)sm.GetPropertyContainerByName("ArryIndexedProps");
										//										if(arryPropIndex != null)
										//										{
										for (int j = 0; j < arryPropIndex.Count; j++)
										{
											arryPropIndex[j] = "Null";
										}
										//										}

									}

									//Get all the selected symbol items	from
									//SymbolObjectBinding to an	ArrayList
									foreach (DictionaryEntry obj in gms.ActiveManager.LabelControllerObj.SymbolObjectBinding)
									{
										LabelLookup lblLookup = obj.Key as LabelLookup;
										if (lblLookup.SymbolID ==sm.GetPropertyContainerByName("ID").ToString())
											arryList.Add(lblLookup);
									}

									for (int i = 0; i < arryList.Count; i++)
									{
										gms.ActiveManager.LabelControllerObj.SymbolObjectBinding.Remove(arryList[i]);
									}
									arryList.Clear();
									//Clear	value of BusinessObjectCollection attached to 
									//this SymbolName
									gms.ActiveManager.LabelControllerObj.BusinessObjectCollection[sm.GetPropertyContainerByName("ID")] = null;
								}
								propertyEditor2.PropertyGrid.Refresh();

							}

							#endregion

							#region	SiteItem Changed

							//If the PropertyChanged is	SiteItem
							if (e.ChangedItem.Label == "PlantItem")
							{
								if (type == typeof(DynamicGridcontainer))
								{
									DynamicGridcontainer dg = sm as DynamicGridcontainer;
									if (dg.SelectedCell != null)
									{
										GridCell gridCell = dg.SelectedCell;
										if (gridCell.IsBinded)
										{
											gms.ActiveManager.LRRBindingManagerObj.RemoveBinding(gridCell.Tag, "PropertyValue", gridCell, true);
											gms.ActiveManager.LRRBindingManagerObj.RemoveBinding(gridCell.Tag, "ErrCode", gridCell, true);
											gridCell.IsBinded = false;
											gridCell.UIUOMID = null;
											gridCell.Tag = null;
											gridCell.UOMTypeID = null;
											gridCell.ModeID = null;
											gridCell.Type = null;
											gridCell.PropertyID = null;
											gridCell.BackgroundStyle.Color = Color.Transparent;
											//gridCell.BorderStyle.BorderColor = dg.GridBorderColor;
											//gridCell.BorderStyle.BorderWidth = dg.GridBorderWidth;
											gridCell.Text = "";
											gridCell.Description = "";
											gridCell.FontStyle.Style = System.Drawing.FontStyle.Regular;
											gridCell.GridCellDoubleClick -= new NodeMouseEventHandler(GraphicsUtilities.OnUOMChangeForGridCell);
                                            //gridCell.GridCellDoubleClick -= new NodeMouseEventHandler(gCell_GridCellDoubleClick);
										}
										for (int i = pt.Properties.Count; i > 0; i--)
										{
											PropertySpec ps = pt.Properties[i - 1] as PropertySpec;
											if (ps.Category == "Bound Properties")
											{
												pt.Properties.Remove(ps);
											}
										}
										if (pt != null)
										{
											ISymbolPropertiesMapping isymbolMapping = null;
											if (dg.SelectedCell.PlantItem.SiteItemType == Globals.Enums.PlantItemType.AGGREGATE)
											{

												isymbolMapping = new AggregatesMapping();
											}
											else //if(dg.SelectedCell.PlantItem.SiteItemType == Globals.Enums.PlantItemType.SIMPLE)
											{
												isymbolMapping = new SiteComponentMapping();
											}

											GridCellMappingDialog gcellMappingDialog = new GridCellMappingDialog(isymbolMapping, pt, dg.SelectedCell);
											DialogResult dresult = gcellMappingDialog.ShowDialog(this);
											if (dresult == DialogResult.OK)
											{
												LRRMode mode = gcellMappingDialog.SelectedMode;
												List<IPropertyValue> alstValues = gcellMappingDialog.SelectedValues;
												IProperty selectedItem = gcellMappingDialog.SelectedItem;
												foreach (IPropertyValue iPropvalue in alstValues)
												{
													if (mode.ModeId == iPropvalue.GetModeID())
													{

														gridCell.Tag = iPropvalue;
														gridCell.ModeID = iPropvalue.GetModeID();
														gridCell.Type = iPropvalue.GetObjectType();


														gms.ActiveManager.LRRBindingManagerObj.AddBinding(iPropvalue, "PropertyValue", gridCell, "Text");
														if (dg.SelectedCell.PlantItem.SiteItemType != Globals.Enums.PlantItemType.AGGREGATE)
														{
															gms.ActiveManager.LRRBindingManagerObj.AddBinding(iPropvalue, "ErrCode", gridCell, "LabelColorCode");
														}

														if (gcellMappingDialog.UIUOMID != null)
														{
															gridCell.Text = iPropvalue.GetPropertyValueForUOM(iPropvalue.GetUOMID(), gcellMappingDialog.UIUOMID, iPropvalue.GetPropertyValue());

															gridCell.UIUOMID = gcellMappingDialog.UIUOMID;
															gridCell.UOMTypeID = gcellMappingDialog.UOMTypeID;

															gridCell.GridCellDoubleClick += new NodeMouseEventHandler(GraphicsUtilities.OnUOMChangeForGridCell);
                                                            //gridCell.GridCellDoubleClick += new NodeMouseEventHandler(gCell_GridCellDoubleClick);
														}
														gridCell.Description = selectedItem.GetName() + "(" + mode.ModeName + ")";
														dg.SelectedCell.IsBinded = true;
														if (gridCell.Type.Name == "LRRSiteGroupPropertyQualifierValue")
														{
															LRRSiteGroupPropertyQualifierValue currentPropval = iPropvalue as LRRSiteGroupPropertyQualifierValue;
															gridCell.ID = currentPropval.LookUpQualifierID;
															gridCell.PropertyID = currentPropval.GroupPropertyID;
														}
														else
														{
															gridCell.PropertyID = selectedItem.GetID();
															dg.SelectedCell.ID = iPropvalue.GetID();
														}

														int propIndex = pt.Properties.Add(new PropertySpec(selectedItem.GetName() + "(" + mode.ModeName + ")", typeof(String), "Bound Properties", selectedItem.GetName(), iPropvalue.GetPropertyValue(), "", typeof(String), iPropvalue.GetID()));
														Attribute[] attrib = new Attribute[1];

														BrowsableAttribute browsableAttrib;
														browsableAttrib = new BrowsableAttribute(false);
														attrib[0] = browsableAttrib;
														pt.Properties[propIndex].AttributesNew = attrib;


														//Add Colour Binding
														GraphicsUtilities.SetColor(dg.SelectedCell, iPropvalue);
														propertyEditor2.PropertyGrid.Update();
														propertyEditor2.PropertyGrid.Refresh();

														break;
													}
												}
											}
										}
									}
								}
								else if (type == typeof(DashBoardControlProperties))
								{
									LRRBindingManager lrrBindingManager = gms.ActiveManager.LRRBindingManagerObj;
									ControlNode cNode = sm.Nodes.Last as ControlNode;
                                    
                                    Control objControl = cNode.HostingControl;
									if (gms.SelectedModes.Count == 0)
									{
										LRRMessagBox.ShowMessage("SID_SELECT_MODE", "SID_LABEL", MessageBoxButtons.OK, MessageBoxIcon.Error);
										_app.LRRUIManagerObj.ShowModesDialog();
										return;
									}
									Canvas canvas = gms.ActiveManager.CanvasObj;
									//Set the Symbol
                                    Syncfusion.Windows.Forms.Diagram.Group smbl = canvas.Controller.SelectionList.First as Syncfusion.Windows.Forms.Diagram.Group;
                                    SiteItem siteItem = smbl.GetPropertyContainerByName("PlantItem") as SiteItem;
                                   
									if (siteItem.SiteItemType != Symcon.Globals.Enums.PlantItemType.AGGREGATE)
									{
										string siteCompID = smbl.GetPropertyContainerByName("PlantItem").GetType().GetProperty("ID").GetValue(smbl.GetPropertyContainerByName("PlantItem"), null).ToString();
										LRRSiteComponent siteComp = LRRModel.SiteComponentsObj.GetSiteComponentByID(siteCompID);
										BindTree modelTree = new BindTree(siteComp);
										DialogResult dlgResult = modelTree.ShowDialog();
										if (dlgResult == DialogResult.OK)
										{
											BindingInfo bindInfo = modelTree.BindInfo;
											if (bindInfo != null)
											{
												objControl.Tag = bindInfo;
												string sourceObjectName = bindInfo.SourceObjectName;
												string sourceObjectID = bindInfo.SourceObjectID;
												string sourceProperty = bindInfo.SourceProperty;
												string propetyValue = "";
												LRRSiteComponentProperty lscp = null;
												LRRSiteComponentGroupProperty lscgp = null;
												LRRMode mode = null;
												object sourceObject = gms.ActiveManager.GetSourceObject(sourceObjectName, sourceObjectID);
												if (sourceObject.GetType().ToString() == "Symcon.LightRidge.BusinessObjects.LRRSiteGroupPropertyQualifierValue")
												{
													string siteCompPropID = sourceObject.GetType().GetProperty("SiteComponentPropID").GetValue(sourceObject, null).ToString();
													string modeID = sourceObject.GetType().GetProperty("ModeID").GetValue(sourceObject, null).ToString();
													object propValueObj = sourceObject.GetType().GetProperty("PropertyValue").GetValue(sourceObject, null);
													if (propValueObj != null)
													{
														propetyValue = propValueObj.ToString();
													}
													lscgp = LRRModel.SiteComponentGroupPropertiesObj.GetSiteCompGroupPropFromID(siteCompPropID) as LRRSiteComponentGroupProperty;
													mode = LRRModel.Modes.GetModeByID(modeID) as LRRMode;
												}
												if (sourceObject.GetType().ToString() == "Symcon.LightRidge.BusinessObjects.LRRSiteComponentPropertyValue")
												{
													string siteCompPropID = sourceObject.GetType().GetProperty("SiteComponentPropertyID").GetValue(sourceObject, null).ToString();
													string modeID = sourceObject.GetType().GetProperty("ModeID").GetValue(sourceObject, null).ToString();
													object propValueObj = sourceObject.GetType().GetProperty("PropertyValue").GetValue(sourceObject, null);
													if (propValueObj != null)
													{
														propetyValue = propValueObj.ToString();
													}
													lscp = LRRModel.SiteComponentPropertiesObj.GetSiteCompPropFromID(siteCompPropID) as LRRSiteComponentProperty;
													/*uomTypeObj = LRRModel.ChildModel.UomTypes.GetUOMTypeObjectFromID(lscp.UOMTypeID);  */
													mode = LRRModel.Modes.GetModeByID(modeID) as LRRMode;
												}


												try
												{
													ClearBindings(sourceObject, objControl, sourceProperty);
													//lrrBindingManager.AddBinding(sourceObject, sourceProperty, objControl, "TargetValue", true);
													lrrBindingManager.AddBinding(bindInfo, "SiteComponentName", objControl, "SourceItem");
													lrrBindingManager.AddBinding(bindInfo, "SiteComponentProperty", objControl, "Attribute");
													lrrBindingManager.AddBinding(bindInfo, "ModeName", objControl, "ModeName");
													lrrBindingManager.AddBinding(bindInfo, "SourceObjectName", objControl, "SourceObjectName");
													lrrBindingManager.AddBinding(bindInfo, "SourceObjectID", objControl, "SourceObjectID");
													lrrBindingManager.AddBinding(bindInfo, "SourceProperty", objControl, "SourceProperty");
													PropertySpec propSpec = null;
													if (sourceObject.GetType().ToString() == "Symcon.LightRidge.BusinessObjects.LRRSiteGroupPropertyQualifierValue")
													{
														LRRSiteGroupPropertyQualifierValue gpQv = sourceObject as LRRSiteGroupPropertyQualifierValue;
														if (gpQv.LookUpQualifierID != null && gpQv.LookUpQualifierID.ToString().Trim() != "")
														{
															string gpName = "";
															string objRef = gpQv.LookUpQualifierID + "|" + gpQv.GroupPropertyID;
															lscgp = LRRModel.SiteComponentGroupPropertiesObj.GetSiteCompGroupPropFromID(gpQv.GroupPropertyID);
															if (lscgp != null)
															{
																gpName = lscgp.AttributeName;
															}
															string propName = lscp.Name + "/" + gpName + "/" + gpQv.QualifierName + "[ Group ]";
															propSpec = new PropertySpec(propName + "(" + mode.ModeName + ")", typeof(string), "Bound Properties", propName + "(" + mode.ModeName + ")", propetyValue, "", "", objRef);
														}
														else
														{
															string gpName = "";
															string objRef = "|" + gpQv.GroupPropertyID;
															lscgp = LRRModel.SiteComponentGroupPropertiesObj.GetSiteCompGroupPropFromID(gpQv.GroupPropertyID);
															if (lscgp != null)
															{
																gpName = lscgp.AttributeName;
															}
															string propName = lscp.Name + "/" + gpName + "/" + gpQv.QualifierName + "[ Group ]";
															propSpec = new PropertySpec(propName + "(" + mode.ModeName + ")", typeof(string), "Bound Properties", propName + "(" + mode.ModeName + ")", propetyValue, "", "", objRef);
														}
													}
													else
													{
														propSpec = new PropertySpec(lscp.Name + "(" + mode.ModeName + ")", typeof(string), "Bound Properties", lscp.Name + "(" + mode.ModeName + ")", propetyValue, "", "", lscp.ID);
													}
													foreach (PropertySpec ps in pt.Properties)
													{
														if (ps.Category == "Bound Properties")
														{
															pt.Properties.Remove(ps);
															break;
														}
													}
													pt.Properties.Add(propSpec);
													LRRLabel lbl = smbl.Labels[0] as LRRLabel;
													lbl.Visible = false;
													lbl.Tag = objControl;
													lrrBindingManager.AddBinding(sourceObject, sourceProperty, propSpec, "DefaultValue", true);
													lrrBindingManager.AddBinding(sourceObject, sourceProperty, lbl, "Text", true);
													objControl.GetType().GetProperty("TargetValue").SetValue(objControl, propSpec.DefaultValue, null);
													GraphicsSiteComponentUtilities.InitializeLablesForDashBoard(objControl, smbl, lscp, lscgp, mode);
													//lrrBindingManager.AddBinding( sourceObject,sourceProperty,propSpec, "DefaultValue");
													//gms.ActiveManager.ChangePropertyValue(objControl);
												}
												catch
												{

												}
											}
										}
									}
									else
									{
										string aggreGateID = smbl.GetPropertyContainerByName("PlantItem").GetType().GetProperty("ID").GetValue(smbl.GetPropertyContainerByName("PlantItem"), null).ToString();
										LRRAggregate aggregate = LRRModel.AggregatesObj.GetAggregateFromID(aggreGateID);
										BindTree modelTree = new BindTree(aggregate);
										DialogResult dlgResult = modelTree.ShowDialog();
										if (dlgResult == DialogResult.OK)
										{
											BindingInfo bindInfo = modelTree.BindInfo;
											if (bindInfo != null)
											{
												objControl.Tag = bindInfo;
												string sourceObjectName = bindInfo.SourceObjectName;
												string sourceObjectID = bindInfo.SourceObjectID;
												string sourceProperty = bindInfo.SourceProperty;
												string propetyValue = "";
												LRRAggregateProperty aggProp = null;
												LRRAggregateGroupedProperty aggGroProp = null;
												LRRMode mode = null;
												object sourceObject = gms.ActiveManager.GetSourceObject(sourceObjectName, sourceObjectID);
												if (sourceObject.GetType().ToString() == "Symcon.LightRidge.BusinessObjects.LRRAggregateGroupedPropertyValue")
												{
													string aggGrpPropID = sourceObject.GetType().GetProperty("AggregateGroupPropertyID").GetValue(sourceObject, null).ToString();
													string modeID = sourceObject.GetType().GetProperty("ModeID").GetValue(sourceObject, null).ToString();
													object propValueObj = sourceObject.GetType().GetProperty("PropertyValue").GetValue(sourceObject, null);
													if (propValueObj != null)
													{
														propetyValue = propValueObj.ToString();
													}
													aggGroProp = LRRModel.AggregateGroupedPropertiesObj.GetAggregateGroupPropFromID(aggGrpPropID) as LRRAggregateGroupedProperty;
													mode = LRRModel.Modes.GetModeByID(modeID) as LRRMode;
												}
												if (sourceObject.GetType().ToString() == "Symcon.LightRidge.BusinessObjects.LRRAggregatePropertyValue")
												{
													string aggPropID = sourceObject.GetType().GetProperty("AggregatePropertyID").GetValue(sourceObject, null).ToString();
													string modeID = sourceObject.GetType().GetProperty("ModeID").GetValue(sourceObject, null).ToString();
													object propValueObj = sourceObject.GetType().GetProperty("PropertyValue").GetValue(sourceObject, null);
													if (propValueObj != null)
													{
														propetyValue = propValueObj.ToString();
													}
													aggProp = LRRModel.AggregatePropertiesObj.GetAggregatePropFromID(aggPropID) as LRRAggregateProperty;
													//uomTypeObj = LRRModel.ChildModel.UomTypes.GetUOMTypeObjectFromID(lscp.UOMTypeID);
													mode = LRRModel.Modes.GetModeByID(modeID) as LRRMode;
												}

												try
												{
													ClearBindings(sourceObject, objControl, sourceProperty);
													//lrrBindingManager.AddBinding(sourceObject, sourceProperty, objControl, "TargetValue", true);
													lrrBindingManager.AddBinding(bindInfo, "SiteComponentName", objControl, "SourceItem");
													lrrBindingManager.AddBinding(bindInfo, "SiteComponentProperty", objControl, "Attribute");
													lrrBindingManager.AddBinding(bindInfo, "ModeName", objControl, "ModeName");
													lrrBindingManager.AddBinding(bindInfo, "SourceObjectName", objControl, "SourceObjectName");
													lrrBindingManager.AddBinding(bindInfo, "SourceObjectID", objControl, "SourceObjectID");
													lrrBindingManager.AddBinding(bindInfo, "SourceProperty", objControl, "SourceProperty");
													PropertySpec propSpec = null;
													if (sourceObject.GetType().ToString() == "Symcon.LightRidge.BusinessObjects.LRRAggregateGroupedPropertyValue")
													{
														LRRAggregateGroupedPropertyValue aggGrpValue = sourceObject as LRRAggregateGroupedPropertyValue;
														if (aggGrpValue.LookUpQualifierID != null && aggGrpValue.LookUpQualifierID.ToString().Trim() != "")
														{
															string gpName = "";
															string objRef = aggGrpValue.LookUpQualifierID + "|" + aggGrpValue.AggregateGroupPropertyID;
															if (aggGroProp != null)
															{
																gpName = aggGroProp.AttributeName;
															}
															string propName = aggGroProp.AttributeName + "/" + gpName + "/" + aggGrpValue.QualifierName + "[ Group ]";
															propSpec = new PropertySpec(propName + "(" + mode.ModeName + ")", typeof(string), "Bound Properties", propName + "(" + mode.ModeName + ")", propetyValue, "", "", objRef);
														}
														else
														{
															string gpName = "";
															string objRef = "|" + aggGrpValue.AggregateGroupPropertyID;
															if (aggGroProp != null)
															{
																gpName = aggGroProp.AttributeName;
															}
															string propName = aggGroProp.AttributeName + "/" + gpName + "/" + aggGrpValue.QualifierName + "[ Group ]";
															propSpec = new PropertySpec(propName + "(" + mode.ModeName + ")", typeof(string), "Bound Properties", propName + "(" + mode.ModeName + ")", propetyValue, "", "", objRef);
														}
													}
													else
													{
														propSpec = new PropertySpec(aggProp.Name + "(" + mode.ModeName + ")", typeof(string), "Bound Properties", aggProp.Name + "(" + mode.ModeName + ")", propetyValue, "", "", aggProp.ID);
													}
													foreach (PropertySpec ps in pt.Properties)
													{
														if (ps.Category == "Bound Properties")
														{
															pt.Properties.Remove(ps);
															break;
														}
													}
													pt.Properties.Add(propSpec);
													LRRLabel lbl = smbl.Labels[0] as LRRLabel;
													lbl.Visible = false;
													lbl.Tag = objControl;
													lrrBindingManager.AddBinding(sourceObject, sourceProperty, propSpec, "DefaultValue", true);
													lrrBindingManager.AddBinding(sourceObject, sourceProperty, lbl, "Text", true);
													objControl.GetType().GetProperty("TargetValue").SetValue(objControl, propSpec.DefaultValue, null);
													GraphicsAggregatesUtilities.InitializeLablesForDashBoard(objControl, smbl, aggProp, aggGroProp, mode);
													//lrrBindingManager.AddBinding( sourceObject,sourceProperty,propSpec, "DefaultValue");
													//gms.ActiveManager.ChangePropertyValue(objControl);
												}
												catch
												{

												}
											}
										}
									}
								}
								else
								{
									//Check if Modes are selected
									if (gms.SelectedModes.Count == 0)
									{
										LRRMessagBox.ShowMessage("SID_SELECT_MODE", "SID_LABEL", MessageBoxButtons.OK, MessageBoxIcon.Error);
										_app.LRRUIManagerObj.ShowModesDialog();
										return;
									}
									//Check	the	old	Value of the Property
									//If the site Item is changed
									if (e.OldValue != null)
									{
										//for(int i= pt.Properties.Count; i>0;i--)
										//{
										//    PropertySpec ps =  pt.Properties[i-1] as PropertySpec;
										//    if(ps.Category == "Bound Properties")
										//    {
										//        pt.Properties.Remove(ps);//Remove Bound Properties
										//    }

										//}

										//Remove Binding
										for (int i = sm.Labels.Count; i > 0; i--)
										{
											LRRLabel lbl = sm.Labels[i - 1] as LRRLabel;
											lbl.Text = "";
											lbl.ParentID = "";
											lbl.BackgroundStyle.Color = Color.Transparent;
											lbl.BackgroundStyle.Color = Color.Black;
											if (lbl.Tag != null && lbl.Tag.GetType().GetInterface("IPropertyValue") == typeof(IPropertyValue))
											{
												gms.ActiveManager.LRRBindingManagerObj.RemoveBinding(lbl.Tag, "PropertyValue", lbl, true);
												gms.ActiveManager.LRRBindingManagerObj.RemoveBinding(lbl.Tag, "ErrCode", lbl, true);
											}
											lbl.Tag = null;
										}
										//Set the Property Holder Array values for the symbol to "Null"
										ArrayList arryPropIndex = (ArrayList)sm.GetPropertyContainerByName("ArryIndexedProps");
										for (int j = 0; j < arryPropIndex.Count; j++)
										{
											arryPropIndex[j] = "Null";
										}

										gms.ActiveManager.LabelControllerObj.BusinessObjectCollection[sm.GetPropertyContainerByName("ID")] = null;

									}


									if (gms.ActiveManager.LabelControllerObj.BusinessObjectCollection[sm.GetPropertyContainerByName("ID")] == null)
									{
										gms.OnMapProperties(GraphicsManagers.UserMode.IMPLEMENTOR);
									}
									propertyEditor2.PropertyGrid.Update();
									propertyEditor2.PropertyGrid.Refresh();
								}
							}
							#endregion


							#region Link Changed

							if (e.ChangedItem.Label == "Link")
							{
								LRRLabel lbl = sm.Labels["Link"] as LRRLabel;
								Symcon.LightRidge.BusinessObjects.GraphicalLink gphLink =sm.GetPropertyContainerByName("Link") as Symcon.LightRidge.BusinessObjects.GraphicalLink;
								if (gphLink != null && gphLink.ID != null)
								{
									if (lbl != null)
									{
										lbl.HorizontalAlignment = System.Drawing.StringAlignment.Center;
										lbl.VerticalAlignment = System.Drawing.StringAlignment.Center;
										Graphics g = this.CreateGraphics();
										float linkWidth = g.MeasureString(lbl.Text, Font).Width;
										//lbl.Width = linkWidth;
                                        lbl.OffsetX = linkWidth;
										lbl.OffsetY = 20f;
										lbl.FontStyle.Size = 6f;
										lbl.FontStyle.Underline = true;
										lbl.FontStyle.Bold = true;
										lbl.BackgroundStyle.Color = Color.Blue;
										lbl.OffsetX = sm.PinPoint.X;
                                        lbl.OffsetY = sm.PinPoint.Y - 20;
										lbl.Visible = true;
										//lbl.Anchor = BoxPosition.TopCenter;
										lbl.OffsetY = -10;
										lbl.Grouped = false;
									}
								}
								else
								{
									//lbl.Anchor = BoxPosition.Center;
									lbl.Text = "Link";
									//smblLbl.Name = "Link";
									lbl.Visible = false;
									lbl.HorizontalAlignment = StringAlignment.Near;
									lbl.OffsetY = 0;
								}
							}

							#endregion


							if (e.ChangedItem.PropertyDescriptor.Category == "Bound Properties")
							{
								LRRLabel myLbl = sm.Labels[e.ChangedItem.Label] as LRRLabel;
                               
								if (sm.GetType().Name == "DashBoardControlProperties")
								{
									string newValue = Utilities.ConvertCultureSpecficToPlainString(e.ChangedItem.Value.ToString(), _app);
									ControlNode cNode = sm.Nodes.Last as ControlNode;
                                    
									Control objControl = cNode.HostingControl;
									GraphicsSiteComponentUtilities.SetOverRideValue(objControl, newValue);
								}
								if (sm.GetType().Name != "Aggregates")
								{
									string newValue = Utilities.ConvertCultureSpecficToPlainString(e.ChangedItem.Value.ToString(), _app);
									GraphicsSiteComponentUtilities.SetOverRideValue(myLbl, newValue);
								}
								else if (sm.GetType().Name == "Aggregates")
								{
									string newValue = Utilities.ConvertCultureSpecficToPlainString(e.ChangedItem.Value.ToString(), _app);
									GraphicsAggregatesUtilities.SetOverRideValue(myLbl, newValue);
								}
							}
						}
						catch (Exception ex)
						{
							Logger.LogMessage(typeof(ImplementerScreen), "PropertyGrid_PropertyValueChanged :" + ex.Message, Logger.Level.Debug);
						}
					}
					//activeCanvas.Model.UpdateViews();
				}
			}
		}

		/// <summary>
		/// Clears the bindings.
		/// </summary>
		/// <param name="sourceObject">The source object.</param>
		/// <param name="objControl">The obj control.</param>
		/// <param name="sourceProperty">The source property.</param>
		private void ClearBindings(object sourceObject, object objControl, string sourceProperty)
		{
			gms.ActiveManager.LRRBindingManagerObj.RemoveBinding(sourceObject, sourceProperty, objControl);
			gms.ActiveManager.LRRBindingManagerObj.RemoveBinding(sourceObject, "SiteComponentName", objControl);
			gms.ActiveManager.LRRBindingManagerObj.RemoveBinding(sourceObject, "SiteComponentProperty", objControl);
			gms.ActiveManager.LRRBindingManagerObj.RemoveBinding(sourceObject, "ModeName", objControl);
			gms.ActiveManager.LRRBindingManagerObj.RemoveBinding(sourceObject, "SourceObjectName", objControl);
			gms.ActiveManager.LRRBindingManagerObj.RemoveBinding(sourceObject, "SourceObjectID", objControl);
			gms.ActiveManager.LRRBindingManagerObj.RemoveBinding(sourceObject, "SourceProperty", objControl);
		}

		/// <summary>
		/// Handles the Click event of the bItemOpen control.
		/// </summary>
		/// <param name="sender">The source of the event.</param>
		/// <param name="e">The <see cref="System.EventArgs"/> instance containing the event data.</param>
		private void bItemOpen_Click(object sender, System.EventArgs e)
		{
			if (gms.SelectedModes.Count == 0)
			{
				LRRMessagBox.ShowMessage("SID_SELECT_MODETYPE", "SID_LABEL", MessageBoxButtons.OK, MessageBoxIcon.Error);
				_app.LRRUIManagerObj.ShowModesDialog();
				return;
			}
			fileDialog = new FileDialog(GraphicsManagers.FileDialogMode.Open, GraphicsManagers.UserMode.IMPLEMENTOR);
			if (fileDialog.ShowDialog(this) == DialogResult.OK)
			{
				for (int i = 0; i < fileDialog.SelectedRecords.Count; i++)
				{
					LRRSavedView selectedView = fileDialog.SelectedRecords[i] as LRRSavedView;
					OpenFiles(selectedView.ID);
				}
			}
		}
		/// <summary>
		/// Handles the Click event of the bItemSave control.
		/// </summary>
		/// <param name="sender">The source of the event.</param>
		/// <param name="e">The <see cref="System.EventArgs"/> instance containing the event data.</param>
		private void bItemSave_Click(object sender, System.EventArgs e)
		{
			if (tabControlAdv1.TabPages.Count > 0)
			{
				Canvas selectedCanvas = gms.ActiveManager.CanvasObj;
				if (selectedCanvas != null)
				{
					if (!selectedCanvas.HasFileName)
					{
						fileDialog = new FileDialog(GraphicsManagers.FileDialogMode.SaveAs, GraphicsManagers.UserMode.IMPLEMENTOR);
						if (fileDialog.ShowDialog(this) == DialogResult.OK)
						{
							selectedCanvas.FileName = fileDialog.FileName;
							selectedCanvas.FileDescription = fileDialog.FileDescription;
							selectedCanvas.FileID = fileDialog.FileID;
							SaveFiles(fileDialog.FileName, fileDialog.FileDescription, fileDialog.FileID);
						}
					}
					else
					{
						this.SaveFile();
					}
				}
			}
		}


		/// <summary>
		/// Handles the Click event of the bItemSaveAs control.
		/// </summary>
		/// <param name="sender">The source of the event.</param>
		/// <param name="e">The <see cref="System.EventArgs"/> instance containing the event data.</param>
		private void bItemSaveAs_Click(object sender, System.EventArgs e)
		{
			if (tabControlAdv1.TabPages.Count > 0)
			{
				Canvas selectedCanvas = gms.ActiveManager.CanvasObj;
				fileDialog = new FileDialog(GraphicsManagers.FileDialogMode.SaveAs, GraphicsManagers.UserMode.IMPLEMENTOR);
				if (selectedCanvas != null)
				{
					if (selectedCanvas.HasFileName)
					{
						fileDialog.FileName = selectedCanvas.FileName;
					}
					if (fileDialog.ShowDialog(this) == DialogResult.OK)
					{
						if (selectedCanvas.FileID != null && gms.OpenedViews.ContainsKey(selectedCanvas.FileID))
							gms.OpenedViews.Remove(selectedCanvas.FileID);
						selectedCanvas.FileName = fileDialog.FileName;
						selectedCanvas.FileDescription = fileDialog.FileDescription;
						selectedCanvas.FileID = fileDialog.FileID;
						SaveFiles(fileDialog.FileName, fileDialog.FileDescription, fileDialog.FileID);
					}
				}
			}
		}

		/// <summary>
		/// Handles the Click event of the bItemNew control.
		/// </summary>
		/// <param name="sender">The source of the event.</param>
		/// <param name="e">The <see cref="System.EventArgs"/> instance containing the event data.</param>
		private void bItemNew_Click(object sender, System.EventArgs e)
		{
			gms.CreateGraphicsManager();
			Canvas canvas = gms.ActiveManager.CanvasObj;				// initialize new canvas
			TabPageAdv newtabPage = new TabPageAdv();	//Add New tap Page
			newtabPage.Text = Symcon.Utils.HeaderDispatcher.LRRHeaderText.GetHeaderString("SID_NEW_CANVAS") + canvasCount;				//Give new Tab default Value
			newtabPage.TabBackColor = Color.LightBlue;
			newtabPage.TabForeColor = Color.Black;
			newtabPage.Controls.Add(canvas);			//add canvas to	the	New	tab	Page
			newtabPage.Tag = gms.ActiveManager.ID;
			this.tabControlAdv1.Controls.Add(newtabPage);//Add Tab Page	to the tabmanager

			tabControlAdv1.SelectedTab = newtabPage;	//Set this as selected tab
			propertyEditor2.Canvas = canvas;			//assing canvas	as selected	object to the Propertygrid
			symbolsList1.Canvas = canvas;
			this.tabControlAdv1.Refresh();				//Refresh tab
			canvas.Model.Modified = false;
			//canvas.View.HorizontalRuler.Visible = bItemRuler.Checked;
			//canvas.View.VerticalRuler.Visible = bItemRuler.Checked;
			canvasCount++;
		}



		/// <summary>
		/// Tools the activate.
		/// </summary>
		/// <param name="sender">The sender.</param>
		/// <param name="e">The <see cref="System.EventArgs"/> instance containing the event data.</param>
		private void ToolActivate(object sender, System.EventArgs e)
		{
			if (gms.ActiveManager != null)
			{
                DeactivateMarkers();
				//Syncfusion.Windows.Forms.Tools.XPMenus.BarItem barItem = sender	as Syncfusion.Windows.Forms.Tools.XPMenus.BarItem;
				ToolStripButton barItem = sender as ToolStripButton;
				Canvas selectedCanvas = this.gms.ActiveManager.CanvasObj;

				try
				{
					if (barItem != null)
					{
						string toolName = (string)barItem.Tag;
						Tool tool = selectedCanvas.Controller.GetTool(toolName);
						if (tool != null)
						{
							if (tool.InAction)
							{
								selectedCanvas.Controller.DeactivateTool(tool);

							}
							else
							{
								selectedCanvas.Controller.ActivateTool(tool);
							}
						}
					}
				}
				catch (Exception ex)
				{
					Logger.LogMessage(typeof(ImplementerScreen), "ToolActivate :" + ex.Message, Logger.Level.Debug);
				}
			}
		}





		/// <summary>
		/// Handles the ControlAdded event of the tabControlAdv1 control.
		/// </summary>
		/// <param name="sender">The source of the event.</param>
		/// <param name="e">The <see cref="System.Windows.Forms.ControlEventArgs"/> instance containing the event data.</param>
		private void tabControlAdv1_ControlAdded(object sender, ControlEventArgs e)
		{
			if (e.Control.GetType() != typeof(Syncfusion.Windows.Forms.ScrollButtons))
			{
				Canvas newCanvas = gms.ActiveManager.CanvasObj;// e.Control.Controls[0] as	Canvas;
				ActivateLinkTools(newCanvas);
				//newCanvas.Controller.RegisterTool(newCanvas.InsSymbolTool);
				//newCanvas.InsSymbolTool.Activate();
               
               
             
               
                
                
             
				//newCanvas.View.VerticalRuler.Visible = this.barItemNavigation.Checked;
				//newCanvas.View.HorizontalRuler.Visible = this.barItemNavigation.Checked;
				//newCanvas.View.MagnificationChanged += new ViewMagnificationEventHandler(View_MagnificationChanged);
                newCanvas.EventSink.MagnificationChanged += new ViewMagnificationEventHandler(View_MagnificationChanged);
                //this.diagram1.EventSink.MagnificationChanged+= new ViewMagnificationEventHandler(View_MagnificationChanged);
             
                
                
                //newCanvas.Controller.View.Magnification += new ViewMagnificationEventHandler(View_MagnificationChanged);
               
                

                
                
               

				//				gms.MagnificationChanged+=new ViewMagnificationEventHandler(gms_MagnificationChanged);
			}


		}


		/// <summary>
		/// Handles the Click event of the barItemPropertiesWindow control.
		/// </summary>
		/// <param name="sender">The source of the event.</param>
		/// <param name="e">The <see cref="System.EventArgs"/> instance containing the event data.</param>
		private void barItemPropertiesWindow_Click(object sender, System.EventArgs e)
		{
			if (this.barItemPropertiesWindow.Checked)
			{
				this.dockingManager1.SetDockVisibility(this.propertyEditor2, false);
				this.barItemPropertiesWindow.Checked = false;
			}
			else
			{
				this.dockingManager1.SetDockVisibility(this.propertyEditor2, true);
				this.barItemPropertiesWindow.Checked = true;
			}

		}


		/// <summary>
		/// Handles the Click event of the barItemSymbolPallette control.
		/// </summary>
		/// <param name="sender">The source of the event.</param>
		/// <param name="e">The <see cref="System.EventArgs"/> instance containing the event data.</param>
		private void barItemSymbolPallette_Click(object sender, System.EventArgs e)
		{

			if (this.barItemSymbolPallette.Checked)
			{
				this.dockingManager1.SetDockVisibility(this.symbolsList1, false);
				this.barItemSymbolPallette.Checked = false;
			}
			else
			{
				this.dockingManager1.SetDockVisibility(this.symbolsList1, true);
				this.barItemSymbolPallette.Checked = true;
			}

		}





		/// <summary>
		/// Handles the Click event of the bItemShowObjectBrowser control.
		/// </summary>
		/// <param name="sender">The source of the event.</param>
		/// <param name="e">The <see cref="System.EventArgs"/> instance containing the event data.</param>
		private void bItemShowObjectBrowser_Click(object sender, System.EventArgs e)
		{

		}





		//		private	void barItemAddPort_Click(object sender, System.EventArgs e)
		//		{
		//			if(this.gms.ActiveManager != null)
		//			{
		//				Canvas activeCanvas	= this.gms.ActiveManager.CanvasObj;
		//				Syncfusion.Windows.Forms.Tools.XPMenus.BarItem barItem = sender	as Syncfusion.Windows.Forms.Tools.XPMenus.BarItem;
		//
		//				if (barItem	!= null)
		//				{
		//					if(activeCanvas.Controller.SelectionList.Count	> 0	&& activeCanvas.Controller.SelectionList.GetType().BaseType == typeof(Symbol))
		//					{
		//						Symbol nde = activeCanvas.Controller.SelectionList as Symbol;
		//						float xoffset =	nde.X -	10f;
		//						PointF ptworld = new PointF(xoffset, nde.Location.Y	+ nde.Height / 2);
		//						PointF[] pts = new PointF[]	{ptworld};
		//						System.Drawing.Drawing2D.Matrix	worldxform = nde.WorldTransform;
		//						worldxform.Invert();
		//						worldxform.TransformPoints(pts);
		//						MoveablePort mp	= new CirclePort(pts[0]);
		//						nde.Ports.Add(mp);	
		//						mp.Enabled = true;
		//						mp.Visible = true;
		//
		//					}
		//				}
		//			}
		//		}





		/// <summary>
		/// Handles the Activated event of the ImplementerScreen control.
		/// </summary>
		/// <param name="sender">The source of the event.</param>
		/// <param name="e">The <see cref="System.EventArgs"/> instance containing the event data.</param>
		private void ImplementerScreen_Activated(object sender, EventArgs e)
		{
			//			PEMainWindow  myMainFrame =	this.MdiParent as PEMainWindow;
			//			StatusBarAdv mainFrameStatusBar	=	myMainFrame.GetStatusBar();
			//			mainFrameStatusBar.Visible = false;
			if (gms.ActiveManager != null && gms.ActiveManager.CanvasObj != null && gms.ActiveManager.CanvasObj.Model != null)
				//gms.ActiveManager.CanvasObj.Model.UpdateViews();
           
            

			if (_implementerPanAndZoom)
				this.SetPanAndZoomVisibility(_implementerPanAndZoom);
			//int i = 0 ;
		}


		/// <summary>
		/// Handles the Deactivate event of the ImplementerScreen control.
		/// </summary>
		/// <param name="sender">The source of the event.</param>
		/// <param name="e">The <see cref="System.EventArgs"/> instance containing the event data.</param>
		private void ImplementerScreen_Deactivate(object sender, EventArgs e)
		{
			//			PEMainWindow  myMainFrame =	this.MdiParent as PEMainWindow;
			//			StatusBarAdv mainFrameStatusBar	=	myMainFrame.GetStatusBar();
			//			mainFrameStatusBar.Visible = true;

			_implementerPanAndZoom = this.GetPanAndZoomVisibility();
			this.SetPanAndZoomVisibility(false);
		}

		/// <summary>
		/// Handles the Click event of the barItem2 control.
		/// </summary>
		/// <param name="sender">The source of the event.</param>
		/// <param name="e">The <see cref="System.EventArgs"/> instance containing the event data.</param>
		private void barItem2_Click(object sender, EventArgs e)
		{
			if (this.barItem2.Checked)
			{
				_app.LRRUIManagerObj.HidePropertyDetailsDialog();
				this.barItem2.Checked = false;
			}
			else
			{
				_app.LRRUIManagerObj.ShowPropertyDetailsDialog();

				if (gms.ActiveManager != null)
					_app.LRRUIManagerObj.UpdatePropertyDetailsPanel(gms);
				this.barItem2.Checked = true;
			}
		}

		/// <summary>
		/// Handles the SelectedIndexChanged event of the toolStripCmbFontFamilyComboBox control.
		/// </summary>
		/// <param name="sender">The source of the event.</param>
		/// <param name="e">The <see cref="System.EventArgs"/> instance containing the event data.</param>
		private void toolStripCmbFontFamilyComboBox_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			try
			{
				if (this.gms.ActiveManager != null)
				{
					Canvas activeCanvas = this.gms.ActiveManager.CanvasObj;
					//	int	selectedIdx	= this.comboBoxFontFamily.ListBox.SelectedIndex;
					int selectedIdx = this.toolStripCmbFontFamily.ComboBox.SelectedIndex;

					if (selectedIdx >= 0)
					{
						//string fontFamily =	(string) this.comboBoxFontFamily.ListBox.Items[selectedIdx];
						string fontFamily = (string)this.toolStripCmbFontFamily.ComboBox.Items[selectedIdx];
						//activeCanvas.Controller.TextEditor.FontFamily = fontFamily;
                        activeCanvas.Controller.TextEditor.FamilyName = fontFamily;
					}
				}
			}
			catch (Exception ex)
			{
				Logger.LogMessage(typeof(ImplementerScreen), "FontFamily_SelectedIndexChanged :" + ex.Message, Logger.Level.Debug);
			}
		}

		//private	void FontFamily_SelectedIndexChanged(object	sender,	System.EventArgs e)
		//{
		//   try
		//   {
		//      if(this.gms.ActiveManager != null)
		//      {
		//         Canvas activeCanvas	= this.gms.ActiveManager.CanvasObj;
		//      //	int	selectedIdx	= this.comboBoxFontFamily.ListBox.SelectedIndex;
		//         int selectedIdx = this.toolStripCmbFontFamily.ComboBox.SelectedIndex;

		//         if (selectedIdx	>= 0)
		//         {
		//            //string fontFamily =	(string) this.comboBoxFontFamily.ListBox.Items[selectedIdx];
		//            string fontFamily = (string)this.toolStripCmbFontFamily.ComboBox.Items[selectedIdx];
		//            activeCanvas.Controller.TextEditor.FontFamily = fontFamily;
		//         }
		//      }
		//   }
		//   catch(Exception ex)
		//   {
		//      Logger.LogMessage(typeof(ImplementerScreen),"FontFamily_SelectedIndexChanged :"+ex.Message  ,Logger.Level.Debug);
		//   }
		//}


		//private	void PointSize_SelectedIndexChanged(object sender, System.EventArgs	e)
		//{
		//   if(this.gms.ActiveManager != null)
		//   {
		//      Canvas activeCanvas	= this.gms.ActiveManager.CanvasObj;
		//   //	int	selectedIdx	= this.comboBoxPointSize.ListBox.SelectedIndex;
		//      int selectedIdx = this.toolStripCmbPointSize.ComboBox.SelectedIndex;
		//      if (selectedIdx	>= 0)
		//      {
		//         //int	ptSize = (int) this.comboBoxPointSize.ListBox.Items[selectedIdx];
		//         int ptSize = (int)this.toolStripCmbPointSize.ComboBox.Items[selectedIdx];
		//         activeCanvas.Controller.TextEditor.PointSize	= (float) ptSize;
		//      }
		//   }
		//}


		/// <summary>
		/// Handles the SelectedIndexChanged event of the toolStripCmbPointSizeComboBox control.
		/// </summary>
		/// <param name="sender">The source of the event.</param>
		/// <param name="e">The <see cref="System.EventArgs"/> instance containing the event data.</param>
		private void toolStripCmbPointSizeComboBox_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			if (this.gms.ActiveManager != null)
			{
				Canvas activeCanvas = this.gms.ActiveManager.CanvasObj;
				//	int	selectedIdx	= this.comboBoxPointSize.ListBox.SelectedIndex;
				int selectedIdx = this.toolStripCmbPointSize.ComboBox.SelectedIndex;
				if (selectedIdx >= 0)
				{
					//int	ptSize = (int) this.comboBoxPointSize.ListBox.Items[selectedIdx];
					int ptSize = (int)this.toolStripCmbPointSize.ComboBox.Items[selectedIdx];
					activeCanvas.Controller.TextEditor.PointSize = (float)ptSize;
				}
			}
		}

		/// <summary>
		/// Handles the Click event of the bItemRuler control.
		/// </summary>
		/// <param name="sender">The source of the event.</param>
		/// <param name="e">The <see cref="System.EventArgs"/> instance containing the event data.</param>
		private void bItemRuler_Click(object sender, EventArgs e)
		{
			if (this.bItemRuler.Checked)
			{
				if (tabControlAdv1 != null && tabControlAdv1.SelectedTab != null && gms.ActiveManager.CanvasObj != null)
				{
					Canvas activeCanvas = gms.ActiveManager.CanvasObj;
					//activeCanvas.View.HorizontalRuler.Visible = false;
					//activeCanvas.View.VerticalRuler.Visible = false;
					this.bItemRuler.Checked = false;
				}
			}
			else
			{
				if (tabControlAdv1 != null && tabControlAdv1.SelectedTab != null && gms.ActiveManager.CanvasObj != null)
				{
					Canvas activeCanvas = gms.ActiveManager.CanvasObj;
					//activeCanvas.View.HorizontalRuler.Visible = true;
                    
					//activeCanvas.View.VerticalRuler.Visible = true;
					this.bItemRuler.Checked = true;
				}
			}
		}

		/// <summary>
		/// Handles the Click event of the barItemNavigation control.
		/// </summary>
		/// <param name="sender">The source of the event.</param>
		/// <param name="e">The <see cref="System.EventArgs"/> instance containing the event data.</param>
		private void barItemNavigation_Click(object sender, EventArgs e)
		{
			if (this.barItemNavigation.Checked)
			{
				this.dockingManager1.SetDockVisibility(this.overViewNavigation, false);
				this.barItemNavigation.Checked = false;
			}
			else
			{
				this.dockingManager1.SetDockVisibility(this.overViewNavigation, true);
				this.barItemNavigation.Checked = true;
			}
		}

		/// <summary>
		/// Sets the pan and zoom visibility.
		/// </summary>
		/// <param name="flag">if set to <c>true</c> [flag].</param>
		public void SetPanAndZoomVisibility(bool flag)
		{
			try
			{
				this.dockingManager1.SetDockVisibility(this.overViewNavigation, flag);
			}
			catch (Exception ex)
			{
				Debug.Assert(false, ex.Message, ex.StackTrace);
			}
            
		}

		/// <summary>
		/// Gets the pan and zoom visibility.
		/// </summary>
		/// <returns></returns>
		public bool GetPanAndZoomVisibility()
		{
			return this.barItemNavigation.Checked;
		}


		/// <summary>
		/// Handles the DockVisibilityChanged event of the dockingManager1 control.
		/// </summary>
		/// <param name="sender">The source of the event.</param>
		/// <param name="arg">The <see cref="Syncfusion.Windows.Forms.Tools.DockVisibilityChangedEventArgs"/> instance containing the event data.</param>
		private void dockingManager1_DockVisibilityChanged(object sender, DockVisibilityChangedEventArgs arg)
		{
			if (arg.Control == this.propertyEditor2)
			{
				this.barItemPropertiesWindow.Checked = this.dockingManager1.GetDockVisibility(this.propertyEditor2);
			}
			else if (arg.Control == this.symbolsList1)
			{
				this.barItemSymbolPallette.Checked = this.dockingManager1.GetDockVisibility(this.symbolsList1);
			}
			else if (arg.Control == this.overViewNavigation)
			{
				this.barItemNavigation.Checked = this.dockingManager1.GetDockVisibility(this.overViewNavigation);
			}

		}

		private string lastGrid = null;

		/// <summary>
		/// Handles the CanvasSelectionChanged event of the gms control.
		/// </summary>
		/// <param name="sender">The source of the event.</param>
		/// <param name="evtArgs">The <see cref="Syncfusion.Windows.Forms.Diagram.NodeCollectionEventArgs"/> instance containing the event data.</param>
		private void gms_CanvasSelectionChanged(CollectionExEventArgs evtArgs)
		{
			try
			{

				if (evtArgs.Element != null)
				{

                    Type bi = evtArgs.Element.GetType();
                    if (evtArgs.Element.GetType().BaseType == typeof(Symbol))
					{

                        Symbol sm = evtArgs.Element as Symbol;
						//if(this.barItemFormatPainter.Checked)
						if (toolStripBtnFormatPainter.Checked)
						{
							if (sourceSymbol != null)
							{
								//gms.ActiveManager.CanvasObj.FormatSymbol(sourceSymbol, sm);
								Cursor myPaintCursor = new Cursor("paintformater.cur");
								this.gms.ActiveManager.CanvasObj.View.Cursor = myPaintCursor;
							}
						}
						else
						{
							this.gms.ActiveManager.CanvasObj.View.Cursor = Cursors.Default;
						}

                        if (evtArgs.Element != null && lastGrid != null && lastGrid != sm.Name)
						{
							DynamicGridcontainer dg = gms.ActiveManager.CanvasObj.Model.GetChildByName(lastGrid) as DynamicGridcontainer;
							if (dg != null)
							{
								dg.cellCtrl_GridCellClick(dg, null);
								lastGrid = null;
							}
						}
						if (sm.GetType() == typeof(DynamicGridcontainer))
						{


							//if (lastGrid != sm.Name)
							//{
							lastGrid = sm.Name;
							//}
							//else
							//{
							//    lastGrid = null;
							//}
							//DynamicGridcontainer grContr = sm as DynamicGridcontainer;
							//if (grContr.SelectedCell != null)
							//{
								//MasterPlantItem mp = grContr.SelectedCell.GetPropertyContainerByName("MasterPlantItem") as MasterPlantItem;
								//if (mp != null)
									//LRRTypeConverter.MasterID = mp.ID;
								//else
									//LRRTypeConverter.MasterID = "";
							//}
						}
                        else if (sm.GetPropertyContainerByName("MasterPlantItem") != null)
						{
                            MasterPlantItem mp = sm.GetPropertyContainerByName("MasterPlantItem") as MasterPlantItem;
							LRRTypeConverter.MasterID = mp.ID;
						}
						else
						{
							LRRTypeConverter.MasterID = "";
						}
                        LRRTypeConverter.SymbolType = evtArgs.Element.GetType();
					}
                    else if (evtArgs.Element.GetType() == typeof(Syncfusion.Windows.Forms.Diagram.Link))
					{
					}
                    else if (evtArgs.Element.GetType() == typeof(Syncfusion.Windows.Forms.Diagram.Label))
					{
					}
					else
					{
					}

				}
				else
				{
				}
			}
			catch (Exception ex)
			{
				Logger.LogMessage(typeof(ImplementerScreen), "gms_CanvasSelectionChanged :" + ex.Message, Logger.Level.Debug);

			}
			this.UpdateUITextFormatting();
			this.ActivateTools();
		}

		/// <summary>
		/// Handles the ChildrenChangeComplete event of the gms control.
		/// </summary>
		/// <param name="sender">The source of the event.</param>
		/// <param name="evtArgs">The <see cref="Syncfusion.Windows.Forms.Diagram.NodeCollectionEventArgs"/> instance containing the event data.</param>
        private void diagram1_ChildrenChangeComplete(CollectionExEventArgs evtArgs)
		{
			try
			{
				//Check	if the node	type is	a sybol	and	if true
				//associate	properties to it.
				if (evtArgs.Element.GetType().BaseType == typeof(Symbol))
				{

					//Symbol symbol	= new Symbol();
					Symbol symbol = evtArgs.Element as Symbol;
                    Type bi = evtArgs.Element.GetType();
					ArrayList aryList = new ArrayList();
					//Assign the selected object's PropertyTable to	the	propertygrid
					//propertyEditor1.PropertyGrid.SelectedObject =	bi.GetProperty("PT").GetValue(evtArgs.Node,	null);
					//Update the BusinesObject Collection 
					//Based	on the changetype


					switch (evtArgs.ChangeType)
					{
						case (CollectionExChangeType.Clear):
							{
								foreach (object obj in gms.ActiveManager.LabelControllerObj.SymbolObjectBinding)
								{
									LabelLookup lblLookup = obj as LabelLookup;
									if (lblLookup != null && lblLookup.SymbolID == symbol.GetPropertyContainerByName("ID").ToString())
										aryList.Add(lblLookup);
								}
								for (int i = 0; i < aryList.Count; i++)
								{
									gms.ActiveManager.LabelControllerObj.SymbolObjectBinding.Remove(aryList[i]);
								}
								aryList.Clear();
								break;
							}

						case (CollectionExChangeType.Insert):
							{
								if (gms.ActiveManager.LabelControllerObj.BusinessObjectCollection.ContainsKey(symbol.GetPropertyContainerByName("ID")))
									//symbol.SetPropertyValue("ID", Guid.NewGuid().ToString());
								gms.ActiveManager.LabelControllerObj.BusinessObjectCollection.Add(symbol.GetPropertyContainerByName("ID"), null);
								break;
							}

						case (CollectionExChangeType.Remove):
							{

								gms.ActiveManager.LabelControllerObj.BusinessObjectCollection.Remove(symbol.GetPropertyContainerByName("ID"));
								foreach (object obj in gms.ActiveManager.LabelControllerObj.SymbolObjectBinding)
								{
									LabelLookup lblLookup = obj as LabelLookup;
									if (lblLookup != null && lblLookup.SymbolID == symbol.GetPropertyContainerByName("ID").ToString())
										aryList.Add(lblLookup);
								}
								for (int i = 0; i < aryList.Count; i++)
								{
									gms.ActiveManager.LabelControllerObj.SymbolObjectBinding.Remove(aryList[i]);
								}
								aryList.Clear();
								break;
							}

						case (CollectionExChangeType.Set):
							{
								LRRMessagBox.ShowMessage("SID_SET", "SID_LABEL", MessageBoxButtons.OK);
								break;
							}
					}
				}

                else if (evtArgs.Element.GetType() == typeof(Syncfusion.Windows.Forms.Diagram.Link))
				{
					if (evtArgs.ChangeType == CollectionExChangeType.Insert)
					{
						//propertyEditor1.PropertyGrid.SelectedObject =	evtArgs.Node;
					}
				}

				else if (evtArgs.Element.GetType() == typeof(RichTextNode))
				{
					if (evtArgs.ChangeType== CollectionExChangeType.Insert)
					{
						//RichTextNode rtNode = evtArgs.ChangeType as RichTextNode;
                        RichTextNode rtNode = evtArgs.Element as RichTextNode;
						rtNode.BackgroundColor = gms.ActiveManager.CanvasObj.Model.BackgroundStyle.Color;
					}

				}
				else if (evtArgs.Element.GetType() == typeof(GridCell))
				{
					if (evtArgs.ChangeType == CollectionExChangeType.Remove)
					{
						GridCell gc = evtArgs.Element as GridCell;
						if (gc.IsBinded)
						{
							gms.ActiveManager.LRRBindingManagerObj.RemoveBinding(gc.Tag, "PropertyValue", gc, true);
							gms.ActiveManager.LRRBindingManagerObj.RemoveBinding(gc.Tag, "ErrCode", gc, true);
						}
					}
				}
				else if (evtArgs.ChangeType == CollectionExChangeType.Insert && (evtArgs.Element.GetType().BaseType == typeof(Syncfusion.Windows.Forms.Diagram.FilledPath) || evtArgs.Element.GetType().BaseType == typeof(Syncfusion.Windows.Forms.Diagram.Shape)))
				{
					SymbolModel smblmdl = new SymbolModel();
                    //PaletteGroupView smblmdl = new PaletteGroupView();
                    
                   
                    //PaletteGroupBar smblmdl = new PaletteGroupBar();

                  
                    
                    
                    
       
                    
					smblmdl.PlugInAssemblyName = "Symcon.Lightridge.LRRUI";
					smblmdl.PlugInClass = "Symcon.Lightridge.LRRUI.Controls.EquipmentProperties";
					smblmdl.Height = gms.ActiveManager.CanvasObj.Model.Size;
					smblmdl.Width = gms.ActiveManager.CanvasObj.Model.Size;
					if (evtArgs.Element.GetType().BaseType == typeof(Shape))
					{
						Shape shape = evtArgs.Element as Shape;
                        //Node shape = evtArgs.Element as Node;
                        
						if (shape.PinPoint.Y == 0)
                           
						{
                            //shape.Height = 0.01f;
                           
						}
                        if (shape.PinPoint.X== 0)
						{
                            //shape.Width = 0.01f;
						}
					}
					else if (evtArgs.Element.GetType().BaseType == typeof(FilledPath))
					{
						FilledPath shape = evtArgs.Element as FilledPath;
                        //FilledPath shape = evtArgs.ChangeType as FilledPath;

                        if (shape.PinPoint.Y == 0)
                           
						{
							//shape.Height = 0.01f;
                            //shape.Size.Height = 0.01f;
                            
                            
                            
                           
                            
                            
						}
                        if (shape.PinPoint.X== 0)
						{
							//shape.Width = 0.01f;
                            //shape.Size.Width = 0.01f;
						}
					}

					//EquipmentProperties smbl = new EquipmentProperties();
					smblmdl.AppendChild(evtArgs.Element as INode);

					//for (int i = evtArgs.Nodes.Length - 1; i >= 0; i--)
					//{
					//    INode node = evtArgs.Nodes[i];
					//    gms.ActiveManager.CanvasObj.Model.RemoveChild(gms.ActiveManager.CanvasObj.Model.GetChildIndex(node));
					//}
					//smblmdl.X = smbl.X;
					//smblmdl.Y = smbl.Y;
					//smblmdl.Height = smbl.Height;
					//smbl.Width = smbl.Width;

					//smblmdl.AppendChild(smbl as INode);

					EquipmentProperties smbl = (EquipmentProperties)smblmdl.CreateSymbol();
					//smbl1.X = 10;
					//smbl1.Y = 10;
					//smbl1.Height = 100;
					//smbl1.Width = 100;
					//gms.ActiveManager.CanvasObj.Model.AppendChild(smbl as INode);
					smbl.LockAspectRatio = false;
					//_toDeleteList.Add(evtArgs.Element);
					//this.gms_MouseUp(null, null);
					// gms.ActiveManager.CanvasObj.SelectionList.Clear();
					//  gms.ActiveManager.CanvasObj.SelectionList.Add(smbl);
					//gms.ActiveManager.CanvasObj.SelectionList.Add(smbl);
					//gms.ActiveManager.CanvasObj.Model.UpdateViews();
					//this.gms_MouseEnter(gms.ActiveManager.CanvasObj, null);
					//evtArgs.Cancel = true;
					//gms.ActiveManager.CanvasObj.Controller..= new Size(2000, 2000);
					//for (INode node in evtArgs.Nodes)
					//{
					//gms.ActiveManager.CanvasObj.SelectionList.Clear();
					//int i = 0;
					//foreach (INode node in evtArgs.Nodes)
					//{
					//gms.ActiveManager.CanvasObj.SelectionList.Add(evtArgs.Node.Name);
					//}
					//gms.ActiveManager.CanvasObj.Controller.Delete();
					//gms.ActiveManager.CanvasObj.Model.RemoveAllChildren();
					//}
					//
					//  gms.ActiveManager.CanvasObj.Model.get
				}
			}
			catch (Exception ex)
			{
				Logger.LogMessage(typeof(ImplementerScreen), "gms_ChildrenChangeComplete :" + ex.Message, Logger.Level.Debug);
			}
		}
		private List<INode> _toDeleteList = new List<INode>();
		/// <summary>
		/// Handles the MagnificationChanged event of the gms control.
		/// </summary>
		/// <param name="sender">The source of the event.</param>
		/// <param name="evtArgs">The <see cref="Syncfusion.Windows.Forms.Diagram.ViewMagnificationEventArgs"/> instance containing the event data.</param>
		private void gms_MagnificationChanged(object sender, ViewMagnificationEventArgs evtArgs)
		{
			UpdateMagnificationComboBox();


		}

		/// <summary>
		/// Handles the NodeDoubleClick event of the gms control.
		/// </summary>
		/// <param name="sender">The source of the event.</param>
		/// <param name="evtArgs">The <see cref="Syncfusion.Windows.Forms.Diagram.NodeMouseEventArgs"/> instance containing the event data.</param>
		/*private void gms_NodeDoubleClick(object sender, NodeMouseEventArgs evtArgs)
		{
			if (gms.ActiveManager.CanvasObj.Controller.NodesHit.Last.GetType() != typeof(LRRLabel))
			{
				if (this.dockingManager1.GetDockVisibility(this.propertyEditor2) == false)
				{
					this.dockingManager1.SetDockVisibility(this.propertyEditor2, true);
				}

				if (evtArgs.Node.GetType().BaseType == typeof(Symbol))
				{

					//if (evtArgs.Node.GetType() == typeof(Navigator))
					//{
					//    Navigator nvg = evtArgs.Node as Navigator;
					//    gms.ActiveManager.CanvasObj.View.Origin = new PointF(nvg.PointX, nvg.PointY);
					//    gms.ActiveManager.CanvasObj.Model.UpdateViews();
					//}
					//else
					//{
					GraphicalLink gphLink = (evtArgs.Node.GetType().GetProperty("Link").GetValue(evtArgs.Node, null)) as GraphicalLink;
					if (gphLink != null)
					{
						OpenLink(gphLink);
					}
					//}
				}
			}
			//evtArgs.ContinueOperation = true;
            
		}*/
        void diagram1_NodeDoubleClick(NodeMouseEventArgs evtArgs)
        {
            if (gms.ActiveManager.CanvasObj.Controller.NodesHit.Last.GetType() != typeof(LRRLabel))
            {
                if (this.dockingManager1.GetDockVisibility(this.propertyEditor2) == false)
                {
                    this.dockingManager1.SetDockVisibility(this.propertyEditor2, true);
                }

                if (evtArgs.Node.GetType().BaseType == typeof(Symbol))
                {

                    //if (evtArgs.Node.GetType() == typeof(Navigator))
                    //{
                    //    Navigator nvg = evtArgs.Node as Navigator;
                    //    gms.ActiveManager.CanvasObj.View.Origin = new PointF(nvg.PointX, nvg.PointY);
                    //    gms.ActiveManager.CanvasObj.Model.UpdateViews();
                    //}
                    //else
                    //{
                    GraphicalLink gphLink = (evtArgs.Node.GetType().GetProperty("Link").GetValue(evtArgs.Node, null)) as GraphicalLink;
                    if (gphLink != null)
                    {
                        OpenLink(gphLink);
                    }
                    //}
                }
            }
            //evtArgs.ContinueOperation = true;

        }

		/// <summary>
		/// Opens the link.
		/// </summary>
		/// <param name="gphLink">The GPH link.</param>
		private void OpenLink(GraphicalLink gphLink)
		{
			string fileID = gphLink.ID;

			switch (gphLink.LinkTypeID)
			{
				case 1:
					OpenFiles(fileID);
					break;
				case 2:
					LRRSearchCriteria lrrsc = LRRModel.ChildModel.SearchCriterias.GetSearchCriteriaByID(fileID);
					LoadQuery(lrrsc);
					break;
				case 3:
					LRRUnifiedViewSearchCrtiteria lrrunifiedViewSearchCriteria = LRRModel.ChildModel.UnifiedViewSearchCrtiterias.GetUnifiedViewByID(fileID);
					LRRViewManager.OpenUnifiedView(lrrunifiedViewSearchCriteria);
					break;
				case 4:
					LRRCompositeView compView = LRRModel.ChildModel.CompositeViews.GetCompositeViewFromID(fileID);
					LRRViewManager.OpenCompositeView(compView);
					break;
				case 5:
					LRRExcelView excelView = LRRModel.ChildModel.ExcelViews.GetExcelViewFromID(fileID);
					LRRViewManager.OpenExcelView(excelView);
					break;
				case 6:
					LRRMultiAttributeTrendInfo multiTrendInfo = LRRModel.ChildModel.MultiTrendInfosObj.GetMultiTrendFromID(fileID);
					LRRViewManager.OpenMultiTrend(multiTrendInfo);
					break;
				default:
					break;
			}
		}


		/// <summary>
		/// Handles the OverrideValueClick event of the gms control.
		/// </summary>
		/// <param name="sender">The source of the event.</param>
		/// <param name="e">The <see cref="System.EventArgs"/> instance containing the event data.</param>
		private void gms_OverrideValueClick(object sender, EventArgs e)
		{
			if (gms.ActiveManager.CanvasObj.Controller.NodesHit.Last.GetType() == typeof(GridCell))
			{
				//GridCell lbl = gms.ActiveManager.CanvasObj.Controller.NodesHit.Last as GridCell;
                GridCell lbl = ((PathNode)this.gms.ActiveManager.CanvasObj.Controller.NodesHit.Last).Labels[0] as GridCell;
				object objPropValue = lbl.Tag;
				IPropertyValue ipropVal = lbl.Tag as IPropertyValue;
				MenuItem miItem = sender as MenuItem;
				if (objPropValue != null)
				{
					LRRSiteComponentPropertyValue lrrPropVal = ipropVal as LRRSiteComponentPropertyValue;
					if (lrrPropVal != null)
					{
						LRRSiteComponentProperty lrrScp = LRRModel.SiteComponentPropertiesObj.GetSiteCompPropFromID(lbl.PropertyID);
						GraphicsSiteComponentUtilities.OnOverrideValueClickForSiteComponent(miItem, ipropVal, lrrScp);
						GraphicsUtilities.SetColor(lbl, ipropVal);
						//gms.ActiveManager.CanvasObj.Model.UpdateViews();
                        
					}
					else if (objPropValue is LRRAggregatePropertyValue)
					{
						LRRAggregatePropertyValue aggrePropVal = ipropVal as LRRAggregatePropertyValue;
						LRRAggregateProperty aggProp = LRRModel.AggregatePropertiesObj.GetAggregatePropFromID(aggrePropVal.AggregateID);
						GraphicsAggregatesUtilities.OnOverrideValueClickForSiteComponent(miItem, ipropVal, aggProp);
						GraphicsUtilities.SetColor(lbl, ipropVal);
						//gms.ActiveManager.CanvasObj.Model.UpdateViews();
					}
				}
			}
			else
			{

				//LRRLabel lbl = gms.ActiveManager.CanvasObj.Controller.NodesHit.Last as LRRLabel;
                LRRLabel lbl = ((PathNode)this.gms.ActiveManager.CanvasObj.Controller.NodesHit.Last).Labels[0] as LRRLabel;
				object objPropValue = lbl.Tag;
				IPropertyValue ipropVal = lbl.Tag as IPropertyValue;
				MenuItem miItem = sender as MenuItem;

				if (objPropValue != null)
				{
					LRRSiteComponentPropertyValue lrrPropVal = ipropVal as LRRSiteComponentPropertyValue;
					if (lrrPropVal != null)
					{
						LRRLabel parentLbl = GraphicsUtilities.GetParentLabel(lbl);
						LRRSiteComponentProperty lrrScp = parentLbl.Tag as LRRSiteComponentProperty;
						GraphicsSiteComponentUtilities.OnOverrideValueClickForSiteComponent(miItem, ipropVal, lrrScp);
					}
					else
					{
						LRRSiteGroupPropertyQualifierValue lrrGpropQValue = ipropVal as LRRSiteGroupPropertyQualifierValue;
						if (lrrGpropQValue != null)
						{
							GraphicsSiteComponentUtilities.OnOverrideValueClickForGroupProp(miItem, ipropVal);
							GraphicsUtilities.SetColor(lbl, ipropVal);
							//gms.ActiveManager.CanvasObj.Model.UpdateViews();
						}
						else
						{
							LRRAggregatePropertyValue aggPropValue = ipropVal as LRRAggregatePropertyValue;
							LRRAggregateProperty aggProperty = LRRModel.AggregatePropertiesObj.GetAggregatePropFromID(aggPropValue.AggregateID);
							GraphicsAggregatesUtilities.OnOverrideValueClickForSiteComponent(miItem, ipropVal, aggProperty);
							GraphicsUtilities.SetColor(lbl, ipropVal);
							//gms.ActiveManager.CanvasObj.Model.UpdateViews();
						}
					}
				}
			}
		}

		/// <summary>
		/// GMS_s the label property value changed.
		/// </summary>
		/// <param name="sender">The sender.</param>
		/// <param name="propertyName">Name of the property.</param>
		private void gms_LabelPropertyValueChanged(object sender, string propertyName)
		{
			this.propertyEditor2.PropertyGrid.Refresh();
		}

		/// <summary>
		/// Handles the MouseEnter event of the gms control.
		/// </summary>
		/// <param name="sender">The source of the event.</param>
		/// <param name="evtArgs">The <see cref="Syncfusion.Windows.Forms.Diagram.NodeMouseEventArgs"/> instance containing the event data.</param>
		private void gms_MouseEnter(NodeMouseEventArgs evtArgs)
		{
			//gms.ActiveManager.CanvasObj.View.WorkArea.Inflate(2000, 2000);

			GraphicsUtilities.ActivateToolTip(evtArgs, _toolTip, gms);

		}

		/// <summary>
		/// Handles the MapProperties event of the gms control.
		/// </summary>
		/// <param name="sender">The source of the event.</param>
		/// <param name="e">The <see cref="System.EventArgs"/> instance containing the event data.</param>
		private void gms_MapProperties(object sender, EventArgs e)
		{
			this.gms.OnMapProperties(GraphicsManagers.UserMode.IMPLEMENTOR);
		}

		/// <summary>
		/// Handles the ShowAttributeDetails event of the gms control.
		/// </summary>
		/// <param name="sender">The source of the event.</param>
		/// <param name="e">The <see cref="System.EventArgs"/> instance containing the event data.</param>
		private void gms_ShowAttributeDetails(object sender, EventArgs e)
		{
			try
			{
				if (!this.barItem2.Checked)
				{
					_app.LRRUIManagerObj.ShowPropertyDetailsDialog();

					this.barItem2.Checked = true;
				}
				_app.LRRUIManagerObj.UpdatePropertyDetailsPanel(gms);
			}
			catch (Exception ex)
			{
				Logger.LogMessage(typeof(ImplementerScreen), "gms_LabelDoubleClick :" + ex.Message, Logger.Level.Debug);
			}
		}

		/// <summary>
		/// Handles the SelectedAttributeDetails event of the gms control.
		/// </summary>
		/// <param name="sender">The source of the event.</param>
		/// <param name="e">The <see cref="System.EventArgs"/> instance containing the event data.</param>
		private void gms_SelectedAttributeDetails(object sender, EventArgs e)
		{
			Canvas activeCanvas = gms.ActiveManager.CanvasObj;
			if (activeCanvas.Controller.SelectionList != null && activeCanvas.Controller.SelectionList.GetType() == typeof(DynamicGridcontainer))
			{
				gms.OnGridCellMapping();
				propertyEditor2.PropertyGrid.Update();
				propertyEditor2.PropertyGrid.Refresh();

			}
			else
			{
				this.gms.OnMapProperties(GraphicsManagers.UserMode.IMPLEMENTOR);
			}
		}
		/// <summary>
		/// Handles the SelectDisplayUOM event of the gms control.
		/// </summary>
		/// <param name="sender">The source of the event.</param>
		/// <param name="e">The <see cref="System.EventArgs"/> instance containing the event data.</param>
		private void gms_SelectDisplayUOM(object sender, EventArgs e)
		{
			if (gms.ActiveManager.CanvasObj.Controller.NodesHit.Last.GetType() == typeof(GridCell))
			{
				GraphicsUtilities.OnUOMChangeForGridCell(gms.ActiveManager.CanvasObj.Controller.NodesHit.Last, null);

			}
			else
			{

				//LRRLabel selectedLbl = gms.ActiveManager.CanvasObj.Controller.NodesHit.Last as LRRLabel;
                LRRLabel selectedLbl = ((PathNode)this.gms.ActiveManager.CanvasObj.Controller.NodesHit.Last).Labels[0] as LRRLabel;
                //LRRLabel selectedLbl = gms.ActiveManager.CanvasObj.Model.Nodes.Last as LRRLabel;

                PathNode smbl = selectedLbl.Container.Parent as PathNode;
                //Node smbl = selectedLbl.IsParent as Node;
				if (selectedLbl != null)
				{
					foreach (LRRLabel lbl in smbl.Labels)
					{
						if (lbl.IsUOM && lbl.ParentID == selectedLbl.ParentID)
						{
							if (lbl.ID != null && lbl.Tag != null)
							{
								LRRUOMType lrrUOMType = lbl.Tag as LRRUOMType;
								if (lrrUOMType != null)
									GraphicsUtilities.ChangeUOMClick(lbl, lrrUOMType.UOMTypeID);
								break;
							}
						}
					}
				}
			}
			//gms.ActiveManager.CanvasObj.Model.UpdateViews();
		}

		/// <summary>
		/// Handles the LabelDoubleClick event of the gms control.
		/// </summary>
		/// <param name="sender">The source of the event.</param>
		/// <param name="evtArgs">The <see cref="Syncfusion.Windows.Forms.Diagram.NodeMouseEventArgs"/> instance containing the event data.</param>
		private void gms_LabelDoubleClick(NodeMouseEventArgs evtArgs)
		{
			if (this.barItem2.Checked)
			{
				//_app.LRRUIManagerObj.HidePropertyDetailsDialog();
				//this.barItem2.Checked =	false;
			}
			else
			{
				_app.LRRUIManagerObj.ShowPropertyDetailsDialog();
				_app.LRRUIManagerObj.UpdatePropertyDetailsPanel(gms);
				this.barItem2.Checked = true;
			}

		}

		/// <summary>
		/// Handles the MagnificationChanged event of the View control.
		/// </summary>
		/// <param name="sender">The source of the event.</param>
		/// <param name="evtArgs">The <see cref="Syncfusion.Windows.Forms.Diagram.ViewMagnificationEventArgs"/> instance containing the event data.</param>
		private void View_MagnificationChanged(ViewMagnificationEventArgs evtArgs)
		{
			UpdateMagnificationComboBox();
			// gms.ActiveManager.CanvasObj.Model.X = 0;
			// gms.ActiveManager.CanvasObj.Model.Y = 0;
		}
      

		/// <summary>
		/// Handles the ViewTrend event of the gms control.
		/// </summary>
		/// <param name="sender">The source of the event.</param>
		/// <param name="e">The <see cref="System.EventArgs"/> instance containing the event data.</param>
		private void gms_ViewTrend(object sender, EventArgs e)
		{
			MenuItem mItemChild = sender as MenuItem;
			if (mItemChild != null)
			{
				string trendScheme = mItemChild.Text;

				if (gms.ActiveManager.CanvasObj.Controller.NodesHit.Last.GetType() == typeof(GridCell))
				{
				   //GridCell gCell = gms.ActiveManager.CanvasObj.Controller.SelectionList.Last as GridCell;
                   GridCell gCell = ((PathNode)this.gms.ActiveManager.CanvasObj.Controller.SelectionList.Last).Labels[0] as GridCell;
                  
                    //GridCell gCell = gms.ActiveManager.CanvasObj.Model.Nodes.Last as GridCell;

					IProperty iProp = LRRModel.SiteComponentPropertiesObj.GetSiteCompPropFromID(gCell.PropertyID);
					_app.LRRUIManagerObj.ShowTrend(trendScheme, iProp, gCell.ModeID, gCell.UIUOMID);
				}
				else
				{
					//LRRLabel selectedLbl = gms.ActiveManager.CanvasObj.Controller.NodesHit.Last as LRRLabel;
					//GraphicsUtilities.OnVeiwTrend(trendScheme, selectedLbl);
				}
			}
		}

		/// <summary>
		/// Handles the SetLabelsVisibility event of the gms control.
		/// </summary>
		/// <param name="sender">The source of the event.</param>
		/// <param name="e">The <see cref="System.EventArgs"/> instance containing the event data.</param>
		private void gms_SetLabelsVisibility(object sender, EventArgs e)
		{
            PathNode smbl = sender as PathNode;
			SetLabelsVisibility slblVisibility = new SetLabelsVisibility(smbl, this.gms.ActiveManager.CanvasObj.Model);
			slblVisibility.ShowDialog(this);
		}

		/// <summary>
		/// Handles the ChangeGridDimensions event of the gms control.
		/// </summary>
		/// <param name="sender">The source of the event.</param>
		/// <param name="e">The <see cref="System.EventArgs"/> instance containing the event data.</param>
		private void gms_ChangeGridDimensions(object sender, EventArgs e)
		{
			GridDimensionDialog grdDimDlg = new GridDimensionDialog(gms.ActiveManager.CanvasObj.Controller.SelectionList.First as DynamicGridcontainer);
			if (DialogResult.OK == grdDimDlg.ShowDialog())
			{
				//gms.ActiveManager.CanvasObj.Model.UpdateViews();
                
                
			}
		}

		/// <summary>
		/// Handles the Closed event of the ImplementerScreen control.
		/// </summary>
		/// <param name="sender">The source of the event.</param>
		/// <param name="e">The <see cref="System.EventArgs"/> instance containing the event data.</param>
		private void ImplementerScreen_Closed(object sender, EventArgs e)
		{
			//toolStripCmbMagnify.Dispose();
			//toolStripCmbFontFamily.Dispose();
			//toolStripCmbPointSize.Dispose();
			toolStripCmbMagnify.Items.Clear();
			toolStripCmbFontFamily.Items.Clear();
			toolStripCmbPointSize.Items.Clear();
			_app.MainFrame.Refresh();
			_app.MainFrame.Activate();
		}


		/// <summary>
		/// Handles the Click event of the bItemBold control.
		/// </summary>
		/// <param name="sender">The source of the event.</param>
		/// <param name="e">The <see cref="System.EventArgs"/> instance containing the event data.</param>
		private void bItemBold_Click(object sender, EventArgs e)
		{
			if (this.gms.ActiveManager != null)
			{
				Canvas activeCanvas = this.gms.ActiveManager.CanvasObj;
				bool newValue = !(activeCanvas.Controller.TextEditor.Bold);
				activeCanvas.Controller.TextEditor.Bold = newValue;
				this.bItemBold.Checked = newValue;
			}


		}


		/// <summary>
		/// Handles the Click event of the bItemUnderline control.
		/// </summary>
		/// <param name="sender">The source of the event.</param>
		/// <param name="e">The <see cref="System.EventArgs"/> instance containing the event data.</param>
		private void bItemUnderline_Click(object sender, EventArgs e)
		{
			if (this.gms.ActiveManager != null)
			{
				Canvas activeCanvas = this.gms.ActiveManager.CanvasObj;
				bool newValue = !(activeCanvas.Controller.TextEditor.Underline);
				activeCanvas.Controller.TextEditor.Underline = newValue;
				this.bItemUnderline.Checked = newValue;
			}
		}


		/// <summary>
		/// Handles the Click event of the bItemItalic control.
		/// </summary>
		/// <param name="sender">The source of the event.</param>
		/// <param name="e">The <see cref="System.EventArgs"/> instance containing the event data.</param>
		private void bItemItalic_Click(object sender, EventArgs e)
		{
			if (this.gms.ActiveManager != null)
			{
				Canvas activeCanvas = this.gms.ActiveManager.CanvasObj;
				bool newValue = !(activeCanvas.Controller.TextEditor.Italic);
				activeCanvas.Controller.TextEditor.Italic = newValue;
				bItemItalic.Checked = newValue;
			}
		}


		/// <summary>
		/// Handles the Click event of the bItemAlignLeft control.
		/// </summary>
		/// <param name="sender">The source of the event.</param>
		/// <param name="e">The <see cref="System.EventArgs"/> instance containing the event data.</param>
		private void bItemAlignLeft_Click(object sender, EventArgs e)
		{
			if (this.gms.ActiveManager != null)
			{
				Canvas activeCanvas = this.gms.ActiveManager.CanvasObj;
				//activeCanvas.Controller.TextEditor.HorizontalAlignment = StringAlignment.Near;
                activeCanvas.Controller.TextEditor.HorizontalAlignment = StringAlignment.Near;
				this.bItemAlignLeft.Checked = true;
				this.bItemAlignCenter.Checked = false;
				this.bItemAlignRight.Checked = false;
			}
		}


		/// <summary>
		/// Handles the Click event of the bItemAlignCenter control.
		/// </summary>
		/// <param name="sender">The source of the event.</param>
		/// <param name="e">The <see cref="System.EventArgs"/> instance containing the event data.</param>
		private void bItemAlignCenter_Click(object sender, EventArgs e)
		{
			if (this.gms.ActiveManager != null)
			{
				Canvas activeCanvas = this.gms.ActiveManager.CanvasObj;
				activeCanvas.Controller.TextEditor.HorizontalAlignment = StringAlignment.Center;
				this.bItemAlignCenter.Checked = true;
				this.bItemAlignLeft.Checked = false;
				this.bItemAlignRight.Checked = false;
			}
		}


		/// <summary>
		/// Handles the Click event of the bItemAlignRight control.
		/// </summary>
		/// <param name="sender">The source of the event.</param>
		/// <param name="e">The <see cref="System.EventArgs"/> instance containing the event data.</param>
		private void bItemAlignRight_Click(object sender, EventArgs e)
		{
			if (this.gms.ActiveManager != null)
			{
				Canvas activeCanvas = this.gms.ActiveManager.CanvasObj;
				activeCanvas.Controller.TextEditor.HorizontalAlignment = StringAlignment.Far;
				this.bItemAlignRight.Checked = true;
				this.bItemAlignLeft.Checked = false;
				this.bItemAlignCenter.Checked = false;
			}
		}


		/// <summary>
		/// Handles the Click event of the bItemTextColor control.
		/// </summary>
		/// <param name="sender">The source of the event.</param>
		/// <param name="e">The <see cref="System.EventArgs"/> instance containing the event data.</param>
		private void bItemTextColor_Click(object sender, EventArgs e)
		{
			if (this.gms.ActiveManager != null)
			{
				Canvas activeCanvas = this.gms.ActiveManager.CanvasObj;
				ColorDialog dlg = new ColorDialog();
				dlg.Color = activeCanvas.Controller.TextEditor.TextColor;
				if (dlg.ShowDialog(this) == DialogResult.OK)
				{
					activeCanvas.Controller.TextEditor.TextColor = dlg.Color;
				}
			}
		}
		#endregion

		#region	Protected Methods

		/*protected Link CreateDirectedLink(PointF[] pts)
		{
			try
			{
				Symcon.Lightridge.LRRUI.Controls.Tools.SimpleLink link = new Symcon.Lightridge.LRRUI.Controls.Tools.SimpleLink(Syncfusion.Windows.Forms.Diagram.Link.Shapes.Default, pts);
                
                link.LineStyle.LineWidth = 1;
				EndPointDecoratorModel decoratorMdl = Syncfusion.Windows.Forms.Diagram.Global.EndPointDecoratorPalette["Filled Arrow"];
              
                //Decorator decoratorMdl = Syncfusion.Windows.Forms.Diagram.Global.EndPointDecoratorPalette["Filled Arrow"];
				if (decoratorMdl != null)
				{
					link.EndPoints.LastEndPointDecorator = decoratorMdl.CreateInstance();
                    
                    
				}
				return link;
			}
			catch (Exception ex)
			{
				Logger.LogMessage(typeof(ImplementerScreen), "CreateDirectedLink :" + ex.Message, Logger.Level.Debug);
				return null;
			}
		}*/


		/*protected Link CreateLink(PointF[] pts)
		{
			try
			{
				Symcon.Lightridge.LRRUI.Controls.Tools.SimpleLink link = new Symcon.Lightridge.LRRUI.Controls.Tools.SimpleLink(Syncfusion.Windows.Forms.Diagram.Link.Shapes.Default, pts);
				link.LineStyle.LineWidth = 1;
				return link;
			}
			catch (Exception ex)
			{
				Logger.LogMessage(typeof(ImplementerScreen), "CreateLink :" + ex.Message, Logger.Level.Debug);
				return null;
			}
		}*/


		/*protected Link CreateOrthogonalLink(PointF[] pts)
		{
			try
			{
				Symcon.Lightridge.LRRUI.Controls.Tools.OrthogonalLink link = new Symcon.Lightridge.LRRUI.Controls.Tools.OrthogonalLink(pts);
				link.LineStyle.LineWidth = 1;
				return link;
			}
			catch (Exception ex)
			{
				Logger.LogMessage(typeof(ImplementerScreen), "CreateOrthogonalLink :" + ex.Message, Logger.Level.Debug);
				return null;
			}
		}*/


		/*protected Link CreateArcLink(PointF[] pts)
		{
			try
			{
				Symcon.Lightridge.LRRUI.Controls.Tools.SimpleLink link = new Symcon.Lightridge.LRRUI.Controls.Tools.SimpleLink(Syncfusion.Windows.Forms.Diagram.Link.Shapes.Arc, pts);
				link.LineStyle.LineWidth = 1;
				return link;
			}
			catch (Exception ex)
			{
				Logger.LogMessage(typeof(ImplementerScreen), "CreateArcLink :" + ex.Message, Logger.Level.Debug);
				return null;
			}
		}*/



		#endregion

		#region	Private	Methods


		public void OpenFiles(string fileID)
		{
			object[] objArray = new object[1];
			objArray[0] = fileID;
			_app.MainFrame.BeginInvoke(_openFile, objArray);
		}


		private void SaveFiles(string fileName, string fileDescription, string fileId)
		{
			if (gms.ActiveManager != null)
			{
				Canvas selectedCanvas = gms.ActiveManager.CanvasObj;
				MemoryStream ms = null;
				BinaryReader br = null;
				try
				{
					ms = new MemoryStream();
					BinaryFormatter formatter = new BinaryFormatter();
					formatter.Binder = Syncfusion.Runtime.Serialization.AppStateSerializer.CustomBinder;
					formatter.AssemblyFormat = FormatterAssemblyStyle.Simple;
					//DiagramDocument doc = new DiagramDocument(selectedCanvas.Model, selectedCanvas.View, (DiagramScript)selectedCanvas.ScriptingManager.Script);
					//formatter.Serialize(ms, doc);
					ms.Position = 0;
					br = new BinaryReader(ms);
					byte[] fileData = br.ReadBytes((int)ms.Length);
					LRRSavedView lrrsv = new LRRSavedView();
					lrrsv.SavedViewName = fileName;
					lrrsv.ID = selectedCanvas.FileID;
					lrrsv.SavedViewDescription = fileDescription;
					LRRSavedViewData lrsvd = new LRRSavedViewData();
					lrsvd.ViewBlob = fileData;
					lrsvd.ID = selectedCanvas.FileID;
					foreach (LRRSavedView savedView in lrrSavedViews)
					{
						if (savedView.ID == lrrsv.ID)
						{
							lrrsv.ObjectState = Symcon.Globals.Enums.DBOperation.UPDATE;
							lrsvd.ObjectState = Symcon.Globals.Enums.DBOperation.DELETE;
						}
					}
					_app.DBManagerObj.CommitObject(lrrsv);
					if (!LRRModel.SavedViews.Contains(lrrsv) && lrrsv.ObjectState != Symcon.Globals.Enums.DBOperation.UPDATE)
					{
						LRRModel.SavedViews.Add(lrrsv);
					}
					_app.DBManagerObj.CommitObject(lrsvd);
					if (lrsvd.ObjectState == Symcon.Globals.Enums.DBOperation.DELETE)
					{
						lrsvd.ObjectState = Symcon.Globals.Enums.DBOperation.INSERT;
						_app.DBManagerObj.CommitObject(lrsvd);
					}
					if (!(gms.OpenedViews.ContainsKey(selectedCanvas.FileID)))
						gms.OpenedViews.Add(selectedCanvas.FileID, selectedCanvas);
					tabControlAdv1.SelectedTab.Text = fileName;
					if (fileDescription != null && fileDescription.Trim() != "")
						tabControlAdv1.SelectedTab.ToolTipText = fileDescription;
					if (!gms.HashGmIDFileIDMap.ContainsKey(selectedCanvas.FileID))
					{
						gms.HashGmIDFileIDMap.Add(selectedCanvas.FileID, gms.ActiveManager.ID);
					}


					selectedCanvas.Model.Modified = false;
					if (_app.GetOptions().PublishGraphics && _app.GraphicsManagersObj != null)
					{
						Canvas activeCanvas = _app.GraphicsManagersObj.OpenedViews[lrrsv.ID] as Canvas;
						if (activeCanvas != null && gms.OpenedViews.ContainsKey(activeCanvas.FileID))
						{
							//  _app.GraphicsManagersObj.OpenedViews.Remove(activeCanvas.FileID);
							string gmKey = _app.GraphicsManagersObj.HashGmIDFileIDMap[activeCanvas.FileID].ToString();
							_app.GraphicsManagersObj.SetActiveGraphicsManager(gmKey);
							_app.GraphicsManagersObj.ActiveManager.LRRBindingManagerObj.RemoveBinding();
							_app.GraphicsManagersObj.RemoveGraphicsManager(gmKey);
						}
						_app.LoadPublishCanvas(LRRModel.ProjectModes, LRRModel.SavedViews.GetSavedViewFromID(lrrsv.ID));
					}
				}
				catch (Exception ex)
				{
					Logger.LogMessage(typeof(ImplementerScreen), "SaveFiles :" + ex.Message, Logger.Level.Debug);
				}
				finally
				{
					if (br != null)
						br.Close();
					if (ms != null)
						ms.Close();
					ms = null;
					br = null;
				}
			}
		}


		///	<summary>
		///	Occurs when	the	canvas is being	closed
		///	</summary>
		///	<returns></returns>
		private bool CanvasClosing()
		{
			if (gms.ActiveManager != null)
			{
				Canvas activeCanvas = gms.ActiveManager.CanvasObj;

				//check	if canvas has been Modified
				if (activeCanvas.Model.Modified)
				{
					//Confirm Saving Changes
					//DialogResult res = MessageBox.Show(this, "The diagram "	+ tabControlAdv1.SelectedTab.Text +	" has been modified." +'\n'+"Save changes?", "Save changes", MessageBoxButtons.YesNoCancel,	MessageBoxIcon.Warning,	MessageBoxDefaultButton.Button3);
					string[] s = new string[1];
					s[0] = tabControlAdv1.SelectedTab.Text;
					DialogResult res = LRRMessagBox.ShowMessage(this, "SID_SAVE_DIAGRAM", "SID_LABEL", s, MessageBoxButtons.YesNoCancel, MessageBoxIcon.Warning, MessageBoxDefaultButton.Button3);
					//Save changes
					if (res == DialogResult.Yes)
					{
						fileDialog = new FileDialog(GraphicsManagers.FileDialogMode.SaveAs, GraphicsManagers.UserMode.IMPLEMENTOR);
						if (activeCanvas.HasFileName)
						{
							//this.fileDialog.FileName = activeCanvas.FileName;
							this.SaveFiles(activeCanvas.FileName, activeCanvas.FileDescription, activeCanvas.FileID);
							CloseTabPage(activeCanvas);
							return true;
						}
						if (this.fileDialog.ShowDialog(this) == DialogResult.OK)
						{
							activeCanvas.FileName = this.fileDialog.FileName;
							this.SaveFiles(this.fileDialog.FileName, fileDialog.FileDescription, fileDialog.FileID);
							CloseTabPage(activeCanvas);
							return true;
						}
						else
						{
							return false;
						}
					}
					//Don Nothing
					else if (res == DialogResult.Cancel)
					{
						return false;
					}
					else
					{
						CloseTabPage(activeCanvas);
						return true;
					}
				}
				else
				{
					CloseTabPage(activeCanvas);
					return true;
				}
			}
			else
			{
				return true;
			}
		}


		///	<summary>
		///	Unhook Events and clear	Opend view Hashtable Entry 
		///	</summary>
		///	<param name="activeCanvas"></param>
		private void CloseTabPage(Canvas activeCanvas)
		{
			if (activeCanvas.FileID != null && gms.OpenedViews.ContainsKey(activeCanvas.FileID))
			{
				gms.OpenedViews.Remove(activeCanvas.FileID);
			}
            DeactivateMarkers();
			gms.ActiveManager.LRRBindingManagerObj.RemoveBinding();
			gms.RemoveGraphicsManager(gms.ActiveManager.ID);
			//if(!_isFormClosing)
			//{
			this.tabControlAdv1.SelectedTab.Dispose();
			//}
			if (this.tabControlAdv1.TabCount == 0)
			{
				pnlCanvasHeader.Hide();
				tabControlAdv1.ThemesEnabled = false;
				this.propertyEditor2.PropertyGrid.SelectedObject = null;
				this.propertyEditor2.Canvas = null;
				this.symbolsList1.Canvas = null;
				_app.LRRUIManagerObj.HidePropertyDetailsDialog();

			}
		}


		///	<summary>
		///	Activate toolbar for the canvas	and	hook events
		///	</summary>
		///	<param name="newCanvas"></param>
		private void ActivateLinkTools(Canvas newCanvas)
		{
			try
			{
				// Create and register a tool for orthogonal links
                //LineConnectorTool simpleLinkTool = new LineConnectorTool("ConnectorTool");
                
                
				//LinkTool simpleLinkTool = new LinkTool("ConnectorTool");
				//simpleLinkTool.LinkFactory = new LinkFactory(this.CreateLink);
                
				//newCanvas.Controller.RegisterTool(simpleLinkTool);
                Tool linkTool = this.diagram1.Controller.GetTool("ConnectorTool");

                //((LineConnectorTool)linkTool).LinkFactory = new LinkFactory(this.CreateLink);
             
                this.diagram1.Controller.RegisterTool(linkTool); 


				// Create and register a tool for orthogonal links
             
				//LinkTool orthogonalLinkTool = new LinkTool("OrthogonalLinkTool");
				//orthogonalLinkTool.LinkFactory = new LinkFactory(this.CreateOrthogonalLink);
				//newCanvas.Controller.RegisterTool(orthogonalLinkTool);
                Tool orthogonalLinkTool = this.diagram1.Controller.GetTool("OrthogonalLinkTool");

                //((LineConnectorTool)linkTool).LinkFactory = new LinkFactory(this.CreateLink);

                this.diagram1.Controller.RegisterTool(orthogonalLinkTool); 

				// Create and register a tool for directed links
             
				//LinkTool directedLinkTool = new LinkTool("DirectedLinkTool");
               
				//directedLinkTool.LinkFactory = new LinkFactory(this.CreateDirectedLink);
				//newCanvas.Controller.RegisterTool(directedLinkTool);
                Tool directedLinkTool = this.diagram1.Controller.GetTool("ConnectorTool");

                //((LineConnectorTool)linkTool).LinkFactory = new LinkFactory(this.CreateLink);

                this.diagram1.Controller.RegisterTool(directedLinkTool); 


				// Create and register a tool for arc links
				//LinkTool arcLinkTool = new LinkTool("ArcLinkTool");
				//arcLinkTool.LinkFactory = new LinkFactory(this.CreateArcLink);
              
				//newCanvas.Controller.RegisterTool(arcLinkTool);
                Tool arcLinkTool = this.diagram1.Controller.GetTool("ArcLinkTool");

                //((LineConnectorTool)linkTool).LinkFactory = new LinkFactory(this.CreateLink);

                this.diagram1.Controller.RegisterTool(arcLinkTool); 



				//LinkTool verticalLinkTool = new LinkTool("VerticalLink");
				//verticalLinkTool.LinkFactory = new LinkFactory(this.CreateVerticalLink);
                
				//newCanvas.Controller.RegisterTool(verticalLinkTool);
                Tool verticalLinkTool = this.diagram1.Controller.GetTool("VerticalLink");

                //((LineConnectorTool)linkTool).LinkFactory = new LinkFactory(this.CreateLink);

                this.diagram1.Controller.RegisterTool(verticalLinkTool); 
                

				//LinkTool rightAngleLinkTool = new LinkTool("RightAngleLink");
				//rightAngleLinkTool.LinkFactory = new LinkFactory(this.CreateRightAngleLink);
				//newCanvas.Controller.RegisterTool(rightAngleLinkTool);
                Tool rightAngleLinkTool = this.diagram1.Controller.GetTool("RightAngleLink");

                //((LineConnectorTool)linkTool).LinkFactory = new LinkFactory(this.CreateLink);

                this.diagram1.Controller.RegisterTool(rightAngleLinkTool); 


				//this.overViewNavigation.Model = newCanvas.Model;
				//this.overViewNavigation.View = newCanvas.View;

				UpdateMagnificationComboBox();

				//this.bItemShowGrid.Checked = newCanvas.View.Grid.Visible;
				//this.bItemSnapToGrid.Checked = newCanvas.View.Grid.SnapToGrid;
				this.toolStripBtnShowGrid.Checked = newCanvas.View.Grid.Visible;
				this.toolStripBtnSnapToGrid.Checked = newCanvas.View.Grid.SnapToGrid;

				if (this.tabControlAdv1.TabCount == 1)
				{
					pnlCanvasHeader.Show();
					tabControlAdv1.ThemesEnabled = true;
				}
			}
			catch (Exception ex)
			{
				Logger.LogMessage(typeof(ImplementerScreen), "ActivateLinkTools :" + ex.Message, Logger.Level.Debug);
			}

		}

		/*private Link CreateVerticalLink(PointF[] pts)
		{
			Symcon.Lightridge.LRRUI.Controls.Tools.VerticalLink verticalLink = new Symcon.Lightridge.LRRUI.Controls.Tools.VerticalLink(pts);
			verticalLink.LineStyle.LineWidth = 1;
			return verticalLink;
		}*/

		/*private Link CreateRightAngleLink(PointF[] pts)
		{
			Symcon.Lightridge.LRRUI.Controls.Tools.RightAngleLink rightAngleLink = new Symcon.Lightridge.LRRUI.Controls.Tools.RightAngleLink(pts);
			rightAngleLink.LineStyle.LineWidth = 1;
			return rightAngleLink;
		}*/


		///	<summary>
		///	To update the Magnification	ComboBox based on the magnification	
		///	</summary>
		private void UpdateMagnificationComboBox()
		{
			Canvas activeCanvas = gms.ActiveManager.CanvasObj;
            //System.Drawing.Size szMag = activeCanvas.Controller.Magnification;
            System.Drawing.Size szMag = activeCanvas.Controller.View.Size;
            //System.Drawing.Size szMag = activeCanvas.Magnification;
            
			if (this.toolStripCmbMagnify.ComboBox.SelectedItem != null)
			{
				this.toolStripCmbMagnify.ComboBox.SelectedItem = szMag.Width + "%";
				if (this.toolStripCmbMagnify.ComboBox.SelectedItem.ToString() != szMag.Width + "%")
				{
					if (!(toolStripCmbMagnify.ComboBox.Items.Contains(szMag.Width + "%")))
					{
						this.toolStripCmbMagnify.ComboBox.Items.Add(szMag.Width + "%");
						this.toolStripCmbMagnify.ComboBox.SelectedItem = szMag.Width + "%";
						//this.toolStripCmbMagnify.ComboBox.Sorted = true;
						//this.toolStripCmbMagnify.Sorted = true;
					}
				}
			}
			else if (this.toolStripCmbMagnify.ComboBox.Text != null)
			{
				if (!(toolStripCmbMagnify.ComboBox.Items.Contains(szMag.Width + "%")))
				{
					this.toolStripCmbMagnify.ComboBox.Items.Add(szMag.Width + "%");
					this.toolStripCmbMagnify.ComboBox.SelectedItem = szMag.Width + "%";
					sortCmbValues(this.toolStripCmbMagnify);
				}
				else
				{
					this.toolStripCmbMagnify.ComboBox.SelectedItem = szMag.Width + "%";
				}
			}
			activeCanvas.View.Origin = new PointF(0, 0);

		}


		///	<summary>
		///	Gets Canvas	Data from the DB when opening saved	View
		///	</summary>
		///	<param name="fileID"></param>
		///	<returns></returns>
		public LRRSavedViewData GetCanvasData(string fileID)
		{
			try
			{
				string whereClause = "	WHERE ID = '" + fileID + "'"; //	Where Clause for Querying the DB
				LRRSavedViewDatas lrrSavedViewDatas = new LRRSavedViewDatas();
				_app.DBManagerObj.PopulateCollection(lrrSavedViewDatas, whereClause);//Fetch	Saved View data	using FileID
				LRRSavedViewData myobj = lrrSavedViewDatas[0];
				return myobj;
			}
			catch (Exception ex)
			{
				Logger.LogMessage(typeof(ImplementerScreen), "GetCanvasData :" + ex.Message, Logger.Level.Debug);

				return null;
			}
		}

		private void SetPanel(ArrayList pnlCollection)
		{
			int heightOfEach = pnlQueryView.Height / pnlCollection.Count;
			int splitCnt = 0;
			for (int i = pnlCollection.Count - 1; i >= 0; i--)
			{
				Panel panel = pnlCollection[i] as Panel;
				panel.Height = heightOfEach;
				pnlQueryView.Controls.Add(panel);
				if (splitCnt < pnlCollection.Count - 1)
				{
					Splitter splitGrid = new Splitter();
					splitGrid.Dock = DockStyle.Top;
					pnlQueryView.Controls.Add(splitGrid);
					splitCnt++;
				}
			}
			if (pnlQueryView.Controls.Count > 0)
				pnlQueryView.Controls[0].Dock = DockStyle.Fill;
		}

		private void LoadFontSelections()
		{
			// Create ListBox containing names of font families	and	attach it to the
			// font	family combo box bar item
			//this.comboBoxFontFamily.ListBox	= new ListBox();
			//	this.toolStripCmbFontFamily.ComboBox = new ComboBox();//check this 

			for (int i = 0; i < this.toolStripCmbFontFamily.ComboBox.Items.Count; i++)
			{
				toolStripCmbFontFamily.ComboBox.Items[i] = null;
			}
			foreach (FontFamily curFontFamily in System.Drawing.FontFamily.Families)
			{
				this.toolStripCmbFontFamily.ComboBox.Items.Add(curFontFamily.Name);
				//this.comboBoxFontFamily.ListBox.Items.Add(curFontFamily.Name);
			}
			//this.comboBoxFontFamily.ListBox.SelectedIndexChanged +=	new	System.EventHandler(this.FontFamily_SelectedIndexChanged);
			this.toolStripCmbFontFamily.ComboBox.SelectedIndexChanged += new EventHandler(toolStripCmbFontFamilyComboBox_SelectedIndexChanged);

			// Create ListBox containing point sizes and attach	to the point size combo
			// box bar item
			ListBox pointSizeListBox = new ListBox();
			int[] ptSizes = new int[] { 8, 9, 10, 11, 12, 14, 16, 18, 20, 22, 24, 26, 28, 36, 48, 72 };
			foreach (int ptSize in ptSizes)
			{
				pointSizeListBox.Items.Add(ptSize);
			}
			for (int k = 0; k < pointSizeListBox.Items.Count; k++)
			{
				if (!toolStripCmbPointSize.ComboBox.Items.Contains(pointSizeListBox.Items[k]))
					toolStripCmbPointSize.ComboBox.Items.Add(pointSizeListBox.Items[k]);
			}
			this.toolStripCmbPointSize.ComboBox.SelectedIndexChanged += new EventHandler(this.toolStripCmbPointSizeComboBox_SelectedIndexChanged);
		}

		private void UpdateUITextFormatting()
		{
			Canvas activeCanvas = gms.ActiveManager.CanvasObj;
			Syncfusion.Windows.Forms.Diagram.Controller controller = activeCanvas.Controller;

			// Update font family bar item
            
			//string fontFamily = controller.TextEditor.FontFamily;
            string fontFamily = activeCanvas.Controller.TextEditor.FamilyName;
            
            
            
			if (fontFamily != null && fontFamily.Length > 0)
			{
				bool found = false;

				//for	(int itemIdx = 0; !found &&	itemIdx	< this.comboBoxFontFamily.ListBox.Items.Count; itemIdx++)
				for (int itemIdx = 0; !found && itemIdx < this.toolStripCmbFontFamily.ComboBox.Items.Count; itemIdx++)
				{
					//string curFontFamilyName = (string)	this.comboBoxFontFamily.ListBox.Items[itemIdx];
					string curFontFamilyName = (string)this.toolStripCmbFontFamily.ComboBox.Items[itemIdx];

					if (curFontFamilyName == fontFamily)
					{
						//this.comboBoxFontFamily.ListBox.SelectedIndex =	itemIdx;
						//this.comboBoxFontFamily.TextBoxValue = fontFamily;
						this.toolStripCmbFontFamily.ComboBox.SelectedIndex = itemIdx;
						this.toolStripCmbFontFamily.ComboBox.SelectedItem = fontFamily;
						this.toolStripCmbFontFamily.ComboBox.SelectedText = fontFamily;
						found = true;

					}
				}
			}

			// Update Bold,	Italic,	and	Underline bar items
			//	this.bItemBold.Checked = controller.TextEditor.Bold;
			//	this.bItemItalic.Checked = controller.TextEditor.Italic;
			//	this.bItemUnderline.Checked	= controller.TextEditor.Underline;
			//this.toolStripBtnBold.Checked = controller.TextEditor.Bold;
			//this.toolStripBtnItalic.Checked = controller.TextEditor.Italic;
			//this.toolStripBtnUnderLine.Checked = controller.TextEditor.Underline;

			// Update point	size bar item
            float ptSize = activeCanvas.Controller.TextEditor.PointSize;
            
			//this.comboBoxPointSize.TextBoxValue	= ptSize.ToString();
			toolStripCmbPointSize.Text = ptSize.ToString();

			// Update text alignment bar items
			//StringAlignment horzAlign = controller.TextEditor.HorizontalAlignment;
            StringAlignment horzAlign = activeCanvas.Controller.TextEditor.HorizontalAlignment;
			if (horzAlign == StringAlignment.Near)
			{
				//this.bItemAlignLeft.Checked	= true;
				//this.bItemAlignCenter.Checked =	false;
				//this.bItemAlignRight.Checked = false;
				this.toolStripBtnTLeft.Checked = true;
				this.toolStripBtnTCenter.Checked = false;
				this.toolStripBtnTRight.Checked = false;
			}
			else if (horzAlign == StringAlignment.Center)
			{
				this.toolStripBtnTLeft.Checked = false;
				this.toolStripBtnTCenter.Checked = true;
				this.toolStripBtnTRight.Checked = false;
				//this.bItemAlignLeft.Checked	= false;
				//this.bItemAlignCenter.Checked =	true;
				//this.bItemAlignRight.Checked = false;
			}
			else if (horzAlign == StringAlignment.Far)
			{
				this.toolStripBtnTLeft.Checked = false;
				this.toolStripBtnTCenter.Checked = false;
				this.toolStripBtnTRight.Checked = true;
				//this.bItemAlignLeft.Checked	= false;
				//this.bItemAlignCenter.Checked =	false;
				//this.bItemAlignRight.Checked = true;
			}
		}


		private void LoadQuery(LRRSearchCriteria lrrsc)
		{
			if (gms.GridView != null)
			{
				Symcon.LightRidge.PEAdvisor.IOScreen.IGridFactory iGridFactory = gms.GridView as Symcon.LightRidge.PEAdvisor.IOScreen.IGridFactory;
				if (iGridFactory != null)
				{
					iGridFactory.ClearAllBindings();
					iGridFactory.UnSubscribeReconnectCompleted();
				}
				else
				{
					Symcon.LightRidge.PEAdvisor.GroupProperties.IGroupGridFactory iGrpGridFactory = gms.GridView as Symcon.LightRidge.PEAdvisor.GroupProperties.IGroupGridFactory;
					if (iGrpGridFactory != null)
					{
						iGrpGridFactory.ClearAllBindings();
						iGrpGridFactory.UnSubscribeReconnectCompleted();
					}
				}
			}
			pnlQueryView.Controls.Clear();

			LRRModes lrrModes = LRRModel.ProjectModes;

			SearchRetrievalUtility searchUtil = new SearchRetrievalUtility();
			LRRSiteComponents lrrSiteComponents = searchUtil.PopulateSiteComponents(lrrsc.ID);

			//Aggregates
			LRRAggregates lrrResultAggregates = searchUtil.PopulateAggregates(lrrsc.ID);

			string sSource = lrrsc.Source == null ? "" : lrrsc.Source.ToString(Symcon.BusinessObjects.SymConverter.Culture);
			if (sSource == "I/O")
			{
				LRRSearchCriteria lrrSearchCriteria = lrrsc;

				string templateClass = lrrSearchCriteria.TemplateClass;
				switch (templateClass)
				{
					case "Symcon.LightRidge.PEAdvisor.GridSimpleView":
						templateClass = "Symcon.LightRidge.PEAdvisor.IOScreen.GridSimpleViewController";
						break;
					case "Symcon.LightRidge.PEAdvisor.GridTransposedView":
						templateClass = "Symcon.LightRidge.PEAdvisor.IOScreen.GridTransposedViewController";
						break;
					case "Symcon.LightRidge.PEAdvisor.GridSimpleGroupedModeView":
						templateClass = "Symcon.LightRidge.PEAdvisor.IOScreen.GridSimpleGroupedModeViewController";
						break;
					case "Symcon.LightRidge.PEAdvisor.GridTransposedGroupedModeView":
						templateClass = "Symcon.LightRidge.PEAdvisor.IOScreen.GridTransposedGroupedModeViewController";
						break;
					default:
						templateClass = templateClass;
						break;
				}

				Type gridType = Type.GetType(templateClass);
				object gridView = Activator.CreateInstance(gridType);
				gms.GridView = gridView;
				Symcon.LightRidge.PEAdvisor.IOScreen.IGridFactory objGrid = gridView as Symcon.LightRidge.PEAdvisor.IOScreen.IGridFactory;
				ArrayList custCollection = new ArrayList();
				custCollection.Add(lrrSiteComponents);
				custCollection.Add(lrrResultAggregates);
				objGrid.SearchQuery.SearchQuery.UserSettingsID = lrrSearchCriteria.UserSettingsID;

				LRRSearchCriteriaItemProperties srchCriteriaItemProps = new LRRSearchCriteriaItemProperties();
				this._app.DBManagerObj.PopulateCollection(srchCriteriaItemProps, " where SearchCriteriaID = '" + lrrSearchCriteria.ID + "'");

				objGrid.LoadPanel(custCollection, srchCriteriaItemProps);

				ArrayList arrList = objGrid.GetPanelCollection();
				if (arrList.Count > 0)
				{
					SetPanel(arrList);
				}
				if (!dockingManager1.GetDockVisibility(pnlQueryView))
					dockingManager1.SetDockVisibility(pnlQueryView, true);
				gms.HideColumns();

			}
			else
			{
				LRRSearchCriteria lrrSearchCriteria = lrrsc;
				Type gridType = Type.GetType(lrrSearchCriteria.TemplateClass);
				object gridView = Activator.CreateInstance(gridType);
				gms.GridView = gridView;
				Symcon.LightRidge.PEAdvisor.GroupProperties.IGroupGridFactory objGrid = gridView as Symcon.LightRidge.PEAdvisor.GroupProperties.IGroupGridFactory;
				LRRLookUpProperties objLookUpProperties = new LRRLookUpProperties();
				LRRLookUpQualifiers objLookUpQualifiers = new LRRLookUpQualifiers();
				LRRSearchCriteriaPropertyTypes lrrSearchCriteriaPropertyTypes = new LRRSearchCriteriaPropertyTypes();
				_app.DBManagerObj.PopulateCollection(lrrSearchCriteriaPropertyTypes, " WHERE SearchCriteriaID = '" + lrrsc.ID + "'", false);
				LRRQualifiers objQualifiers = new LRRQualifiers();
				LRRSiteComponents objModelComponent = LRRModel.SiteComponentsObj;
				LRRSiteComponents objSiteCompCollection = new LRRSiteComponents();
				string qualIDs = "";

				////////////				LRRSearchCriteriaQualifiers lrrSrchCriteriaQualifiers = new LRRSearchCriteriaQualifiers();
				////////////                _app.DBManagerObj.PopulateCollection(lrrSrchCriteriaQualifiers,false);
				////////////				LRRSearchCriteriaQualifiers lrrSrchCriteriaQuals = lrrSrchCriteriaQualifiers.FilterBySearchCriteriaID(lrrsc.ID); 
				////////////
				////////////				foreach(LRRSearchCriteriaQualifier lrrSearchCriteriaQual in lrrSrchCriteriaQuals)
				////////////				{
				////////////					if( qualIDs=="")
				////////////					{
				////////////						qualIDs="'" + lrrSearchCriteriaQual.QualifierID + "'";
				////////////					}
				////////////					else
				////////////						qualIDs=qualIDs + ",'" + lrrSearchCriteriaQual.QualifierID + "'";
				////////////				
				////////////				}
				////////////				_app.DBManagerObj.PopulateCollection(objLookUpQualifiers," WHERE LookupQualifierID IN (" + qualIDs + ")",false);
				////////////
				////////////				foreach(LRRSiteComponent objSiteComponent in lrrSiteComponents)
				////////////				{
				////////////					LRRSiteComponent objModelSiteComponent = objModelComponent.GetSiteComponentByID(objSiteComponent.SiteComponentID);
				////////////					objSiteCompCollection.Add(objModelSiteComponent);
				////////////				}
				////////////
				////////////				ArrayList custCollection = new ArrayList();
				////////////				custCollection.Add(objSiteCompCollection);
				////////////				custCollection.Add(objLookUpQualifiers);
				///

				ArrayList custCollection = new ArrayList();
				foreach (LRRSiteComponent objSiteComponent in lrrSiteComponents)
				{
					LRRSiteComponent objModelSiteComponent = objModelComponent.GetSiteComponentByID(objSiteComponent.SiteComponentID);
					objSiteCompCollection.Add(objModelSiteComponent);
				}
				//LRRSearchCriteriaPropertyTypes srchPropTypes = _lrrSearchCriteriaPropertyTypes.FilterBySearchCriteriaID(lrrSearchCriteria.ID);
				LRRSearchCriteriaPropertyTypes srchPropTypes = lrrSearchCriteriaPropertyTypes;
				if (srchPropTypes.Count > 0)
				{
					LRRSearchCriteriaPropertyType srchPropType = srchPropTypes[0];
					LRRPropertyType propTypeObj = LRRModel.ChildModel.PropertyTypes.getPropertyTypeForID(srchPropType.PropertyType);
					if (propTypeObj != null && propTypeObj.IsDataArray)
					{
						LRRPropertyTypes objPropTypes = new LRRPropertyTypes();
						foreach (LRRSearchCriteriaPropertyType srchCriteriaPropType in srchPropTypes)
						{
							LRRPropertyType lrrPropTypeObj = LRRModel.ChildModel.PropertyTypes.getPropertyTypeForID(srchCriteriaPropType.PropertyType);
							objPropTypes.Add(lrrPropTypeObj);
						}
						custCollection.Add(objPropTypes);
						custCollection.Add(objSiteCompCollection);
					}
					else
					{
						LRRSearchCriteriaQualifiers lrrSrchCriteriaQualifiers = new LRRSearchCriteriaQualifiers();
						_app.DBManagerObj.PopulateCollection(lrrSrchCriteriaQualifiers, false);
						LRRSearchCriteriaQualifiers lrrSrchCriteriaQuals = lrrSrchCriteriaQualifiers.FilterBySearchCriteriaID(lrrsc.ID);
						foreach (LRRSearchCriteriaQualifier lrrSearchCriteriaQual in lrrSrchCriteriaQuals)
						{
							if (qualIDs == "")
							{
								qualIDs = "'" + lrrSearchCriteriaQual.QualifierID + "'";
							}
							else
								qualIDs = qualIDs + ",'" + lrrSearchCriteriaQual.QualifierID + "'";

						}

						_app.DBManagerObj.PopulateCollection(objLookUpQualifiers, " WHERE LookupQualifierID IN (" + qualIDs + ")", false);
						custCollection.Add(objSiteCompCollection);
						custCollection.Add(objLookUpQualifiers);
					}

				}

				LRRSearchCriteriaItemGroupPropertiesUIUOMs srchCriteriaUIUOMs = null;
				srchCriteriaUIUOMs = new LRRSearchCriteriaItemGroupPropertiesUIUOMs();
				this._app.DBManagerObj.PopulateCollection(srchCriteriaUIUOMs, " where SearchCriteriaID = '" + lrrSearchCriteria.ID + "'");

				objGrid.LoadPanel(custCollection, srchCriteriaUIUOMs);//Change to UIUOMs collection

				ArrayList arrList = objGrid.GetPanelCollection();
				if (arrList.Count > 0)
				{
					SetPanel(arrList);
				}
				if (!dockingManager1.GetDockVisibility(pnlQueryView))
					dockingManager1.SetDockVisibility(pnlQueryView, true);
			}
		}


		private void WireGmsEvents(GraphicsManagers gms)
		{
			//this.gms.CanvasSelectionChanged += new NodeCollectionEventHandler(gms_CanvasSelectionChanged);
            this.gms.CanvasSelectionChanged += new CollectionExEventHandler(gms_CanvasSelectionChanged);
            
            
            //this.gms.CanvasSelectionChanged += new NodeSelectedEventHandler(gms_CanvasSelectionChanged);
			//this.gms.ChildrenChangeComplete += new CollectionExEventHandler(gms_ChildrenChangeComplete);
            this.diagram1.Model.EventSink.NodeCollectionChanged += new CollectionExEventHandler(diagram1_ChildrenChangeComplete);
            //this.gms.ChildrenChangeComplete += new Syncfusion.Windows.Forms.Diagram.NodeCollection(gms

            //this.gms.ChildrenChangeComplete += new CollectionExEventHandler(gms_ChildrenChangeComplete);
			this.gms.MapProperties += new EventHandler(gms_MapProperties);
			this.gms.ShowAttributeDetails += new EventHandler(gms_ShowAttributeDetails);
			this.gms.SelectedAttributeDetails += new EventHandler(gms_SelectedAttributeDetails);
			this.gms.SetLabelsVisibility += new EventHandler(gms_SetLabelsVisibility);
			this.gms.SelectDisplayUOM += new EventHandler(gms_SelectDisplayUOM);
			this.gms.ViewTrend += new EventHandler(gms_ViewTrend);
			//this.gms.NodeDoubleClick += new NodeMouseEventHandler(gms_NodeDoubleClick);
            //this.gms.NodeDoubleClick += new EventHandler(gms_NodeDoubleClick);
            this.diagram1.EventSink.NodeDoubleClick += new NodeMouseEventHandler(diagram1_NodeDoubleClick);
			this.gms.OverrideValueClick += new EventHandler(gms_OverrideValueClick);
			this.gms.LabelPropertyValueChanged += new PropertyChanged(gms_LabelPropertyValueChanged);
			this.gms.LabelDoubleClick += new NodeMouseEventHandler(gms_LabelDoubleClick);
			//this.gms.MouseEnter += new NodeMouseEventHandler(gms_MouseEnter);
            //this.gms.MouseEnter += new MouseEventHandler(gms_MouseEnter);
            this.gms.MouseEnter += new NodeMouseEventHandler(gms_MouseEnter);
            
          

            //this.gms.MouseEnter += new MouseEventHandler(gms_MouseEnter);
			this.gms.ChangeGridDimensions += new EventHandler(gms_ChangeGridDimensions);
			this.gms.RemoveRow += new EventHandler(gms_RemoveRow);
			//this.gms.RemoveColumn += new EventHandler(gms_RemoveColumn);
			this.gms.SetCustomFormat += new EventHandler(gms_SetCustomFormat);
			this.gms.SetCustomFormatGridCell += new EventHandler(gms_SetCustomFormatGridCell);
			this.gms.MouseUp += new MouseEventHandler(gms_MouseUp);
			this.gms.ResetGridCell += new EventHandler(gms_ResetGridCell);
			this.gms.ResetNode += new EventHandler(gms_ResetNode);
		}

		void gms_RemoveRow(object sender, EventArgs e)
		{
			DynamicGridcontainer dg = gms.ActiveManager.CanvasObj.Controller.SelectionList.First as DynamicGridcontainer;
			if (dg != null)
				dg.RemoveRow();
		}

		/*void gms_RemoveColumn(object sender, EventArgs e)
		{
			DynamicGridcontainer dg = gms.ActiveManager.CanvasObj.Controller.SelectionList.First as DynamicGridcontainer;
			if (dg != null)
				dg.RemoveColumn();
            
            //dg.ResizeColumn();
		}*/


		void gms_ResetNode(object sender, EventArgs e)
		{
			//Symbol smb = gms.ActiveManager.CanvasObj.Controller.SelectionList.First as Symbol;

			//removing the binding from the labels
            //PathNode mySymbol = gms.ActiveManager.CanvasObj.Controller.SelectionList.First as PathNode;
            Syncfusion.Windows.Forms.Diagram.Group mySymbol = gms.ActiveManager.CanvasObj.Controller.SelectionList.First as Syncfusion.Windows.Forms.Diagram.Group;
            if (mySymbol == null)
            {
                return;   
            }
			//Get the PropertyTable	Associated with	the	selected Node
			Symcon.Lightridge.LRRUI.PropertyTable pt = null;//=	
			pt = mySymbol.GetPropertyContainerByName("PT") as PropertyTable;
			for (int i = pt.Properties.Count; i > 0; i--)
			{
				PropertySpec ps = pt.Properties[i - 1] as PropertySpec;

				if (ps.Category == "Bound Properties")
				{
					pt.Properties.Remove(ps);
				}
				if (ps.Name == "MasterPlantItem")
				{
					ps.DefaultValue = null;
				}
				if (ps.Name == "PlantItem")
				{
					ps.DefaultValue = null;
				}
			}
			ArrayList arryList = new ArrayList();
			//Get all the selected symbol items	from
			//SymbolObjectBinding to an	ArrayList
			foreach (DictionaryEntry obj in gms.ActiveManager.LabelControllerObj.SymbolObjectBinding)
			{
				LabelLookup lblLookup = obj.Key as LabelLookup;
				if (lblLookup.SymbolID == mySymbol.GetPropertyContainerByName("ID").ToString())
					arryList.Add(lblLookup);
			}

			for (int i = 0; i < arryList.Count; i++)
			{
				gms.ActiveManager.LabelControllerObj.SymbolObjectBinding.Remove(arryList[i]);
			}
			arryList.Clear();
			//Clear	value of BusinessObjectCollection attached to 
			//this SymbolName
			gms.ActiveManager.LabelControllerObj.BusinessObjectCollection[mySymbol.GetPropertyContainerByName("ID")] = null;
			//	mySymbol.SetPropertyValue("PT",pt) ;
			for (int i = mySymbol.Labels.Count; i > 0; i--)
			{
				LRRLabel lrrLabel = mySymbol.Labels[i - 1] as LRRLabel;
				if (lrrLabel.Tag != null && lrrLabel.Tag.GetType() == typeof(IPropertyValue))
				{
					gms.ActiveManager.LRRBindingManagerObj.RemoveBinding(lrrLabel.Tag, "PropertyValue", mySymbol.Labels[i - 1], true);
					gms.ActiveManager.LRRBindingManagerObj.RemoveBinding(lrrLabel.Tag, "ErrCode", lrrLabel, true);
				}

			}
            
            //mySymbol.SetPropertyValue("MasterPlantItem",null);
            //mySymbol.SetPropertyValue("PlantItem", null);
			GraphicsUtilities.ResetLabels(mySymbol);

			//this.gms.ActiveManager.CanvasObj.Model.UpdateViews();
			//this.gms.ActiveManager.CanvasObj.Refresh();
			// mySymbol.SetPropertyValue("MasterPlantItem", null);
			//mySymbol.SetPropertyValue("PlantItem", null);
			this.propertyEditor2.PropertyGrid.Refresh();

		}
		void gms_ResetGridCell(object sender, EventArgs e)
		{
			DynamicGridcontainer dg = gms.ActiveManager.CanvasObj.Controller.SelectionList.First as DynamicGridcontainer;
			GridCell gridCell = dg.SelectedCell;// as GridCell;
			//            GridCell gridCell = dg.SelectedCell;
			if (gridCell != null && gridCell.IsBinded)
			{

				gms.ActiveManager.LRRBindingManagerObj.RemoveBinding(gridCell.Tag, "PropertyValue", gridCell, true);
				gms.ActiveManager.LRRBindingManagerObj.RemoveBinding(gridCell.Tag, "ErrCode", gridCell, true);
				gridCell.IsBinded = false;
				gridCell.UIUOMID = null;
				gridCell.UOMTypeID = null;
				gridCell.Tag = null;
				gridCell.ModeID = null;
				gridCell.Type = null;
				gridCell.PropertyID = null;
				gridCell.BackgroundStyle.Color = Color.Transparent;
                
				//gridCell.BorderStyle.BorderColor = dg.GridBorderColor;
				//gridCell.BorderStyle.BorderWidth = dg.GridBorderWidth;
				gridCell.Text = "";
				gridCell.Description = "";
				gridCell.FontStyle.Style = System.Drawing.FontStyle.Regular;
				gridCell.GridCellDoubleClick -= new NodeMouseEventHandler(GraphicsUtilities.OnUOMChangeForGridCell);
                //gridCell.GridCellDoubleClick -= new NodeMouseEventHandler(gCell_GridCellDoubleClick);
               
				gridCell.MasterPlantItem = null;
				gridCell.PlantItem = null;
				for (int i = gridCell.PT.Properties.Count - 1; i > 0; i--)
				{
					PropertySpec ps = gridCell.PT.Properties[i] as PropertySpec;
					if (ps.Category == "Bound Properties")
					{
						gridCell.PT.Properties.Remove(ps);
					}
					if (ps.Name == "MasterPlantItem")
					{
						ps.DefaultValue = null;
					}
					if (ps.Name == "PlantItem")
					{
						ps.DefaultValue = null;
					}
				}
				//gms.ActiveManager.CanvasObj.Model.UpdateViews();
			}
		}

		void gms_MouseUp(object sender, MouseEventArgs e)
		{
			for (int i = _toDeleteList.Count; i > 0; i--)
			{
				//if (gms.ActiveManager.CanvasObj.Model.GetChildIndex(_toDeleteList[i - 1]) != -1)
				//{
					//gms.ActiveManager.CanvasObj.Model.RemoveChild(gms.ActiveManager.CanvasObj.Model.GetChildIndex(_toDeleteList[i - 1]));
					//gms.ActiveManager.CanvasObj.Model.UpdateViews();
				//}
			}

			_toDeleteList.Clear();
		}




		private void UnWireGmsEvents(GraphicsManagers gms)
		{
			this.gms.CanvasSelectionChanged -= new CollectionExEventHandler(gms_CanvasSelectionChanged);
           
            //this.gms.ChildrenChangeComplete -= new CollectionExEventHandler(gms_ChildrenChangeComplete);
            this.diagram1.Model.EventSink.NodeCollectionChanged-= new CollectionExEventHandler(diagram1_ChildrenChangeComplete);
			this.gms.MapProperties -= new EventHandler(gms_MapProperties);
			this.gms.ShowAttributeDetails -= new EventHandler(gms_ShowAttributeDetails);
			this.gms.SelectedAttributeDetails -= new EventHandler(gms_SelectedAttributeDetails);
			this.gms.SetLabelsVisibility -= new EventHandler(gms_SetLabelsVisibility);
			this.gms.SelectDisplayUOM -= new EventHandler(gms_SelectDisplayUOM);
			this.gms.ViewTrend -= new EventHandler(gms_ViewTrend);
			//this.gms.NodeDoubleClick -= new NodeMouseEventHandler(gms_NodeDoubleClick);
            this.diagram1.EventSink.NodeDoubleClick-= new NodeMouseEventHandler(diagram1_NodeDoubleClick);
            
            //this.gms.NodeDoubleClick -= new NodeEventHandler(gms_NodeDoubleClick);
			this.gms.OverrideValueClick -= new EventHandler(gms_OverrideValueClick);
			this.gms.LabelPropertyValueChanged -= new PropertyChanged(gms_LabelPropertyValueChanged);
			this.gms.LabelDoubleClick -= new NodeMouseEventHandler(gms_LabelDoubleClick);
            
			this.gms.MouseEnter -= new NodeMouseEventHandler(gms_MouseEnter);
			this.gms.ChangeGridDimensions -= new EventHandler(gms_ChangeGridDimensions);
			this.gms.SetCustomFormat -= new EventHandler(gms_SetCustomFormat);
			this.gms.SetCustomFormatGridCell -= new EventHandler(gms_SetCustomFormatGridCell);
			this.gms.MouseUp -= new MouseEventHandler(gms_MouseUp);
			this.gms.ResetGridCell -= new EventHandler(gms_ResetGridCell);
			this.gms.ResetNode -= new EventHandler(gms_ResetNode);
		}


		private void OnOpenFile(string fileID)
		{
			if (fileID != null && gms.OpenedViews.ContainsKey(fileID))
			{
				foreach (TabPageAdv tp in tabControlAdv1.TabPages)
				{
					Canvas openCanvas = tp.Controls[0] as Canvas;
					if (openCanvas.FileID == fileID)
					{
						tabControlAdv1.SelectedTab = tp;
						break;
					}
				}
			}
			else
			{
				try
				{

					//this.SuspendLayout();
					overViewNavigation.SuspendLayout();
					LRRSavedView lrsv = lrrSavedViews.GetSavedViewFromID(fileID);
					LRRWaitWindowUtility.ShowPogressIndicator(lrsv.SavedViewName);
					if (lrsv == null)
						return;
					gms.CreateGraphicsManager(fileID);
					Canvas canvas = gms.ActiveManager.CanvasObj;
					canvas.BeginUpdate();
					TabPageAdv tabPage = new TabPageAdv();
					tabPage.TabBackColor = Color.LightBlue;
					tabPage.TabForeColor = Color.Black;
					tabPage.Controls.Add(canvas);
					tabPage.Tag = gms.ActiveManager.ID;
					tabControlAdv1.Controls.Add(tabPage);
					canvas.FileDescription = lrsv.SavedViewDescription;
					if (lrsv.SavedViewDescription != null && lrsv.SavedViewDescription.Trim() != "")
						tabPage.ToolTipText = lrsv.SavedViewDescription;
					tabControlAdv1.SelectedTab = tabPage;
					canvas.FileName = lrsv.SavedViewName;
					canvas.FileID = lrsv.ID;
					tabPage.Text = canvas.FileName;
					propertyEditor2.Canvas = canvas;
					symbolsList1.Canvas = canvas;
					gms.OpenedViews.Add(lrsv.ID, canvas);
					gms.ActiveManager.BindSymbols(gms.SelectedModes, GraphicsManagers.PropertiesMappingMode.OPEN, GraphicsManagers.UserMode.IMPLEMENTOR);
					//canvas.View.HorizontalRuler.Visible = bItemRuler.Checked;
                   
					//canvas.View.VerticalRuler.Visible = bItemRuler.Checked;
					canvas.Model.Modified = false;
					//canvas.Model.UpdateViews();
					ArrayList toDeleteNodes = new ArrayList();
					PointF pt = new PointF(0, 0);
					foreach (INode node in canvas.Model.Nodes)
					{
						if (node.Name.StartsWith("CustomProperties"))
						{
							CustomProperties cp = node as CustomProperties;
							if (cp.PinPoint== pt)
                             
							{
                                if (cp.PinPoint.Y== 0 && cp.PinPoint.X== 0)
								{
									toDeleteNodes.Add(node);
								}
							}
						}
					}
					foreach (INode node in toDeleteNodes)
					{
						this.gms.ActiveManager.CanvasObj.Controller.SelectionList.Clear();
						//this.gms.ActiveManager.CanvasObj.SelectionList.Add(node);
						this.gms.ActiveManager.CanvasObj.Controller.Delete();
                   
						//this.gms.ActiveManager.CanvasObj.SelectionList.Clear();
					}
					canvas.EndUpdate(true);
				}

				catch (Exception ex)
				{
					Logger.LogMessage(typeof(ImplementerScreen), "OpenFiles :" + ex.Message, Logger.Level.Debug);
				}
				finally
				{
					overViewNavigation.ResumeLayout();
					LRRWaitWindowUtility.EndProgressIndicator();
					//	this.ResumeLayout();
				}
			}

		}

		private void OnIdle(object sender, EventArgs e)
		{
			this.barItem2.Checked = _app.LRRUIManagerObj.IsPropertyDialogVisible;

			if (gms.ActiveManager != null)
			{
				bItemText.Enabled = true;
				bItemTextColor.Enabled = true;
				bItemUnderline.Enabled = true;
				bItemRichText.Enabled = true;
				bItemItalic.Enabled = true;
				bItemBold.Enabled = true;
				biPrintZooming.Enabled = true;
				bItemClose.Enabled = true;
				toolStripbtnChangeDemsion.Enabled = true;
				toolStripBtnOrthoConn.Enabled = true;
				toolStripBtnPan.Enabled = true;
				toolStripCmbMagnify.Enabled = true;
				toolStripCmbFontFamily.Enabled = true;
				toolStripCmbPointSize.Enabled = true;
				toolStripLblSaveAs.Enabled = true;
				bItemSaveAs.Enabled = true;
				if (gms.ActiveManager.CanvasObj.Model != null)
				{
					toolStripBtnSave.Enabled = gms.ActiveManager.CanvasObj.Model.Modified;
					bItemSave.Enabled = gms.ActiveManager.CanvasObj.Model.Modified;
				}
				toolStripBtnSelect.Enabled = true;
				toolStripBtnPolyLine.Enabled = true;
				barItemNavigation.Enabled = true;
				toolStripBtnCurve.Enabled = true;
				toolStripBtnEcllipse.Enabled = true;
				toolStripBtnLine.Enabled = true;
				toolStripBtnFormatPainter.Enabled = true;
				toolStripBtnZoom.Enabled = true;

				toolStripBtnTColor.Enabled = true;
				toolStripBtnConnectors.Enabled = true;
				toolStripBtnDirectedConn.Enabled = true;
				bItemRuler.Enabled = true;
				toolStripBtnVerticalConn.Enabled = true;
				toolStripBtnRightAngleConn.Enabled = true;
				toolStripBtnShowGrid.Enabled = true;
				toolStripBtnSnapToGrid.Enabled = true;
				toolStripBtnItalic.Enabled = true;
				toolStripBtnArcConn.Enabled = true;
				toolStripBtnRectangle.Enabled = true;
				toolStripBtnRRect.Enabled = true;

				toolStripBtnRichText.Enabled = true;
				toolStripBtnBold.Enabled = true;
				toolStripBtnUnderLine.Enabled = true;
				toolStripBtnTLeft.Enabled = true;
				toolStripBtnTRight.Enabled = true;
				toolStripBtnTCenter.Enabled = true;
				if (this.tabControlAdv1.Renderer != null)
				{
					btnMoveRight.Enabled = this.tabControlAdv1.Renderer.CanScrollRight;
					btnMoveLeft.Enabled = this.tabControlAdv1.Renderer.CanScrollLeft;
				}
                toolStripBtnHMarker.Enabled = true;
                toolStripBtnVMarker.Enabled = true;
                toolStripBtnHVMarkerEdit.Enabled = true;

			}
			else
			{

				toolStripBtnBToFront.Enabled = false;
				bItemAlignCenter.Enabled = false;
				bItemAlignRight.Enabled = false;
				bItemAlignLeft.Enabled = false;
				bItemItalic.Enabled = false;
				bItemRichText.Enabled = false;
				bItemText.Enabled = false;
				bItemTextColor.Enabled = false;
				bItemUnderline.Enabled = false;
				bItemBold.Enabled = false;
				this.toolStripBtnAlignLeft.Enabled = false;
				this.toolStripBtnAlignCenter.Enabled = false;
				this.toolStripBtnAlignRight.Enabled = false;
				bItemSave.Enabled = false;
				bItemSaveAs.Enabled = false;
				bItemClose.Enabled = false;
				biPrintZooming.Enabled = false;
				toolStripBtnArcConn.Enabled = false;
				toolStripBtnToForward.Enabled = false;
				toolStripbtnChangeDemsion.Enabled = false;
				toolStripBtnConnectors.Enabled = false;
				toolStripBtnDirectedConn.Enabled = false;
				toolStripBtnFlipHorizontal.Enabled = false;
				toolStripBtnFlipVertical.Enabled = false;
				toolStripBtnGroup.Enabled = false;
				toolStripBtnItalic.Enabled = false;
				toolStripBtnOrthoConn.Enabled = false;
				toolStripBtnPan.Enabled = false;
				toolStripBtnRotate.Enabled = false;
				toolStripBtnLeftRotate.Enabled = false;
				toolStripBtnRightRotate.Enabled = false;
				bItemRuler.Enabled = false;
				toolStripBtnSave.Enabled = false;
				toolStripLblSaveAs.Enabled = false;
				toolStripBtnSendBackwards.Enabled = false;
				toolStripBtnSToBack.Enabled = false;
				toolStripBtnShowGrid.Enabled = false;
				toolStripBtnSnapToGrid.Enabled = false;
				toolStripBtnTColor.Enabled = false;
				toolStripBtnUnGroup.Enabled = false;
				toolStripBtnVerticalConn.Enabled = false;
				toolStripBtnRightAngleConn.Enabled = false;
				toolStripBtnZoom.Enabled = false;
				barItem1.Enabled = false;
				toolStripBtnAlignBottom.Enabled = false;
				toolStripBtnAlignCenter.Enabled = false;
				toolStripBtnAlignMiddle.Enabled = false;
				toolStripBtnAlignRight.Enabled = false;
				toolStripBtnAlignTop.Enabled = false;
				toolStripBtnAlignLeft.Enabled = false;
				toolStripBtnCurve.Enabled = false;
				toolStripBtnEcllipse.Enabled = false;
				toolStripBtnLine.Enabled = false;
				toolStripBtnFormatPainter.Enabled = false;
				barItemNavigation.Enabled = false;
				toolStripBtnNudgeDown.Enabled = false;
				toolStripBtnNudgeLeft.Enabled = false;
				toolStripBtnNudgeRight.Enabled = false;
				toolStripBtnNudgeUp.Enabled = false;
				toolStripBtnPolyLine.Enabled = false;
				toolStripBtnRectangle.Enabled = false;
				toolStripBtnRRect.Enabled = false;
				toolStripBtnSameHeight.Enabled = false;
				toolStripBtnSameSize.Enabled = false;
				toolStripBtnSameWidth.Enabled = false;
				toolStripBtnSelect.Enabled = false;
				toolStripBtnSpaceAcross.Enabled = false;
				toolStripBtnSpaceDown.Enabled = false;
				toolStripCmbMagnify.Enabled = false;
				toolStripCmbFontFamily.Enabled = false;
				toolStripCmbPointSize.Enabled = false;

				toolStripBtnRichText.Enabled = false;
				toolStripBtnBold.Enabled = false;
				toolStripBtnUnderLine.Enabled = false;
				toolStripBtnTLeft.Enabled = false;
				toolStripBtnTRight.Enabled = false;
				toolStripBtnTCenter.Enabled = false;
                toolStripBtnHMarker.Enabled = false;
                toolStripBtnVMarker.Enabled = false;
                toolStripBtnHVMarkerEdit.Enabled = false;
			}
		}

		private void ActivateTools()
		{
			if (gms.ActiveManager != null)
			{

				if (gms.ActiveManager.CanvasObj.Controller.SelectionList.Count != 0)
				{
					if (gms.ActiveManager.CanvasObj.Controller.SelectionList.First.GetType() == typeof(LRRLabel))
					{

						this.toolStripBtnAlignLeft.Enabled = true;
						this.toolStripBtnAlignCenter.Enabled = true;
						this.toolStripBtnAlignRight.Enabled = true;
						toolStripBtnToForward.Enabled = false;
						toolStripBtnBToFront.Enabled = false;
						toolStripBtnFlipHorizontal.Enabled = false;
						toolStripBtnFlipVertical.Enabled = false;
						toolStripBtnGroup.Enabled = false;
						toolStripBtnGroup.Enabled = false;
						toolStripBtnRotate.Enabled = false;
						toolStripBtnLeftRotate.Enabled = false;
						toolStripBtnRightRotate.Enabled = false;
						toolStripBtnSendBackwards.Enabled = false;
						toolStripBtnSToBack.Enabled = false;
						toolStripBtnUnGroup.Enabled = false;
						barItem1.Enabled = true;
						toolStripBtnAlignBottom.Enabled = true;
						toolStripBtnAlignCenter.Enabled = true;
						toolStripBtnAlignMiddle.Enabled = true;
						toolStripBtnAlignRight.Enabled = true;
						toolStripBtnAlignTop.Enabled = true;
						toolStripBtnAlignLeft.Enabled = true;
						toolStripBtnNudgeRight.Enabled = true;
						toolStripBtnNudgeUp.Enabled = true;
						toolStripBtnNudgeLeft.Enabled = true;
						toolStripBtnNudgeDown.Enabled = true;
						toolStripBtnSameHeight.Enabled = false;
						toolStripBtnSameSize.Enabled = false;
						toolStripBtnSameWidth.Enabled = false;
						toolStripBtnSpaceAcross.Enabled = false;
						toolStripBtnSpaceDown.Enabled = false;

					}
					else
					{

						this.toolStripBtnAlignLeft.Enabled = true;
						this.toolStripBtnAlignCenter.Enabled = true;
						this.toolStripBtnAlignRight.Enabled = true;
						toolStripBtnToForward.Enabled = true;
						toolStripBtnBToFront.Enabled = true;
						toolStripBtnFlipHorizontal.Enabled = true;
						toolStripBtnFlipVertical.Enabled = true;
						toolStripBtnGroup.Enabled = true;
						toolStripBtnRotate.Enabled = true;
						toolStripBtnLeftRotate.Enabled = true;
						toolStripBtnRightRotate.Enabled = true;
						toolStripBtnSendBackwards.Enabled = true;
						toolStripBtnSToBack.Enabled = true;
						toolStripBtnUnGroup.Enabled = true;
						barItem1.Enabled = true;
						toolStripBtnAlignBottom.Enabled = true;
						toolStripBtnAlignCenter.Enabled = true;
						toolStripBtnAlignMiddle.Enabled = true;
						toolStripBtnAlignRight.Enabled = true;
						toolStripBtnAlignTop.Enabled = true;
						toolStripBtnAlignLeft.Enabled = true;

						toolStripBtnNudgeRight.Enabled = true;
						toolStripBtnNudgeUp.Enabled = true;
						toolStripBtnNudgeLeft.Enabled = true;
						toolStripBtnNudgeDown.Enabled = true;
						toolStripBtnSameHeight.Enabled = true;
						toolStripBtnSameSize.Enabled = true;
						toolStripBtnSameWidth.Enabled = true;
						toolStripBtnSpaceAcross.Enabled = true;
						toolStripBtnSpaceDown.Enabled = true;
					}
				}
				else
				{
					this.toolStripBtnAlignLeft.Enabled = false;
					this.toolStripBtnAlignCenter.Enabled = false;
					this.toolStripBtnAlignRight.Enabled = false;
					toolStripBtnToForward.Enabled = false;
					toolStripBtnBToFront.Enabled = false;
					toolStripBtnFlipHorizontal.Enabled = false;
					toolStripBtnFlipVertical.Enabled = false;
					toolStripBtnGroup.Enabled = false;
					toolStripBtnRotate.Enabled = false;
					toolStripBtnLeftRotate.Enabled = false;
					toolStripBtnRightRotate.Enabled = false;
					toolStripBtnSendBackwards.Enabled = false;
					toolStripBtnSToBack.Enabled = false;
					toolStripBtnUnGroup.Enabled = false;
					barItem1.Enabled = false;
					toolStripBtnAlignBottom.Enabled = true;
					toolStripBtnAlignCenter.Enabled = true;
					toolStripBtnAlignMiddle.Enabled = true;
					toolStripBtnAlignRight.Enabled = true;
					toolStripBtnAlignTop.Enabled = true;
					toolStripBtnAlignLeft.Enabled = true;
					toolStripBtnNudgeRight.Enabled = false;
					toolStripBtnNudgeUp.Enabled = false;
					toolStripBtnNudgeLeft.Enabled = false;
					toolStripBtnNudgeDown.Enabled = false;
					toolStripBtnRectangle.Enabled = false;
					toolStripBtnRRect.Enabled = false;
					toolStripBtnSameHeight.Enabled = false;
					toolStripBtnSameSize.Enabled = false;
					toolStripBtnSameWidth.Enabled = false;
					toolStripBtnSpaceAcross.Enabled = false;
					toolStripBtnSpaceDown.Enabled = false;
				}
			}
		}

		#endregion

		#region	File Menu


		///	<summary>
		///	Called when	Save file is Clicked 
		///	</summary>
		private void SaveFile()
		{
			Canvas selectedCanvas = gms.ActiveManager.CanvasObj;
			if (!selectedCanvas.HasFileName)
			{
				throw new InvalidOperationException();
			}
			SaveFiles(selectedCanvas.FileName, selectedCanvas.FileDescription, selectedCanvas.FileID);
		}

		private void btnClose_Click(object sender, System.EventArgs e)
		{
			CanvasClosing();
			//_app.LRRUIManagerObj.HidePropertyDetailsDialog();
		}


		private void btnMoveRight_Click(object sender, System.EventArgs e)
		{
			//if(this.tabControlAdv1.SelectedIndex +1	< this.tabControlAdv1.TabCount)
			//    this.tabControlAdv1.SelectedIndex =	this.tabControlAdv1.SelectedIndex +1;

			this.tabControlAdv1.Renderer.Scroll(ScrollIncrement.Tab, ScrollDirection.Right);


		}


		private void btnMoveLeft_Click(object sender, System.EventArgs e)
		{
			//if(this.tabControlAdv1.SelectedIndex !=	-1)
			//    this.tabControlAdv1.SelectedIndex =	this.tabControlAdv1.SelectedIndex -1;
			// this.tabControlAdv1.Renderer. = Color.Red;

			this.tabControlAdv1.Renderer.Scroll(ScrollIncrement.Tab, ScrollDirection.Left);
		}


		private void tabControlAdv1_SelectedIndexChanged(object sender, EventArgs e)
		{
			TabControlAdv tabControl = sender as TabControlAdv;
			if (tabControl.SelectedTab != null)
			{
                DeactivateMarkers();
				gms.SetActiveGraphicsManager(this.tabControlAdv1.SelectedTab.Tag as String);
				Canvas selectedCanvas = gms.ActiveManager.CanvasObj;//tabControl.SelectedTab.Controls[0]as Canvas;
				this.propertyEditor2.Canvas = selectedCanvas;
				this.symbolsList1.Canvas = selectedCanvas;
				UpdateMagnificationComboBox();
				//this.overViewNavigation.Model = selectedCanvas.Model;
              
				//this.overViewNavigation.View = selectedCanvas.View;
                
				this.toolStripBtnShowGrid.Checked = selectedCanvas.View.Grid.Visible;
				this.toolStripBtnSnapToGrid.Checked = selectedCanvas.View.Grid.SnapToGrid;
				//selectedCanvas.View.HorizontalRuler.Visible = bItemRuler.Checked;
				//selectedCanvas.View.VerticalRuler.Visible = bItemRuler.Checked;
                

			}
		}

        public void DeactivateMarkers()
        {
            if (toolStripBtnHMarker.Checked)
            {
                toolStripBtnHMarker.Checked = false;
                this.gms.ActiveManager.CanvasObj.MouseClick -= new MouseEventHandler(HorizontalMarker_MouseClick);    
            }
            if (toolStripBtnVMarker.Checked)
            {
                toolStripBtnVMarker.Checked = false;
                this.gms.ActiveManager.CanvasObj.MouseClick -= new MouseEventHandler(VerticalMarker_MouseClick);    
            }
        }

		private void ImplementerScreen_Closing(object sender, CancelEventArgs e)
		{
			_isFormClosing = true;
			ApplicationPersistanceUtil.SaveCanvas(this);
			for (int i = tabControlAdv1.TabCount; i > 0; i--)
			{
				tabControlAdv1.SelectedIndex = i - 1;
				bool closeWindow = CanvasClosing();
				if (!closeWindow)
				{
					e.Cancel = true;
					return;
				}
				else
				{
					_app.LRRUIManagerObj.HidePropertyDetailsDialog();
					if (gms.GridView != null)
					{
						Symcon.LightRidge.PEAdvisor.IOScreen.IGridFactory iGridFactory = gms.GridView as Symcon.LightRidge.PEAdvisor.IOScreen.IGridFactory;
						if (iGridFactory != null)
						{
							iGridFactory.ClearAllBindings();
							iGridFactory.UnSubscribeReconnectCompleted();
						}
						else
						{
							Symcon.LightRidge.PEAdvisor.GroupProperties.IGroupGridFactory iGrpGridFactory = gms.GridView as Symcon.LightRidge.PEAdvisor.GroupProperties.IGroupGridFactory;
							if (iGridFactory != null)
							{
								iGrpGridFactory.ClearAllBindings();
								iGrpGridFactory.UnSubscribeReconnectCompleted();
							}
						}
					}
					//_app.MainFrame.Activate();
				}
			}
		}

		#endregion

		#region	Enumerator



		#endregion

		#region	ILRRUIContainer	Members

		public new void Refresh()
		{
			if (this.gms.ActiveManager != null)
			{
				this.propertyEditor2.Refresh();
				this.gms.ActiveManager.CanvasObj.Refresh();
			}

		}

		public void Save()
		{
			if (this.gms.ActiveManager != null)
			{
				Canvas selectedCanvas = gms.ActiveManager.CanvasObj;
				if (selectedCanvas != null)
				{
					if (!selectedCanvas.HasFileName)
					{
						fileDialog = new FileDialog(GraphicsManagers.FileDialogMode.SaveAs, GraphicsManagers.UserMode.IMPLEMENTOR);
						if (fileDialog.ShowDialog(this) == DialogResult.OK)
						{
							selectedCanvas.FileName = fileDialog.FileName;
							selectedCanvas.FileDescription = fileDialog.FileDescription;
							selectedCanvas.FileID = fileDialog.FileID;
							//							LRRSearchGroupLevel lrrSearchGrpLvl = new LRRSearchGroupLevel();
							//							lrrSearchGrpLvl.LevelID = fileDialog.FileID;
							//							lrrSearchGrpLvl.Name = fileDialog.FileName;
							//							lrrSearchGrpLvl.Description = fileDialog.FileDescription;
							//							lrrSearchGrpLvl.IsPublished = fileDialog.IsPublished;
							//							lrrSearchGrpLvl.Type = "Graphics";
							//							_app.DBManagerObj.CommitObject(lrrSearchGrpLvl);
							SaveFiles(fileDialog.FileName, fileDialog.FileDescription, fileDialog.FileID);
						}
					}
					else
					{
						this.SaveFile();
					}
				}
			}
		}

		public void CopyMasterProperties()
		{
			// TODO:  Add ImplementerScreen.CopyMasterProperties implementation
		}

		public void Paste()
		{

		}

		public void Copy()
		{


		}

		public void Print()
		{
			if (gms.ActiveManager != null && gms.ActiveManager.CanvasObj != null)
			{
				Canvas activeDiagram = gms.ActiveManager.CanvasObj;
				System.Drawing.Printing.PrintDocument printDoc = activeDiagram.CreatePrintDocument();
				PrintDialog printDlg = new PrintDialog();
				printDlg.Document = printDoc;

				printDlg.AllowSomePages = true;

				if (printDlg.ShowDialog(this) == DialogResult.OK)
				{
					printDoc.PrinterSettings = printDlg.PrinterSettings;
					printDoc.Print();
				}
			}
		}

		public void Delete()
		{
			if (this.gms.ActiveManager != null)
			{
				Canvas selectedCanvas = gms.ActiveManager.CanvasObj;
				//selectedCanvas.Delete();
                selectedCanvas.Controller.Delete();
                
                
			}
		}

		public void ArrangeColumns()
		{
			// TODO:  Add ImplementerScreen.ArrangeColumns implementation
		}

		public void ClearFilter()
		{
			// TODO:  Add ImplementerScreen.ClearFilter	implementation
		}

		public void InsertNewRows()
		{
			// TODO:  Add ImplementerScreen.InsertNewRows implementation
		}

		public void ImportToExcel()
		{
			// TODO:  Add ImplementerScreen.ImportToExcel implementation
		}

		public void Export()
		{
			// TODO:  Add ImplementerScreen.Export implementation
		}

		public void SelectionPaste()
		{
			// TODO:  Add ImplementerScreen.SelectionPaste implementation
		}

		public void RightLevel()
		{
			// TODO:  Add ImplementerScreen.RightLevel implementation
		}

		public void LeftLevel()
		{
			// TODO:  Add ImplementerScreen.LeftLevel implementation
		}

		public void UpLevel()
		{
			// TODO:  Add ImplementerScreen.UpLevel	implementation
		}

		public void DownLevel()
		{
			// TODO:  Add ImplementerScreen.DownLevel implementation
		}

		public bool SupportsMasterPropertiesCopy()
		{
			// TODO:  Add ImplementerScreen.SupportsMasterPropertiesCopy implementation
			return false;
		}

		public bool SupportsCopy()
		{
			// TODO:  Add ImplementerScreen.SupportsCopy implementation
			return true;
		}

		public bool SupportsPaste()
		{
			// TODO:  Add ImplementerScreen.SupportsPaste implementation
			return true;
		}

		public bool SupportsExport()
		{
			// TODO:  Add ImplementerScreen.SupportsExport implementation
			return false;
		}

		public bool SupportsSave()
		{
			// TODO:  Add ImplementerScreen.SupportsSave implementation
			return true;
		}

		public bool SupportsRefresh()
		{
			// TODO:  Add ImplementerScreen.SupportsRefresh	implementation
			return true;
		}

		public bool SupportsDelete()
		{
			// TODO:  Add ImplementerScreen.SupportsDelete implementation
			return true;
		}

		public bool SupportsPrint()
		{
			// TODO:  Add ImplementerScreen.SupportsPrint implementation
			return true;
		}

		public bool SupportsArrangeColumns()
		{
			// TODO:  Add ImplementerScreen.SupportsArrangeColumns implementation
			return false;
		}

		public bool SupportsClearFilter()
		{
			// TODO:  Add ImplementerScreen.SupportsClearFilter	implementation
			return false;
		}

		public bool SupportsInsertNewRows()
		{
			// TODO:  Add ImplementerScreen.SupportsInsertNewRows implementation
			return false;
		}

		public bool SupportsImportToExcel()
		{
			// TODO:  Add ImplementerScreen.SupportsImportToExcel implementation
			return false;
		}

		public bool SupportsSelectionPaste()
		{
			// TODO:  Add ImplementerScreen.SupportsSelectionPaste implementation
			return false;
		}

		public bool SupportsLevel()
		{
			// TODO:  Add ImplementerScreen.SupportsLevel implementation
			return false;
		}

		public TabControl ParentTabControl
		{
			set
			{
				_parentTabControl = value;
			}
			get { return _parentTabControl; }
		}

		public TabPage ParentTabPage
		{
			set
			{
				_parentTabPage = value;
			}
			get
			{
				return _parentTabPage;
			}
		}
		#endregion

		#region	ProcessCMD OverRide	(Commented)
		////////		protected override bool	ProcessCmdKey(ref Message msg, Keys	keyData)
		////////		{
		////////			try
		////////			{
		////////				switch(keyData)
		////////				{
		////////					case Keys.Tab: 
		////////					{
		////////						if(tabControlAdv1 != null && tabControlAdv1.SelectedTab	!= null	&& tabControlAdv1.SelectedTab.Controls[0] != null)
		////////						{
		////////							Canvas activecanvas	=  tabControlAdv1.SelectedTab.Controls[0] as Canvas;
		////////							if(activeCanvas.Controller.SelectionList	!= null)
		////////							{
		////////								if(activeCanvas.Controller.SelectionList.GetType().BaseType == typeof(Symbol))
		////////								{
		////////									Symbol selectedSymbol =	activeCanvas.Controller.SelectionList as	Symbol;
		////////									if(selectedsymbol.GetPropertyContainerByName("ItemType") != null && selectedsymbol.GetPropertyContainerByName("ItemType").ToString().Trim()	!= "")
		////////									{
		////////										foreach(INode node in activecanvas.Model.Nodes.)
		////////										{
		////////											if(node.GetType().BaseType == typeof(Symbol))
		////////											{
		////////												Symbol smbl	= node as Symbol;
		////////												if(smbl.GetPropertyContainerByName("ItemType") !=	null &&	smbl !=	selectedSymbol)
		////////													if(selectedsymbol.GetPropertyContainerByName("ItemType").ToString() == smbl.GetPropertyContainerByName("ItemType").ToString())
		////////													{
		////////														activecanvas.SelectionList.Clear();
		////////														activecanvas.SelectionList.Add(smbl);
		////////														activecanvas.Invalidate();;
		////////														break;
		////////													}
		////////												//MessageBox.Show(smbl.GetPropertyContainerByName("ItemType").ToString());
		////////											}
		////////										}
		////////									}
		////////								}
		////////							}
		////////						}
		////////						break;
		////////					}
		////////				}
		////////			}
		////////			catch(Exception	ex)
		////////			{
		////////				Debug.Assert(false,	ex.Message);
		////////			}
		////////			
		////////			return base.ProcessCmdKey (ref msg,	keyData);
		////////		}

		#endregion

		#region Public Methods
		///	<summary>
		///	To Remove the controls of the Properties Panel 
		///	</summary>
		///	<param name="sender"></param>
		///	<param name="e"></param>

		public TabControlAdv GetTabControl()
		{
			return this.tabControlAdv1;
		}



		#endregion

		#region Printing

		public void PageSetup()
		{
			if (gms.ActiveManager != null && gms.ActiveManager.CanvasObj != null)
			{
				Canvas activeDiagram = gms.ActiveManager.CanvasObj;

				//PageSetupDialog dlg = new PageSetupDialog();
                PrintSetupDialog dlg = new PrintSetupDialog();
				// Made to make values more user friendly 
				activeDiagram.View.ConvertPageMargins(false);
				dlg.PageSettings = activeDiagram.View.PageSettings;

				if (dlg.ShowDialog(this) == DialogResult.OK)
				{
					activeDiagram.View.PageSettings = dlg.PageSettings;
					activeDiagram.View.RefreshPageSettings();
					//activeDiagram.View.Update(true);
                   
				}
				else
				{
					// Need to convert backwards
					activeDiagram.View.ConvertPageMargins(true);
				}
			}
		}



		public void PrintPreview()
		{
			if (gms.ActiveManager != null && gms.ActiveManager.CanvasObj != null)
			{
				Canvas activeDiagram = gms.ActiveManager.CanvasObj;
				System.Drawing.Printing.PrintDocument printDoc = activeDiagram.CreatePrintDocument();
				PrintPreviewDialog printPreviewDlg = new PrintPreviewDialog();

				printDoc.PrinterSettings.FromPage = 0;
				printDoc.PrinterSettings.ToPage = 0;
				printDoc.PrinterSettings.PrintRange = PrintRange.AllPages;

				printPreviewDlg.Document = printDoc;
				printPreviewDlg.ShowDialog(this);
			}
		}

		private void PrintZooming()
		{
			if (gms.ActiveManager != null && gms.ActiveManager.CanvasObj != null)
			{
				Canvas activeDiagram = gms.ActiveManager.CanvasObj;
				PrintZoomingDialog dlg = new PrintZoomingDialog();
               
				float i = (activeDiagram.Controller.View.PrintZoom.PrintingZoom * 100);
                
                
                //float i = (activeDiagram.View.PrintZoom * 100);
				dlg.comboBox1.Text = i.ToString(Symcon.BusinessObjects.SymConverter.Culture) + "%";
				//dlg.SheetsAcross = activeDiagram.Model.PrintData.SheetsAcross.ToString(Symcon.BusinessObjects.SymConverter.Culture);
                dlg.SheetsAcross = activeDiagram.Controller.View.PrintZoom.SheetsAcross.ToString(Symcon.BusinessObjects.SymConverter.Culture);
                dlg.SheetsDown = activeDiagram.Controller.View.PrintZoom.SheetsDown.ToString(Symcon.BusinessObjects.SymConverter.Culture);
				//dlg.SheetsDown = activeDiagram.Model.PrintData.SheetsDown.ToString(Symcon.BusinessObjects.SymConverter.Culture);
				//if (activeDiagram.Model.PrintData.UsePrintingZoom)
                    if(activeDiagram.View.PrintZoom.UsePrintingZoom)
					dlg.radio1.Checked = true;
				else
				{
					dlg.radio2.Checked = true;
				}
				if (dlg.ShowDialog(this) == DialogResult.OK)
				{
					if (dlg.radio1.Checked)
					{
                        //activeDiagram.View.PrintZoom = true;
						//activeDiagram.Model.PrintData.UsePrintingZoom = true;
                        activeDiagram.View.PrintZoom.UsePrintingZoom = true;
                        //activeDiagram.View.PrintZoom.PrintingZoom = float.Parse(Regex.Replace(dlg.comboBox1.Text, "%", ""), Symcon.BusinessObjects.SymConverter.Culture);
						//activeDiagram.Model.PrintData.PrintingZoom = float.Parse(Regex.Replace(dlg.comboBox1.Text, "%", ""), Symcon.BusinessObjects.SymConverter.Culture);
                        activeDiagram.Controller.View.PrintZoom.PrintingZoom = int.Parse(Regex.Replace(dlg.comboBox1.Text, "%", ""), Symcon.BusinessObjects.SymConverter.Culture);
					}
					else
					{
                        activeDiagram.View.PrintZoom.UsePrintingZoom = true;
                        activeDiagram.Controller.View.PrintZoom.SheetsAcross = int.Parse(dlg.SheetsAcross, Symcon.BusinessObjects.SymConverter.Culture);
                        activeDiagram.Controller.View.PrintZoom.SheetsDown= int.Parse(dlg.SheetsDown, Symcon.BusinessObjects.SymConverter.Culture);
						//activeDiagram.Model.PrintData.SheetsAcross = int.Parse(dlg.SheetsAcross, Symcon.BusinessObjects.SymConverter.Culture);
						//activeDiagram.Model.PrintData.SheetsDown = int.Parse(dlg.SheetsDown, Symcon.BusinessObjects.SymConverter.Culture);
					}
				}
			}
		}

		#endregion

		#region ILRRUIContainer Members

		public void ClearSort()
		{
			// TODO:  Add ImplementerScreen.ClearSort implementation
		}


		public bool SupportsClearSort()
		{
			// TODO:  Add ImplementerScreen.SupportsClearSort implementation
			return false;
		}


		public void CopyUOMTypes()
		{

		}


		public bool SupportsCopyUOMTypes()
		{
			return false;
		}


		public void ShowPropertyList()
		{
			// TODO:  Add ImplementerScreen.ShowPropertyList implementation
		}


		public bool SupportsResultsFilter()
		{
			// TODO:  Add ImplementerScreen.SupportsResultsFilter implementation
			return false;
		}


		public void ShowComponentList()
		{
			// TODO:  Add ImplementerScreen.ShowComponentList implementation
		}


		public void LeftColMovement()
		{
			// TODO:  Add ImplementerScreen.LeftColMovement implementation
		}


		public void RightColMovement()
		{
			// TODO:  Add ImplementerScreen.RightColMovement implementation
		}


		public void Undo()
		{
			//this.gms.ActiveManager.CanvasObj.UndoCommand();
            this.gms.ActiveManager.CanvasObj.Model.HistoryManager.Undo();
            
          
            
            
            
            
            
		}


		public bool SupportsPageSetup()
		{
			// TODO:  Add ImplementerScreen.SupportsPageSetup implementation
			return true;
		}


		public bool SupportsUndo()
		{
			// TODO:  Add ImplementerScreen.SupportsUndo implementation
			return true;
		}


		public void OpenCompositeView()
		{
			// TODO:  Add ImplementerScreen.OpenCompositeView implementation
		}


		public void TransposeView()
		{
			// TODO:  Add ImplementerScreen.TransposeView implementation
		}


		public void OpenQuery()
		{
			// TODO:  Add ImplementerScreen.OpenQuery implementation
		}


		public void OpenView()
		{
			// TODO:  Add ImplementerScreen.OpenView implementation
		}


		public bool SupportsOpenCompositeView()
		{
			// TODO:  Add ImplementerScreen.SupportsOpenCompositeView implementation
			return false;
		}


		public bool SupportsTransposeView()
		{
			// TODO:  Add ImplementerScreen.SupportsTransposeView implementation
			return false;
		}


		public bool SupportsOpenQuery()
		{
			// TODO:  Add ImplementerScreen.SupportsOpenQuery implementation
			return false;
		}


		public bool SupportsOpenView()
		{
			// TODO:  Add ImplementerScreen.SupportsOpenView implementation
			return false;
		}


		public bool SupportsCompositeView()
		{
			// TODO:  Add ImplementerScreen.SupportsCompositeView implementation
			return false;
		}


		public bool PerformDirtyChk
		{
			get
			{
				// TODO:  Add ImplementerScreen.PerformDirtyChk getter implementation
				return true;
			}
		}

		#endregion

		#region ILRRUISpecificContainer Members

		public void ChangeUOMSet()
		{
			if (gms.ActiveManager != null)
			{
				ChangeUOMSetDefinitionForm chngUOMSetDefn = new ChangeUOMSetDefinitionForm();
				DialogResult dlgResult = chngUOMSetDefn.ShowDialog(this);
				if (dlgResult == DialogResult.OK && chngUOMSetDefn.MeasSysID != null)
				{
					gms.ChangeUOMSetDefinationForSelectedSymbols(chngUOMSetDefn.MeasSysID);
					//gms.ActiveManager.CanvasObj.Model.UpdateViews();
					if (gms.GridView != null)
					{
						Symcon.LightRidge.PEAdvisor.IOScreen.IGridFactory igridFactory = gms.GridView as Symcon.LightRidge.PEAdvisor.IOScreen.IGridFactory;
						if (igridFactory != null)
							igridFactory.ChangeUOMSet(chngUOMSetDefn.MeasSysID);
						else
						{
							Symcon.LightRidge.PEAdvisor.GroupProperties.IGroupGridFactory igrpGridFactory = gms.GridView as Symcon.LightRidge.PEAdvisor.GroupProperties.IGroupGridFactory;
							if (igrpGridFactory != null)
								igrpGridFactory.ChangeUOMSet(chngUOMSetDefn.MeasSysID);
						}
					}
				}
			}
		}

		public bool SupportsChangeUOMSet()
		{
			return true;
		}

		#endregion

		private void gms_SetCustomFormat(object sender, EventArgs e)
		{
			gms.SetCustomFormatCalled();
		}

		void gms_SetCustomFormatGridCell(object sender, EventArgs e)
		{
			gms.SetCustomFormatGridCellCalled();
			//throw new Exception("The method or operation is not implemented.");
		}

		private void toolStripBtnNew_Click(object sender, EventArgs e)
		{
			gms.CreateGraphicsManager();
			Canvas canvas = gms.ActiveManager.CanvasObj;				// initialize new canvas
			TabPageAdv newtabPage = new TabPageAdv();	//Add New tap Page
			newtabPage.Text = Symcon.Utils.HeaderDispatcher.LRRHeaderText.GetHeaderString("SID_NEW_CANVAS") + canvasCount;				//Give new Tab default Value
			newtabPage.TabBackColor = Color.LightBlue;
			newtabPage.TabForeColor = Color.Black;
			newtabPage.Controls.Add(canvas);			//add canvas to	the	New	tab	Page
			newtabPage.Tag = gms.ActiveManager.ID;
			this.tabControlAdv1.Controls.Add(newtabPage);//Add Tab Page	to the tabmanager

			tabControlAdv1.SelectedTab = newtabPage;	//Set this as selected tab
			propertyEditor2.Canvas = canvas;			//assing canvas	as selected	object to the Propertygrid
			symbolsList1.Canvas = canvas;
			this.tabControlAdv1.Refresh();				//Refresh tab
			canvas.Model.Modified = false;
			//canvas.View.HorizontalRuler.Visible = bItemRuler.Checked;
         
            
            
			//canvas.View.VerticalRuler.Visible = bItemRuler.Checked;
			canvasCount++;
		}

		private void toolStripBtnSave_Click(object sender, EventArgs e)
		{
			if (tabControlAdv1.TabPages.Count > 0)
			{
				Canvas selectedCanvas = gms.ActiveManager.CanvasObj;
				if (selectedCanvas != null)
				{
					if (!selectedCanvas.HasFileName)
					{
						fileDialog = new FileDialog(GraphicsManagers.FileDialogMode.SaveAs, GraphicsManagers.UserMode.IMPLEMENTOR);
						if (fileDialog.ShowDialog(this) == DialogResult.OK)
						{
							selectedCanvas.FileName = fileDialog.FileName;
							selectedCanvas.FileDescription = fileDialog.FileDescription;
							selectedCanvas.FileID = fileDialog.FileID;
							SaveFiles(fileDialog.FileName, fileDialog.FileDescription, fileDialog.FileID);
						}
					}
					else
					{
						this.SaveFile();
					}
				}
			}
		}

		private void toolStripBtnOpen_Click(object sender, EventArgs e)
		{
			if (gms.SelectedModes.Count == 0)
			{
				LRRMessagBox.ShowMessage("SID_SELECT_MODETYPE", "SID_LABEL", MessageBoxButtons.OK, MessageBoxIcon.Error);
				_app.LRRUIManagerObj.ShowModesDialog();
				return;
			}
			fileDialog = new FileDialog(GraphicsManagers.FileDialogMode.Open, GraphicsManagers.UserMode.IMPLEMENTOR);
			if (fileDialog.ShowDialog(this) == DialogResult.OK)
			{
				for (int i = 0; i < fileDialog.SelectedRecords.Count; i++)
				{
					LRRSavedView selectedView = fileDialog.SelectedRecords[i] as LRRSavedView;
					OpenFiles(selectedView.ID);
				}
			}
		}

		private void toolStripLblSaveAs_Click(object sender, EventArgs e)
		{
			if (tabControlAdv1.TabPages.Count > 0)
			{
				Canvas selectedCanvas = gms.ActiveManager.CanvasObj;
				fileDialog = new FileDialog(GraphicsManagers.FileDialogMode.SaveAs, GraphicsManagers.UserMode.IMPLEMENTOR);
				if (selectedCanvas != null)
				{
					if (selectedCanvas.HasFileName)
					{
						fileDialog.FileName = selectedCanvas.FileName;
					}
					if (fileDialog.ShowDialog(this) == DialogResult.OK)
					{
						if (selectedCanvas.FileID != null && gms.OpenedViews.ContainsKey(selectedCanvas.FileID))
							gms.OpenedViews.Remove(selectedCanvas.FileID);
						selectedCanvas.FileName = fileDialog.FileName;
						selectedCanvas.FileDescription = fileDialog.FileDescription;
						selectedCanvas.FileID = fileDialog.FileID;
						SaveFiles(fileDialog.FileName, fileDialog.FileDescription, fileDialog.FileID);
					}
				}
			}
		}

		private void toolStripbtnChangeDemsion_Click(object sender, EventArgs e)
		{
			if (tabControlAdv1.SelectedTab != null)
			{
				Canvas activeCanvas = this.gms.ActiveManager.CanvasObj;

				FrmDimensionsDlg dlg = new FrmDimensionsDlg();
				//dlg.DiagramWidth = activeCanvas.Model.Size;
                
				//dlg.DiagramHeight = activeCanvas.Model.Size;

				if (dlg.ShowDialog(this) == DialogResult.OK)
				{
					//activeCanvas.Model.Width = dlg.DiagramWidth;
					//activeCanvas.Model.Height = dlg.DiagramHeight;
					activeCanvas.Refresh();
				}

			}
		}

		private void toolStripBtnSpaceAcross_Click(object sender, EventArgs e)
		{
			if (gms.ActiveManager != null)
			{
				gms.ActiveManager.CanvasObj.SpaceAcross();
			}
		}

		private void toolStripBtnSpaceDown_Click(object sender, EventArgs e)
		{
			if (gms.ActiveManager != null)
			{
				gms.ActiveManager.CanvasObj.SpaceDown();
			}
		}

		private void toolStripBtnSameWidth_Click(object sender, EventArgs e)
		{
			if (gms.ActiveManager != null)
			{
				gms.ActiveManager.CanvasObj.SameWidth();
			}
		}

		private void toolStripBtnSameHeight_Click(object sender, EventArgs e)
		{
			if (gms.ActiveManager != null)
			{
				gms.ActiveManager.CanvasObj.SameHeight();
			}
		}

		private void toolStripBtnNudgeUp_Click(object sender, EventArgs e)
		{
			if (gms.ActiveManager != null)
			{
				gms.ActiveManager.CanvasObj.NudgeUp();
			}
		}

		private void toolStripBtnNudgeDown_Click(object sender, EventArgs e)
		{
			if (gms.ActiveManager != null)
			{
				gms.ActiveManager.CanvasObj.NudgeDown();
			}
		}

		private void toolStripBtnNudgeLeft_Click(object sender, EventArgs e)
		{
			if (gms.ActiveManager != null)
			{
				gms.ActiveManager.CanvasObj.NudgeLeft();
			}
		}

		private void toolStripBtnNudgeRight_Click(object sender, EventArgs e)
		{
			if (gms.ActiveManager != null)
			{
				gms.ActiveManager.CanvasObj.NudgeRight();
			}
		}

		private void toolStripBtnAlignLeft_Click(object sender, EventArgs e)
		{
			if (gms.ActiveManager != null)
			{
				gms.ActiveManager.CanvasObj.AlignLeft();
			}
		}

		private void toolStripBtnAlignCenter_Click(object sender, EventArgs e)
		{
			if (gms.ActiveManager != null)
			{
				gms.ActiveManager.CanvasObj.AlignCenter();
			}

		}

		private void toolStripBtnAlignRight_Click(object sender, EventArgs e)
		{
			if (gms.ActiveManager != null)
			{
				gms.ActiveManager.CanvasObj.AlignRight();
			}

		}

		private void toolStripBtnAlignTop_Click(object sender, EventArgs e)
		{
			if (gms.ActiveManager != null)
			{
				gms.ActiveManager.CanvasObj.AlignTop();
			}

		}

		private void toolStripBtnAlignMiddle_Click(object sender, EventArgs e)
		{
			if (gms.ActiveManager != null)
			{
				gms.ActiveManager.CanvasObj.AlignMiddle();
			}
		}

		private void toolStripBtnAlignBottom_Click(object sender, EventArgs e)
		{
			if (gms.ActiveManager != null)
			{
				gms.ActiveManager.CanvasObj.AlignBottom();
			}
		}

		private void toolStripBtnBToFront_Click(object sender, EventArgs e)
		{
			if (this.gms.ActiveManager != null)
			{
				this.gms.ActiveManager.CanvasObj.Controller.BringToFront();
			}
		}

		private void toolStripBtnSToBack_Click(object sender, EventArgs e)
		{
			if (this.gms.ActiveManager != null)
			{
				this.gms.ActiveManager.CanvasObj.Controller.SendToBack();
			}
		}

		private void toolStripBtnToForward_Click(object sender, EventArgs e)
		{
			if (this.gms.ActiveManager != null)
			{
				this.gms.ActiveManager.CanvasObj.Controller.BringForward();
			}
		}

		private void toolStripBtnSendBackwards_Click(object sender, EventArgs e)
		{
			if (this.gms.ActiveManager != null)
			{
				this.gms.ActiveManager.CanvasObj.Controller.SendBackward();
			}
		}

		private void toolStripBtnConnectors_Click(object sender, EventArgs e)
		{
			if (gms.ActiveManager != null)
			{
				this.gms.ActiveManager.CanvasObj.Controller.ActivateTool("ConnectorTool");
			}
		}

		private void toolStripBtnOrthoConn_Click(object sender, EventArgs e)
		{
			if (this.gms.ActiveManager != null)
				this.gms.ActiveManager.CanvasObj.Controller.ActivateTool("OrthogonalLinkTool");
		}

		private void toolStripBtnDirectedConn_Click(object sender, EventArgs e)
		{
			if (this.gms.ActiveManager != null)
				this.gms.ActiveManager.CanvasObj.Controller.ActivateTool("DirectedLinkTool");
		}

		private void toolStripBtnVerticalConn_Click(object sender, EventArgs e)
		{
			if (this.gms.ActiveManager != null)
				this.gms.ActiveManager.CanvasObj.ActivateTool("VerticalLink");
		}

		private void toolStripBtnRightAngleConn_Click(object sender, EventArgs e)
		{
			if (this.gms.ActiveManager != null)
				this.gms.ActiveManager.CanvasObj.ActivateTool("RightAngleLink");
		}

		private void toolStripBtnArcConn_Click(object sender, EventArgs e)
		{
			if (this.gms.ActiveManager != null)
				this.gms.ActiveManager.CanvasObj.ActivateTool("ArcLinkTool");
		}

		private void toolStripBtnLeftRotate_Click(object sender, EventArgs e)
		{
			if (this.gms.ActiveManager != null)
			{
				if (this.gms.ActiveManager.CanvasObj.Controller.SelectionList.Count == 1)
					this.gms.ActiveManager.CanvasObj.Rotate(-90);
			}
		}

		private void toolStripBtnRightRotate_Click(object sender, EventArgs e)
		{
			if (this.gms.ActiveManager != null)
			{
				if (this.gms.ActiveManager.CanvasObj.Controller.SelectionList.Count == 1)
					this.gms.ActiveManager.CanvasObj.Rotate(90);
			}
		}

        private void toolStripBtnFlipVertical_Click(object sender, EventArgs e)
		{
			if (this.gms.ActiveManager != null)
			{
				if (this.gms.ActiveManager.CanvasObj.Controller.SelectionList.Count == 1)
					this.gms.ActiveManager.CanvasObj.FlipVertical();
			}
		}

		private void toolStripBtnFlipHorizontal_Click(object sender, EventArgs e)
		{
			if (this.gms.ActiveManager != null)
			{
				if (this.gms.ActiveManager.CanvasObj.Controller.SelectionList.Count == 1)
					this.gms.ActiveManager.CanvasObj.FlipHorizontal();
			}
		}

		private void toolStripBtnShowGrid_Click(object sender, EventArgs e)
		{
			if (this.gms.ActiveManager != null)
			{
				//this.bItemShowGrid.Checked = !this.bItemShowGrid.Checked;
				this.toolStripBtnShowGrid.Checked = !this.toolStripBtnShowGrid.Checked;
				this.gms.ActiveManager.CanvasObj.View.Grid.Visible = this.toolStripBtnShowGrid.Checked;//this.bItemShowGrid.Checked;
			}
		}

		private void toolStripBtnSnapToGrid_Click(object sender, EventArgs e)
		{
			if (this.gms.ActiveManager != null)
			{
				//this.bItemSnapToGrid.Checked = !this.bItemSnapToGrid.Checked;
				this.toolStripBtnSnapToGrid.Checked = !this.toolStripBtnSnapToGrid.Checked;
				this.gms.ActiveManager.CanvasObj.View.Grid.SnapToGrid = this.toolStripBtnSnapToGrid.Checked;//this.bItemSnapToGrid.Checked;
			}
		}

		private void toolStripCmbMagnify_Click(object sender, EventArgs e)
		{
			//if (this.gms.ActiveManager != null)
			//{
			//   if (toolStripCmbMagnify.SelectedItem != null)
			//   {
			//      this.gms.ActiveManager.CanvasObj.Zoom(this.toolStripCmbMagnify.SelectedItem.ToString());
			//   }
			//   else if (toolStripCmbMagnify.Text != null && this.toolStripCmbMagnify.Text != "")
			//   {
			//      this.gms.ActiveManager.CanvasObj.Zoom(this.toolStripCmbMagnify.SelectedText.ToString());
			//   }
			//}
		}

		private void toolStripCmbMagnify_SelectedIndexChanged(object sender, EventArgs e)
		{
			if (this.gms.ActiveManager != null)
				this.gms.ActiveManager.CanvasObj.Zoom(this.toolStripCmbMagnify.SelectedItem.ToString());
		}

		private void toolStripBtnBold_Click(object sender, EventArgs e)
		{
			if (this.gms.ActiveManager != null)
			{
				Canvas activeCanvas = this.gms.ActiveManager.CanvasObj;
				bool newValue = !(activeCanvas.Controller.TextEditor.Bold);
				activeCanvas.Controller.TextEditor.Bold = newValue;
				this.bItemBold.Checked = newValue;
			}
		}

		private void toolStripBtnItalic_Click(object sender, EventArgs e)
		{
			if (this.gms.ActiveManager != null)
			{
				Canvas activeCanvas = this.gms.ActiveManager.CanvasObj;
				bool newValue = !(activeCanvas.Controller.TextEditor.Italic);
				activeCanvas.Controller.TextEditor.Italic = newValue;
				//bItemItalic.Checked = newValue;
				this.toolStripBtnItalic.Checked = newValue;
			}
		}

		private void toolStripBtnUnderLine_Click(object sender, EventArgs e)
		{
			if (this.gms.ActiveManager != null)
			{
				Canvas activeCanvas = this.gms.ActiveManager.CanvasObj;
				bool newValue = !(activeCanvas.Controller.TextEditor.Underline);
				activeCanvas.Controller.TextEditor.Underline = newValue;
				//this.bItemUnderline.Checked = newValue;
				this.toolStripBtnUnderLine.Checked = newValue;
			}
		}

		private void toolStripBtnTLeft_Click(object sender, EventArgs e)
		{
			if (this.gms.ActiveManager != null)
			{
				Canvas activeCanvas = this.gms.ActiveManager.CanvasObj;
				activeCanvas.Controller.TextEditor.HorizontalAlignment = StringAlignment.Near;
				//this.bItemAlignLeft.Checked = true;
				//this.bItemAlignCenter.Checked = false;
				//this.bItemAlignRight.Checked = false;
				this.toolStripBtnTLeft.Checked = true;
				this.toolStripBtnTCenter.Checked = false;
				this.toolStripBtnTRight.Checked = false;
			}
		}

		private void toolStripBtnTCenter_Click(object sender, EventArgs e)
		{
			if (this.gms.ActiveManager != null)
			{
				Canvas activeCanvas = this.gms.ActiveManager.CanvasObj;
				activeCanvas.Controller.TextEditor.HorizontalAlignment = StringAlignment.Center;
				//this.bItemAlignCenter.Checked = true;
				//this.bItemAlignLeft.Checked = false;
				//this.bItemAlignRight.Checked = false;
				this.toolStripBtnTCenter.Checked = true;
				this.toolStripBtnTLeft.Checked = false;
				this.toolStripBtnTRight.Checked = false;
			}
		}

		private void toolStripBtnTRight_Click(object sender, EventArgs e)
		{
			if (this.gms.ActiveManager != null)
			{
				Canvas activeCanvas = this.gms.ActiveManager.CanvasObj;
				activeCanvas.Controller.TextEditor.HorizontalAlignment = StringAlignment.Far;
				//this.bItemAlignRight.Checked = true;
				//this.bItemAlignLeft.Checked = false;
				//this.bItemAlignCenter.Checked = false;
				this.toolStripBtnTRight.Checked = true;
				this.toolStripBtnTLeft.Checked = false;
				this.toolStripBtnTCenter.Checked = false;
			}
		}

		private void toolStripBtnTColor_Click(object sender, EventArgs e)
		{
			if (this.gms.ActiveManager != null)
			{
				Canvas activeCanvas = this.gms.ActiveManager.CanvasObj;
				ColorDialog dlg = new ColorDialog();
				dlg.Color = activeCanvas.Controller.TextEditor.TextColor;
				if (dlg.ShowDialog(this) == DialogResult.OK)
				{
					activeCanvas.Controller.TextEditor.TextColor = dlg.Color;
				}
			}
		}

		private void toolStripBtnSameSize_Click(object sender, EventArgs e)
		{
            if (gms.ActiveManager != null)
            {
                gms.ActiveManager.CanvasObj.SameSize();
            }
            

		}

		private void toolStripBtnFormatPainter_Click(object sender, EventArgs e)
		{
			if (this.gms.ActiveManager != null)
			{

				//this.barItemFormatPainter.Checked = !this.barItemFormatPainter.Checked;
				this.toolStripBtnFormatPainter.Checked = !this.toolStripBtnFormatPainter.Checked;
				if (this.toolStripBtnFormatPainter.Checked)
				{
					sourceSymbol = this.gms.ActiveManager.CanvasObj.Controller.SelectionList.First as Symbol;
					if (sourceSymbol != null)
					{
						Cursor myPaintCursor = new Cursor("paintformater.cur");
						this.gms.ActiveManager.CanvasObj.View.Cursor = myPaintCursor;
						//this.gms.ActiveManager.CanvasObj.View.Cursor = LoadColorCursor();
					}
					else
					{
						LRRMessagBox.ShowMessage("SID_FP_SELECT_SYM");
						toolStripBtnFormatPainter.Checked = false;
					}
				}
				else
				{
					sourceSymbol = null;
					this.gms.ActiveManager.CanvasObj.View.Cursor = Cursors.Default;

				}

			}
		}




        void HorizontalMarker_MouseClick(object sender, MouseEventArgs e)
        {
            float val = e.Location.X + gms.ActiveManager.CanvasObj.View.Origin.X / ((float)gms.ActiveManager.CanvasObj.View.Magnification/ 100) - 6;
            if (!float.IsInfinity(val))
            {
                gms.ActiveManager.CanvasObj.HorizontalAnchorList.Add(val);
            }
            
        }

        void VerticalMarker_MouseClick(object sender, MouseEventArgs e)
        {
            float val = e.Location.Y + gms.ActiveManager.CanvasObj.View.Origin.Y / ((float)gms.ActiveManager.CanvasObj.View.Magnification/ 100) - 6;
            if (!float.IsInfinity(val))
            {
                gms.ActiveManager.CanvasObj.VerticalAnchorList.Add(val);   
            }
            
        }

		private void sortCmbValues(ToolStripComboBox toolStripCmb)
		{
			string selectedVal = toolStripCmb.ComboBox.SelectedItem.ToString();

			ArrayList tempList = new ArrayList();
			for (int i = 0; i < toolStripCmb.Items.Count; i++)
			{
				string val = toolStripCmb.Items[i].ToString();
				string[] temp = val.Split('%');

				tempList.Add(Convert.ToInt32(temp[0]));

			}
			tempList.Sort();
			object[] tempobj = new object[tempList.Count];
			for (int j = 0; j < tempList.Count; j++)
			{
				tempobj.SetValue((tempList[j] + "%"), j);
			}

			toolStripCmb.Items.Clear();
			toolStripCmb.Items.AddRange(tempobj);

			toolStripCmb.ComboBox.SelectedItem = selectedVal;

		}


	}
}